<?php

/* * ********************************************************************
 * Customization Services by ModulesGarden.com
 * Copyright  ModulesGarden, INBS Group Brand, All Rights Reserved 
 * (2014-07-29, 08:01:26)
 * 
 *
 *  CREATED BY MODULESGARDEN       ->        http://modulesgarden.com
 *  CONTACT                        ->       contact@modulesgarden.com
 *
 *
 *
 *
 * This software is furnished under a license and may be used and copied
 * only  in  accordance  with  the  terms  of such  license and with the
 * inclusion of the above copyright notice.  This software  or any other
 * copies thereof may not be provided or otherwise made available to any
 * other person.  No title to and  ownership of the  software is  hereby
 * transferred.
 *
 *
 * ******************************************************************** */

/**
 * @author Maciej Husak <maciej@modulesgarden.com>
 */
use WHMCS\Database\Capsule as DB;
define("CLIENTAREA",true);
require('init.php');

$ca = new WHMCS_ClientArea();
$ca->setPageTitle("Certificate Details");
$ca->initPage();
$ca->requireLogin();

if(isset($_GET['cert']))
{

    require_once(ROOTDIR.DIRECTORY_SEPARATOR.'modules'.DIRECTORY_SEPARATOR.'servers'.DIRECTORY_SEPARATOR.'CERTUM_Certificates'.DIRECTORY_SEPARATOR.'CERTUM_Certificates.php');  
    require_once(ROOTDIR . DIRECTORY_SEPARATOR . 'modules' . DIRECTORY_SEPARATOR . 'servers' . DIRECTORY_SEPARATOR . 'CERTUM_Certificates' . DIRECTORY_SEPARATOR . 'helpers' . DIRECTORY_SEPARATOR . 'Customer.php');
    require_once(ROOTDIR . DIRECTORY_SEPARATOR . 'modules' . DIRECTORY_SEPARATOR . 'servers' . DIRECTORY_SEPARATOR . 'CERTUM_Certificates' . DIRECTORY_SEPARATOR . 'helpers' . DIRECTORY_SEPARATOR . 'Whmcs.php');
    $isWHMCS73OrHigher = MGModule\CERTUM_Certificates\helpers\Whmcs::isWHMCS73OrHigher();   
   
    $ca->assign('lang', CERTUM_Certificates_loadLanguage());
    $r = DB::table('tblsslorders')->where(DB::raw('md5(id)'), '=', $_GET['cert'])->first();
    
    $isAddon = false;
    if(isset($r->addon_id) && !empty($r->addon_id))
    {
        $isAddon = true;
    }
    
    if($r->userid == $_SESSION['uid'])
    {         
        if(isset($_POST['nextstep']) && $_POST['nextstep'] == 1)
        {
            $data = ($isWHMCS73OrHigher) ? (array)json_decode($r->configdata) : unserialize($r->configdata);
           
            DB::table('tblsslorders')
                ->where(DB::raw('md5(id)'), '=', $_GET['cert'])
                ->update(['configdata' => ($isWHMCS73OrHigher) ? json_encode($data) : serialize($data)
            ]);
            
            ob_clean();
            header("Location: configuressl.php?cert=".$_GET['cert'].'&step=3&token='.generate_token('plain'));
            die();
        }
    
        if($isAddon)
        {
            $addonhosting = DB::table('tblhostingaddons')->where('id', $r->addon_id)->first();
            $configAddon = DB::table('tblmodule_configuration')->where('entity_type', 'addon')->where('entity_id', $addonhosting->addonid)->get();
            
            $params = new stdClass();
            
            foreach($configAddon as $v)
            {
                $params->{$v->setting_name} = $v->value;
            }
        }
        else
        {
            $params = DB::table('tblproducts')
                    ->select('tblproducts.*')
                    ->join('tblhosting', 'tblhosting.packageid', '=', 'tblproducts.id')
                    ->where('tblhosting.id', '=', $r->serviceid)->first();
        }
        try {
            $api    = new PartnerAPIService($params->configoption1, $params->configoption2, $params->configoption10 );
            $op     = $api->operationValidateOrderParameters();
            $pid    = explode('|', $_SESSION['certificate_details']['configoption3']);
            $customer = \MGModule\CERTUM_Certificates\helpers\Customer::getCustomerHash($_SESSION['uid']);

            $op
                ->setCSR($_SESSION['certificate_details']['csr'])
                ->setCustomer($customer)
                ->setOrderID(uniqid())
                ->setProductCode($pid[0])
                ->setState($_SESSION['certificate_details']['fields']['StateProvince'])
                //->setLocality($_SESSION['certificate_details']['fields']['StateProvince'])
                ->setUserAgent($_SERVER['HTTP_USER_AGENT']);

            $dataCSR = openssl_csr_get_subject($_SESSION['certificate_details']['csr']);
            if(!isset($dataCSR['C']) || empty($dataCSR['C']))
            {
                $op->setCountry($_SESSION['certificate_details']['fields']['Country']);
            }

            if(
                $pid[0] == '601' || $pid[0] == '741' || $pid[0] == '961' || $pid[0] == '691' ||
                $pid[0] == '791' ||
                $pid[0] == '731' || $pid[0] == '732' || $pid[0] == '733' ||
                $pid[0] == '501' || $pid[0] == '502' || $pid[0] == '511' || $pid[0] == '512' || $pid[0] == '521' || $pid[0] == '522' || $pid[0] == '531' || $pid[0]== '532'
            ) {

                $emailtemp = $_SESSION['certificate_details']['fields']['AdminEmail'];
                if (!empty($_SESSION['certificate_details']['fields']['Email'])) {
                    $emailtemp = $_SESSION['certificate_details']['fields']['Email'];
                }
                $op->setCommonName($_SESSION['certificate_details']['fields']['CommonName']);
                $op->setEmail($emailtemp);
                $op->setOrganization($_SESSION['certificate_details']['fields']['Organization']);
                $op->setState($_SESSION['certificate_details']['fields']['StateProvince']);
                $op->setLocality($_SESSION['certificate_details']['fields']['Locality']);

                if(
                    (isset($_SESSION['certificate_details']['fields']['AdminFirstName']) && !empty($_SESSION['certificate_details']['fields']['AdminFirstName'])) &&
                    (isset($_SESSION['certificate_details']['fields']['AdminLastName']) && !empty($_SESSION['certificate_details']['fields']['AdminLastName'])) &&
                    (isset($_SESSION['certificate_details']['fields']['AdminEmail']) && !empty($_SESSION['certificate_details']['fields']['AdminEmail']))
                )
                {
                    $op
                        ->setRequestorInfoIndividual(
                            $_SESSION['certificate_details']['fields']['AdminFirstName'],
                            $_SESSION['certificate_details']['fields']['AdminLastName'],
                            $_SESSION['certificate_details']['fields']['AdminEmail'],
                            $_SESSION['certificate_details']['fields']['AdminPhone']
                        );
                }

            } else {
                if ($pid[0] == '841' || $pid[0] == '842' || $pid[0] == '843' ||
                    $pid[0] == '831' || $pid[0] == '832' || $pid[0] == '833' ||
                    $pid[0] == '721' || $pid[0] == '722' || $pid[0] == '723' ||
                    $pid[0] == '281' || $pid[0] == '282' || $pid[0] == '283' ||
                    $pid[0] == '316' || $pid[0] == '317' || $pid[0] == '318' ||
                    $pid[0] == '731' || $pid[0] == '732' || $pid[0] == '733' ||
                    $pid[0] == '501' || $pid[0] == '502' || $pid[0] == '511' || $pid[0] == '512' || $pid[0] == '521' || $pid[0] == '522' || $pid[0] == '531' || $pid[0]== '532'
                ) {
                    $emailtemp = $_SESSION['certificate_details']['fields']['AdminEmail'];
                    if (!empty($_SESSION['certificate_details']['fields']['Email'])) {
                        $emailtemp = $_SESSION['certificate_details']['fields']['Email'];
                    }

                    if (
                        $pid[0] == '731' || $pid[0] == '732' || $pid[0] == '733' ||
                        $pid[0] == '501' || $pid[0] == '502' || $pid[0] == '511' || $pid[0] == '512' || $pid[0] == '521' || $pid[0] == '522' || $pid[0] == '531' || $pid[0]== '532'
                    ) {
                        $op
                            ->setRequestorInfoIndividual(
                                $_SESSION['certificate_details']['fields']['AdminFirstName'],
                                $_SESSION['certificate_details']['fields']['AdminLastName'],
                                $emailtemp,
                                $_SESSION['certificate_details']['fields']['AdminPhone']
                            );
                        $op->setEmail($emailtemp);
                    } else {
                        $op
                            ->setRequestorInfoIndividual(
                                $_SESSION['certificate_details']['fields']['AdminFirstName'],
                                $_SESSION['certificate_details']['fields']['AdminLastName'],
                                $emailtemp,
                                $_SESSION['certificate_details']['fields']['AdminPhone']
                            );


                        if ($pid[0] == '281' || $pid[0] == '282' || $pid[0] == '283') {
                            $op->setCommonName($_SESSION['certificate_details']['fields']['CommonName']);
                            $op->setOrganization($_SESSION['certificate_details']['fields']['Organization']);
                            $op->setCountry($_SESSION['certificate_details']['fields']['Country']);
                            $emailtemp = $_SESSION['certificate_details']['fields']['AdminEmail'];
                            if (!empty($_SESSION['certificate_details']['fields']['Email'])) {
                                $emailtemp = $_SESSION['certificate_details']['fields']['Email'];
                            }
                            $op->setEmail($emailtemp);
                            $op->setLocality($_SESSION['certificate_details']['fields']['Locality']);
                            $op->setState($_SESSION['certificate_details']['fields']['StateProvince']);
                        } else {
                            $op->setEmail($_SESSION['certificate_details']['fields']['Email']);
                            $op->setOrganization($_SESSION['certificate_details']['fields']['Organization']);
                            $op->setState($_SESSION['certificate_details']['fields']['StateProvince']);
                            $op->setLocality($_SESSION['certificate_details']['fields']['Locality']);
                        }


                        if ($pid[0] == '316' || $pid[0] == '317' || $pid[0] == '318') {
                            $op->setJoisocn($_SESSION['certificate_details']['fields']['Joisocn']);
                            $op->setBusinessCategory($_SESSION['certificate_details']['fields']['BusinessCategory']);
                            $op->setSerialNumber($_SESSION['certificate_details']['fields']['SerialNumber']);
                        }
                    }
                } else {
                    $op
                        ->setRequestorInfoIndividual(
                            $_SESSION['certificate_details']['fields']['AdminFirstName'],
                            $_SESSION['certificate_details']['fields']['AdminLastName'],
                            $_SESSION['certificate_details']['fields']['AdminEmail'],
                            $_SESSION['certificate_details']['fields']['AdminPhone']
                        );
                }
            }

            if($pid[0] == '511' || $pid[0] == '512' || $pid[0] == '521' || $pid[0] == '522')
            {
                $op->setSurname($_SESSION['certificate_details']['fields']['Surname']);
                $op->setGivenName($_SESSION['certificate_details']['fields']['GivenName']);
            }

            if(!empty($_SESSION['certificate_details']['fields']['AdminName']) && !empty($_SESSION['certificate_details']['fields']['AdminTax']))
                    $op->setOrganizationInfo($_SESSION['certificate_details']['fields']['AdminTax']);



            if ($op->call())
            {
                $p = $op->getParsedCSR();
                $p->businessCategory = '';
                
                if(isset($_SESSION['certificate_details']['fields']['CommonName']) && !empty($_SESSION['certificate_details']['fields']['CommonName']))
                {
                    $p->commonName = $_SESSION['certificate_details']['fields']['CommonName'];
                }
                if(isset($_SESSION['certificate_details']['fields']['Organization']) && !empty($_SESSION['certificate_details']['fields']['Organization']))
                {
                    $p->organization = $_SESSION['certificate_details']['fields']['Organization'];
                }
                if(isset($_SESSION['certificate_details']['fields']['GivenName']) && !empty($_SESSION['certificate_details']['fields']['GivenName']))
                {
                    $p->givenname = $_SESSION['certificate_details']['fields']['GivenName'];
                }
                else
                {
                    $p->givenname = '';
                }
                if(isset($_SESSION['certificate_details']['fields']['Surname']) && !empty($_SESSION['certificate_details']['fields']['Surname']))
                {
                    $p->surname = $_SESSION['certificate_details']['fields']['Surname'];
                }
                else
                {
                    $p->surname = '';
                }
                if(isset($_SESSION['certificate_details']['fields']['Locality']) && !empty($_SESSION['certificate_details']['fields']['Locality']))
                {
                    $p->locality = $_SESSION['certificate_details']['fields']['Locality'];
                }
                if(isset($_SESSION['certificate_details']['fields']['StateProvince']) && !empty($_SESSION['certificate_details']['fields']['StateProvince']))
                {
                    $p->state = $_SESSION['certificate_details']['fields']['StateProvince'];
                }
                if(isset($_SESSION['certificate_details']['fields']['Country']) && !empty($_SESSION['certificate_details']['fields']['Country']))
                {
                    $p->country = $_SESSION['certificate_details']['fields']['Country'];
                }
                if(isset($_SESSION['certificate_details']['fields']['BusinessCategory']) && !empty($_SESSION['certificate_details']['fields']['BusinessCategory']))
                {
                    $p->businessCategory = $_SESSION['certificate_details']['fields']['BusinessCategory'];
                }
                if(isset($_SESSION['certificate_details']['fields']['Street']) && !empty($_SESSION['certificate_details']['fields']['Street']))
                {
                    $p->street = $_SESSION['certificate_details']['fields']['Street'];
                }
                if(isset($_SESSION['certificate_details']['fields']['PostalCode']) && !empty($_SESSION['certificate_details']['fields']['PostalCode']))
                {
                    $p->postalCode = $_SESSION['certificate_details']['fields']['PostalCode'];
                }
                if(isset($_SESSION['certificate_details']['fields']['JoILN']) && !empty($_SESSION['certificate_details']['fields']['JoILN']))
                {
                    $p->joILN = $_SESSION['certificate_details']['fields']['JoILN'];
                }
                if(isset($_SESSION['certificate_details']['fields']['JoISoPN']) && !empty($_SESSION['certificate_details']['fields']['JoISoPN']))
                {
                    $p->joISoPN = $_SESSION['certificate_details']['fields']['JoISoPN'];
                }
                if(isset($_SESSION['certificate_details']['fields']['Email']) && !empty($_SESSION['certificate_details']['fields']['Email']))
                {
                    $p->email = $_SESSION['certificate_details']['fields']['Email'];
                }
                else
                {
                    $p->email = '';
                }



                $ca->assign('cert', $p);
                $ca->assign('pid', $pid[0]);
            }            
            else 
            {
                $p      = $op->getParsedCSR();
                $error  = $op->getErrorTexts();
                $ca->assign('error', $error[0]['text']);
            }
        } catch (Exception $e) {
            $ca->assign('error', $e->getMessage());
        }

    }
}

$ca->setTemplate('configurecertificate');

$ca->output();
