<?php

use WHMCS\Database\Capsule as DB;

define("CLIENTAREA", true);
require('init.php');

$ca = new WHMCS_ClientArea();
$ca->setPageTitle("Configure SSL Certificate");
$ca->initPage();
$ca->requireLogin();


if (isset($_GET['cert'])) {
    unset($_SESSION['domains']);
    
    require_once(ROOTDIR . DIRECTORY_SEPARATOR . 'modules' . DIRECTORY_SEPARATOR . 'servers' . DIRECTORY_SEPARATOR . 'CERTUM_Certificates' . DIRECTORY_SEPARATOR . 'helpers' . DIRECTORY_SEPARATOR . 'Whmcs.php');
    $isWHMCS73OrHigher = MGModule\CERTUM_Certificates\helpers\Whmcs::isWHMCS73OrHigher();    
   
    $r = DB::table('tblsslorders')->where(DB::raw('md5(id)'), '=', $_GET['cert'])->first();
    
    $isAddon = false;
    if(isset($r->addon_id) && !empty($r->addon_id))
    {
        $isAddon = true;
    }
    
    require_once(ROOTDIR . DIRECTORY_SEPARATOR . 'modules' . DIRECTORY_SEPARATOR . 'servers' . DIRECTORY_SEPARATOR . 'CERTUM_Certificates' . DIRECTORY_SEPARATOR . 'CERTUM_Certificates.php');
    
    $step = isset($_GET['step']) && $_GET['step'] == '2' ? '2' : '1';
    
    if ($r->userid == $_SESSION['uid']) {
        
        if (isset($_POST['domain']) && isset($_POST['method'])) {

            $lang = CERTUM_Certificates_loadLanguage();
            
            $wwwdomains = array();
            
            foreach($_POST['withwww'] as $withwww_key => $withwww)
            {
                $wwwdomains[] = $_POST['domain'][$withwww_key];
            }
            
            $sanlist = $_POST['domain'];
            
            $_SESSION['san_list'] = $sanlist;
            $_SESSION['www_domain'] = $wwwdomains;
            
            $_SESSION['approvermethod'] = $_POST['method'];
            $_SESSION['approveremailprefix'] = $_POST['emailprefix'];
            $_SESSION['approveremailaddress'] = $_POST['emailaddress'];
            $_SESSION['approvenotification'] = $_POST['approvenotification'];
            
            
            
            foreach ($_POST['domain'] as $key => $val) {
                if (!empty($val) && !empty($_POST['method'][$key]))
                    $_SESSION['domains'][] = array('domain' => str_replace(array('http://', 'https://'), '', $val), 'method' => $_POST['method'][$key], 'email' => $_POST['emails'][$key], 'www' => $_POST['withwww'][$key], 'addsan' => $_POST['addsan'][$key]);
            }
            
            if($_POST['method'] != 'ADMIN' && empty($_POST['emailaddress']))
            {
                $ca->assign('error', $lang['enter_email_address']);
            }
            else {
                if (count($_SESSION['domains']) > 0) {
                    $data = ($isWHMCS73OrHigher) ? (array)json_decode($r->configdata) : unserialize($r->configdata); 
                    $data['approveremail'] = empty($_POST['email'][1]) ? 'admin@' . $_POST['domain'][1] : $_POST['emails'][1];
                    DB::table('tblsslorders')
                            ->where(DB::raw('md5(id)'), '=', $_GET['cert'])
                            ->update([
                                'configdata' => ($isWHMCS73OrHigher) ? json_encode($data) : serialize($data)
                    ]);


                    if($isAddon)
                    {
                        $info = DB::table('certum_approvers')->where('addonid', '=', $r->addon_id)->count();
                        if ($info == 0) {
                            DB::table('certum_approvers')->insert([
                            'addonid' => $r->addon_id,
                            'data' => serialize(array(
                                    'approvermethod' => $_SESSION['approvermethod'],
                                    'approveremailprefix' => $_SESSION['approveremailprefix'],
                                    'approveremailaddress' => $_SESSION['approveremailaddress'],
                                    'approvenotification' => $_SESSION['approvenotification'],
                                ))
                            ]);
                        } else {
                            DB::table('certum_approvers')
                                    ->where('addonid', '=', $r->addon_id)
                                    ->update([
                                            'data' => serialize(array(
                                    'approvermethod' => $_SESSION['approvermethod'],
                                    'approveremailprefix' => $_SESSION['approveremailprefix'],
                                    'approveremailaddress' => $_SESSION['approveremailaddress'],
                                    'approvenotification' => $_SESSION['approvenotification'],
                                ))
                                     ]);
                        }
                    }
                    else
                    {
                        $info = DB::table('certum_approvers')->where('serviceid', '=', $r->serviceid)->count();
                        if ($info == 0) {
                            DB::table('certum_approvers')->insert([
                            'serviceid' => $r->serviceid,
                            'data' => serialize(array(
                                    'approvermethod' => $_SESSION['approvermethod'],
                                    'approveremailprefix' => $_SESSION['approveremailprefix'],
                                    'approveremailaddress' => $_SESSION['approveremailaddress'],
                                    'approvenotification' => $_SESSION['approvenotification'],
                                ))
                            ]);
                        } else {
                            DB::table('certum_approvers')
                                    ->where('serviceid', '=', $r->serviceid)
                                    ->update([
                                            'data' => serialize(array(
                                    'approvermethod' => $_SESSION['approvermethod'],
                                    'approveremailprefix' => $_SESSION['approveremailprefix'],
                                    'approveremailaddress' => $_SESSION['approveremailaddress'],
                                    'approvenotification' => $_SESSION['approvenotification'],
                                ))
                                     ]);
                        }
                    }
                    ob_clean();
                    header("Location: configuressl.php?cert=" . $_GET['cert'] . '&step=3&token=' . generate_token('plain'));
                    die();
                }
            }
        }

        $ca->assign('allow_configure', 1);

        if($isAddon)
        {
            $addonhosting = DB::table('tblhostingaddons')->where('id', $r->addon_id)->first();
            $configAddon = DB::table('tblmodule_configuration')->where('entity_type', 'addon')->where('entity_id', $addonhosting->addonid)->get();
            
            $params = new stdClass();
            
            foreach($configAddon as $v)
            {
                $params->{$v->setting_name} = $v->value;
            }
        }
        else
        {
            $params = DB::table('tblproducts')
                    ->select('tblproducts.*')
                    ->join('tblhosting', 'tblhosting.packageid', '=', 'tblproducts.id')
                    ->where('tblhosting.id', '=', $r->serviceid)->first();
        }
        
        $ca->assign('domains_limit', empty($params->configoption5) ? 1 : (empty($params->configoption6) ? 10 : $params->configoption6));
  
        $productconfig = DB::table('tblproductconfiglinks')->where('pid', $params->id)->first();

        $productoptionname = DB::table('tblproductconfigoptions')
                ->where('gid', $productconfig->gid)
                ->where('optionname', 'like', '%additional_domains%')
                ->where('optiontype', '4')
                ->first();


        $productoptionsub = DB::table('tblproductconfigoptionssub')
                ->where('configid', $productoptionname->id)
                ->where('optionname', 'like', '%additional_domains%')
                ->first();

        $configurableoptionvalue = DB::table('tblhostingconfigoptions')
                ->where('relid', $r->serviceid)
                ->where('configid', $productoptionsub->configid)
                ->where('optionid', $productoptionsub->id)
                ->first();
            
     
        if(isset($configurableoptionvalue->qty) && !empty($configurableoptionvalue->qty))
        {
            $ca->assign('domains_limit', $configurableoptionvalue->qty);
        }
        
        
        $ca->assign('allow_add', $params->configoption7);
        $ca->assign('cert_details', $_SESSION['certificate_details']);

        $pid[0] = $params->id;

        $email = '<option>ADMIN</option>';
        $file = '<option>FILE</option>';
        $dns = '<option>DNS_TXT</option><option>DNS_CNAME</option><option>DNS_TXT_PREFIX</option><option>DNS_CNAME_PREFIX</option>';
       
        $fields = null;
        $pid = explode('|', $params->configoption3);
        

        if($step == '2')
        {
            $wwwdomains = array();
            
            foreach($_GET['withwww'] as $withwww_key => $withwww)
            {
                $wwwdomains[] = $_GET['domain'][$withwww_key];
            }
            
            $sanlist = $_GET['domain'];
            
            $_SESSION['san_list'] = $sanlist;
            $_SESSION['www_domain'] = $wwwdomains;
            
            $approverslist = array();

            foreach($sanlist as $sandomain)
            {
                $approverslist[] = $sandomain;
            }
                   
            $ca->assign('approverslist', $approverslist);
            $ca->assign('sandomains', $sanlist);
            $ca->assign('wwwdomains', $wwwdomains);

        }
        
        if (in_array($pid[0], array_keys(CERTUM_Certificates_Commercial()))) {
            $fields = $email . $file . $dns;
        }
        
        if (in_array($pid[0], array_keys(CERTUM_Certificates_Trusted()))) {
            $fields = $email . $file . $dns;
        }

        if (in_array($pid[0], array_keys(CERTUM_Certificates_PremiumEVSSL()))) {
            $fields = $email . $file . $dns;
        }

        if (in_array($pid[0], array_keys(CERTUM_Certificates_IDCerts()))) {
            $fields = $email;
        }

        if (in_array($pid[0], array_keys(CERTUM_Certificates_CodeSigning()))) {
            $fields = $email;
        }
        
        $data = openssl_csr_get_subject($_SESSION['certificate_details']['csr']);
        $domain = $data['CN'];
        
        if(isset($_SESSION['certificate_details']['fields']['CommonName']) && !empty($_SESSION['certificate_details']['fields']['CommonName']))
        {
            $domain = $_SESSION['certificate_details']['fields']['CommonName'];
        }

        $lang = CERTUM_Certificates_loadLanguage();

        $otherDomains = array();
        $list = [];
        $ca->assign('approve_method', $fields);
        $ca->assign('approve_emails', $list);
        $ca->assign('validation', $params->configoption8);
        $ca->assign('lang', $lang);
        $ca->assign('otherdomains', $otherDomains);
        
        $ca->assign('isAddon', $isAddon);
        
        if($isAddon)
        {
        
            $ca->assign('addonid', $r->addon_id);
        
        }
        else
        {
            $ca->assign('serviceid', $r->serviceid);
        }
        
        if(is_array($domain))
        {
            $domain = reset($domain);
        }

        if (substr($domain, 0, 4) == 'www.') {
            $ca->assign('withwww', 1);
            $domain = substr($domain, 4);
        }

        $ca->assign('step', $step);
        $ca->assign('domain', $domain);
        $ca->assign('pid', $pid[0]);
   
        $cert = new \stdClass();
        $cert->commonName = isset($_SESSION['certificate_details']['fields']['CommonName']) ? $_SESSION['certificate_details']['fields']['CommonName'] : '';
        $cert->organization = isset($_SESSION['certificate_details']['fields']['Organization']) ? $_SESSION['certificate_details']['fields']['Organization'] : '';
        $cert->locality = isset($_SESSION['certificate_details']['fields']['Locality']) ? $_SESSION['certificate_details']['fields']['Locality'] : '';
        $cert->state = isset($_SESSION['certificate_details']['fields']['StateProvince']) ? $_SESSION['certificate_details']['fields']['StateProvince'] : '';
        $cert->country = isset($_SESSION['certificate_details']['fields']['Country']) ? $_SESSION['certificate_details']['fields']['Country'] : '';
        $cert->serialNumber = isset($_SESSION['certificate_details']['fields']['SerialNumber']) ? $_SESSION['certificate_details']['fields']['SerialNumber'] : '';
        $cert->businessCategory = isset($_SESSION['certificate_details']['fields']['BusinessCategory']) ? $_SESSION['certificate_details']['fields']['BusinessCategory'] : '';
        $cert->street = isset($_SESSION['certificate_details']['fields']['Street']) ? $_SESSION['certificate_details']['fields']['Street'] : '';
        $cert->postalCode = isset($_SESSION['certificate_details']['fields']['PostalCode']) ? $_SESSION['certificate_details']['fields']['PostalCode'] : '';
        $cert->joILN = isset($_SESSION['certificate_details']['fields']['JoILN']) ? $_SESSION['certificate_details']['fields']['JoILN'] : '';
        $cert->joISoPN = isset($_SESSION['certificate_details']['fields']['JoISoPN']) ? $_SESSION['certificate_details']['fields']['JoISoPN'] : '';
        $cert->joISoCN = isset($_SESSION['certificate_details']['fields']['Joisocn']) ? $_SESSION['certificate_details']['fields']['Joisocn'] : '';
        $cert->email = isset($_SESSION['certificate_details']['fields']['Email']) ? $_SESSION['certificate_details']['fields']['Email'] : '';
        
        if(empty($cert->commonName))
        {
            $cert->commonName = $data['CN'];
        }
        if(empty($cert->email))
        {
            $cert->email = $data['emailAddress'];
        }
        
        $ca->assign('cert', $cert);
       
        $ca->assign('wildcard', $params->configoption9);
    }
}

$ca->setTemplate('configuressl2');

$ca->output();
