<?php

/* * ********************************************************************
 * Customization Services by ModulesGarden.com
 * Copyright  ModulesGarden, INBS Group Brand, All Rights Reserved
 * (2014-05-06, 12:06:50)
 *
 *
 *  CREATED BY MODULESGARDEN       ->        http://modulesgarden.com
 *  CONTACT                        ->       contact@modulesgarden.com
 *
 *
 *
 *
 * This software is furnished under a license and may be used and copied
 * only  in  accordance  with  the  terms  of such  license and with the
 * inclusion of the above copyright notice.  This software  or any other
 * copies thereof may not be provided or otherwise made available to any
 * other person.  No title to and  ownership of the  software is  hereby
 * transferred.
 *
 *
 * ******************************************************************** */

/**
 * @author Maciej Husak <maciej@modulesgarden.com>
 */
// debug mode
use WHMCS\Database\Capsule as DB;
use MGModule\CERTUM_Certificates\helpers\SslService;
use MGModule\CERTUM_Certificates\helpers\Product;
use MGModule\CERTUM_Certificates\helpers\Domain;
use MGModule\CERTUM_Certificates\helpers\Template;
use MGModule\CERTUM_Certificates\helpers\View;
use MGModule\CERTUM_Certificates\helpers\CertificateConfiguration;

if (isset($_GET['_debug']) && $_GET['_debug'] == 'turnon') {
    error_reporting(E_ALL);
    ini_set('display_errors', 1);
}

if (!defined('DS'))
    define('DS', DIRECTORY_SEPARATOR);

require_once 'certumPartnerAPI/service.php';
require_once 'helpers/Whmcs.php';
require_once 'helpers/Customer.php';
require_once 'helpers/SslService.php';
require_once 'helpers/Product.php';
require_once 'helpers/Domain.php';
require_once 'helpers/Template.php';
require_once 'helpers/View.php';
require_once 'helpers/CertificateConfiguration.php';

if (!defined('IS_WHMCS_73_OR_HIGHER'))
    define('IS_WHMCS_73_OR_HIGHER', MGModule\CERTUM_Certificates\helpers\Whmcs::isWHMCS73OrHigher());

function CERTUM_Certificates_ProductsRenew() {
    return array(
        //SSL Certificates
        601 => 606,
        741 => 746,
        961 => 966,
        631 => 636,
        681 => 686,
        971 => 976,
        691 => null,
        //Premium EV Certificates
        641 => 646,
        981 => 986,
        //Code Signing Certificates
        316 => 321,
        317 => 322,
        318 => 323,
        831 => 836,
        832 => 837,
        833 => 838,
        281 => 286,
        282 => 287,
        283 => 288,
        // S/MIME
        501 => 506,
        502 => 507,
        511 => 516,
        512 => 517,
        521 => 526,
        522 => 527,
        531 => 536,
        532 => 537
    );
}

function CERTUM_Certificates_IDCerts() {
    return array(
        //ID Certificates
    );
}

function CERTUM_Certificates_Commercial() {
    return array(
        //SSL Certificates
        601 => 'Commercial SSL (1 Year) Issue',
        741 => 'Commercial WildCard SSL (1 Year) Issue',
        961 => 'Commercial MultiDomain WildCard SSL (300 domains) (1 Year) Issue'
    );
}

function CERTUM_Certificates_Trusted() {
    return array(
        631 => 'Trusted SSL (1 Year) Issue',
        681 => 'Trusted WildCard SSL (1 Year) Issue',
        971 => 'Trusted MultiDomain WildCard SSL (300 domains) (1 Year) Issue'
    );
}

function CERTUM_Certificates_PremiumEVSSL() {
    return array(
        //Premium EV Certificates
        641 => 'Premium EV SSL (1 Year) Issue',
        981 => 'Premium EV MultiDomain SSL (1 Year) Issue (300 Domains)'
    );
}

function CERTUM_Certificates_CodeSigning() {
    return array(
        //Code Signing Certificates
        281 => 'Document Signing SimplySign (1 Year) Issue',
        282 => 'Document Signing SimplySign (2 Years) Issue',
        283 => 'Document Signing SimplySign (3 Years) Issue',
        316 => 'EV Code Signing SimplySign (1 Year) Issue',
        317 => 'EV Code Signing SimplySign (2 Years) Issue',
        318 => 'EV Code Signing SimplySign (3 Years) Issue',
        831 => 'Standard Code Signing SimplySign (1 Year) Issue',
        832 => 'Standard Code Signing SimplySign (2 Year) Issue',
        833 => 'Standard Code Signing SimplySign (3 Year) Issue',
    );
}

function CERTUM_Certificates_SMime() {
    return array(
        // S/MIME Certificates
        501 => 'S/MIME Mailbox (1 Year) Issue',
        502 => 'S/MIME Mailbox (2 Years) Issue',
        511 => 'S/MIME Individual (1 Year) Issue',
        512 => 'S/MIME Individual (2 Years) Issue',
        521 => 'S/MIME Sponsor (1 Year) Issue',
        522 => 'S/MIME Sponsor (2 Years) Issue',
        531 => 'S/MIME Organization (1 Year) Issue',
        532 => 'S/MIME Organization (2 Years) Issue'
    );
}

function CERTUM_Certificates_Products() {
    return CERTUM_Certificates_IDCerts() + CERTUM_Certificates_PremiumEVSSL() + CERTUM_Certificates_Trusted() + CERTUM_Certificates_CodeSigning() + CERTUM_Certificates_Commercial()+CERTUM_Certificates_SMime();
}

function CERTUM_Certificates_ProductsAvailable() {
    $products = CERTUM_Certificates_IDCerts() + CERTUM_Certificates_PremiumEVSSL() + CERTUM_Certificates_Trusted() + CERTUM_Certificates_CodeSigning() + CERTUM_Certificates_Commercial()+CERTUM_Certificates_SMime();
    $renew = CERTUM_Certificates_ProductsRenew();

    foreach($renew as $renewID)
    {
        if(!empty($renewID))
        {
            $products[$renewID] = 'Renew Product';
        }
    }

    return $products;
}

function CERTUM_Certificates_ConfigOptions() {
    
    $_LANG = CERTUM_Certificates_loadLanguage();
    
    if($_POST['action'] == 'save')
    {
        $configarray = array(
            "User"              => array(
                "Type"         => "text",
                "Size"         => "25",
                "FriendlyName" => CERTUM_Certificates_translate("Username"),
                "Description"  => '',
                "Default"      => "",
            ),
            "Pass"              => array(
                "Type"         => "password",
                "Size"         => "25",
                "FriendlyName" => CERTUM_Certificates_translate("Password"),
                "Description"  => "",
                "Default"      => "",
            ),
            "Product"           => array(
                "Type"         => "dropdown",
                "Size"         => "25",
                "Options"      => '',
                "FriendlyName" => CERTUM_Certificates_translate("Product"),
                "Description"  => "",
                "Default"      => "",
            ),
            "ApproveMethod"     => array(
                "Type"         => "dropdown",
                "Size"         => 25,
                "Options"      => "ADMIN,FILE,DNS_TXT,DNS_CNAME,DNS_TXT_PREFIX,DNS_CNAME_PREFIX", # META removed
                "FriendlyName" => CERTUM_Certificates_translate("Approve Method"),
                "Description"  => "",
                "Default"      => ""
            ),
            "AdditionalDomains" => array(
                "Type"         => "yesno",
                "Size"         => "5",
                "FriendlyName" => CERTUM_Certificates_translate("Additional Domains"),
            ),
            "DomainsLimit"      => array(
                "Type"         => "text",
                "Size"         => "25",
                "FriendlyName" => CERTUM_Certificates_translate("Domains Limit")
            ),
            "AllowAdd"          => array(
                "FriendlyName" => CERTUM_Certificates_translate("Allow To Add More Domains"),
                "Type"         => "yesno",
                "Size"         => "5"
            ),
            "Validation"        => array(
                "Type"         => "dropdown",
                "Size"         => "25",
                "Options"      => "Basic,Extended",
                "FriendlyName" => CERTUM_Certificates_translate("Validation Type"),
                "Description"  => "",
            ),
            "WildCard"          => array(
                "Type"         => "yesno",
                "Size"         => "5",
                "FriendlyName" => CERTUM_Certificates_translate("WildCard")
            ),
            "TestMode"          => array(
                "Type"         => "dropdown",
                "Size"         => "5",
                "FriendlyName" => CERTUM_Certificates_translate("Mode"),
                "Options"      => array('testmode' => 'Test mode - gs.test', 'oldtestmode' => 'Test mode - old', 'production' => 'Production mode')
            ),
            "Language"          => array(
                "Type"         => "dropdown",
                "Size"         => "25",
                "Options"      => "pl,en,ru",
                "FriendlyName" => CERTUM_Certificates_translate("Language"),
                "Description"  => ''
            ),
            "ProductName"       => array(
                "Type"          => "yesno",
                "Size"          => "5",
                "FriendlyName"  => CERTUM_Certificates_translate("DisplayProductName"),
            ),
            "DueDate"       => array(
                "Type"          => "yesno",
                "Size"          => "5",
                "FriendlyName"  => CERTUM_Certificates_translate("SetDueDate"),
            ),
            "RenewCA"       => array(
                "Type"          => "yesno",
                "Size"          => "5",
                "FriendlyName"  => CERTUM_Certificates_translate("RenewCA"),
            ),

        );

        return $configarray;
        
      
    }



    if (!DB::schema()->hasTable('certum_renewals')) {
        DB::schema()->create('certum_renewals', function($table) {
            $table->integer('serviceid')->unique()->unsigned()->nullable();
            $table->integer('addonid')->unique()->unsigned()->nullable();
            $table->char('serial', 255);
            $table->text('pem');
            $table->text('csr');
        });
    }

    $isColExist = DB::schema()->hasColumn('certum_renewals','addonid');
    if(!$isColExist)
    {
        DB::schema()->table('certum_renewals', function ($table) {
            $table->integer('addonid')->unique()->unsigned()->nullable();
        });
        full_query('ALTER TABLE `certum_renewals` CHANGE `serviceid` `serviceid` INT(10) UNSIGNED NULL;');
    }
    else
    {
        full_query('ALTER TABLE `certum_renewals` CHANGE `serviceid` `serviceid` INT(10) UNSIGNED NULL;');
        full_query('ALTER TABLE `certum_renewals` CHANGE `addonid` `addonid` INT(10) UNSIGNED NULL;');
    }

    if (!DB::schema()->hasTable('certum_approvers')) {
        DB::schema()->create('certum_approvers', function($table2) {
            $table2->integer('serviceid')->unique()->unsigned()->nullable();
            $table2->integer('addonid')->unique()->unsigned()->nullable();
            $table2->text('data');
        });
    }

    $isColExist = DB::schema()->hasColumn('certum_approvers','addonid');
    if(!$isColExist)
    {
        DB::schema()->table('certum_approvers', function ($table) {
            $table->integer('addonid')->unique()->unsigned()->nullable();
            full_query('ALTER TABLE `certum_approvers` CHANGE `serviceid` `serviceid` INT(10) UNSIGNED NULL;');
        });
    }
    else
    {
        full_query('ALTER TABLE `certum_approvers` CHANGE `serviceid` `serviceid` INT(10) UNSIGNED NULL;');
        full_query('ALTER TABLE `certum_approvers` CHANGE `addonid` `addonid` INT(10) UNSIGNED NULL;');
    }



    //EMAIL FOR NEW CERTS
    $row = DB::table('tblemailtemplates')
            ->where('name', '=', 'CERTUM Certificates - SSL Certificate Configuration Required')
            ->count();
    if ($row == 0) {
        DB::table('tblemailtemplates')
                ->insert([
                    'type'       => "product",
                    'name'       => "CERTUM Certificates - SSL Certificate Configuration Required",
                    'subject'    => "SSL Certificate Configuration Required",
                    'message'    => "<p>Dear {\$client_name},</p><p>Thank you for your order for an SSL Certificate. Before you can use your certificate, it requires configuration which can be done at the URL below.</p><p>{\$ssl_configuration_link}</p><p>Instructions are provided throughout the process but if you experience any problems or have any questions, please open a ticket for assistance.</p><p>{\$signature}</p>",
                    'created_at' => date('Y-m-d H:i:s'),
                    'updated_at' => date('Y-m-d H:i:s'),
        ]);
    }


    $row = DB::table('tblemailtemplates')
            ->where('name', '=', 'CERTUM Certificates - ID Certificate Configuration Required')
            ->count();
    if ($row == 0) {
        DB::table('tblemailtemplates')
                ->insert([
                    'type'       => "product",
                    'name'       => "CERTUM Certificates - ID Certificate Configuration Required",
                    'subject'    => "SSL Certificate Configuration Required",
                    'message'    => "<p>Dear {\$client_name},</p><p>Thank you for your order for an ID Certificate. Before you can use your certificate, it requires configuration which can be done at the URL below.</p><p>{\$ssl_configuration_link}</p><p>Instructions are provided throughout the process but if you experience any problems or have any questions, please open a ticket for assistance.</p><p>{\$signature}</p>",
                    'created_at' => date('Y-m-d H:i:s'),
                    'updated_at' => date('Y-m-d H:i:s'),
        ]);
    }

    $row = DB::table('tblemailtemplates')
            ->where('name', '=', 'CERTUM Certificates - Code Signing Certificate Configuration Required')
            ->count();
    if ($row == 0) {
        DB::table('tblemailtemplates')
                ->insert([
                    'type'       => "product",
                    'name'       => "CERTUM Certificates - Code Signing Certificate Configuration Required",
                    'subject'    => "Code Signing Certificate Configuration Required",
                    'message'    => "<p>Dear {\$client_name},</p><p>Thank you for your order for an Code Signing Certificate. Before you can use your certificate, it requires configuration which can be done at the URL below.</p><p>{\$ssl_configuration_link}</p><p>Instructions are provided throughout the process but if you experience any problems or have any questions, please open a ticket for assistance.</p><p>{\$signature}</p>",
                    'created_at' => date('Y-m-d H:i:s'),
                    'updated_at' => date('Y-m-d H:i:s'),
        ]);
    }

    $products = null;
    $params = DB::table('tblproducts')->where('id', '=', (int) $_POST['id'])->first();

    if (strpos($_SERVER['SCRIPT_NAME'], 'configaddons.php') !== false) {

        $addonConfig = DB::table('tblmodule_configuration')->where('entity_type', 'addon')->where('entity_id', '=', (int) $_POST['id'])->get();
        $params = new stdClass();
        foreach($addonConfig as $v)
        {
            $params->{$v->setting_name} = $v->value;
        }

    }

    $configarray = array();

    $errorScript = '';

    if (empty($params->configoption1) || empty($params->configoption2)) {
        $errorScript = "<script type='text/javascript'>jQuery('select[name=\"packageconfigoption[3]\"]').parents().eq(4).find('.errorbox').remove(); jQuery('select[name=\"packageconfigoption[3]\"]').parents().eq(3).before(\"<div class='errorbox'><strong><span class='title'>{$_LANG['api_credentials_info']}</span></strong></div>\")</script>";
    } else {
        try {

            if(!empty($params->configoption24))
            {
                throw new \Exception($params->configoption24);
            }
            
            $api = new PartnerAPIService($params->configoption1, $params->configoption2, $params->configoption10);

            $op = $api->operationGetProductList();

            if ($op->call())
                $lists = $op->getProducts();

            $new = array();
            foreach ($lists as $key => $val) {
                if ($val->type == 'ISSUE') {
                    $new[] = $key;
                }
            }

            $names = CERTUM_Certificates_Products();
            
            $products[0] = CERTUM_Certificates_translate("SelectProductValue");
            foreach ($names as $codeproduct => $nameproduct) {
                $productName = $codeproduct . '|' . $nameproduct;
                $products[$productName] = $productName;
            }
        } catch (Exception $e) {
            $errorScript = "<script type='text/javascript'>jQuery('select[name=\"packageconfigoption[3]\"]').parents().eq(4).find('.errorbox').remove(); jQuery('select[name=\"packageconfigoption[3]\"]').parents().eq(3).before(`<div class='errorbox'><strong><span class='title'> " . addslashes($e->getMessage()) . "</span></strong></div>`);</script>";
            
            if(!empty($params->configoption24))
            {
                DB::table('tblproducts')->where('id', '=', (int) $_POST['id'])->update(['configoption24' => '']);
            }
            else
            {
                DB::table('tblproducts')->where('id', '=', (int) $_POST['id'])->update(['configoption24' => $e->getMessage()]);
            }
            
        }
    }

    $jsScript = "
        <script type='text/javascript'>

                jQuery(document).ready(function(){
                    approve();
                    jQuery('select[name=\"packageconfigoption[3]\"]').change(function()
                    {
                       approve();
                    });
                });

                function approve()
                {
                    var id              = jQuery('select[name=\"packageconfigoption[3]\"]').val().split('|');
                    var commercial      = [" . implode(',', array_keys(CERTUM_Certificates_Commercial())) . "];
                    var trusted         = [" . implode(',', array_keys(CERTUM_Certificates_Trusted())) . "];
                    var ev              = [" . implode(',', array_keys(CERTUM_Certificates_PremiumEVSSL())) . "];
                    var basic           = [" . implode(',', array_keys(CERTUM_Certificates_IDCerts())) . "];
                    var codesigning     = [" . implode(',', array_keys(CERTUM_Certificates_CodeSigning())) . "];

                    var email           = '<option value=\"ADMIN\">ADMIN</option>';
                    var file            = '<option value=\"FILE\">FILE</option>';
                    var dns             = '<option value=\"DNS_TXT\">DNS_TXT</option><option value=\"DNS_CNAME\">DNS_CNAME</option><option value=\"DNS_TXT_PREFIX\">DNS_TXT_PREFIX</option><option value=\"DNS_CNAME_PREFIX\">DNS_CNAME_PREFIX</option>';

                    var selected        = jQuery('select[name=\"packageconfigoption[4]\"]').val();

                    if(id[0]>0)
                    {

                        if(jQuery.inArray(parseInt(id[0]), commercial) > -1)
                        {
                            jQuery('select[name=\"packageconfigoption[4]\"]').html(email+file+dns);
                        }

                        if(jQuery.inArray(parseInt(id[0]), trusted) > -1)
                        {
                            jQuery('select[name=\"packageconfigoption[4]\"]').html(email+file+dns);
                        }

                        if(jQuery.inArray(parseInt(id[0]), ev) > -1)
                        {
                            jQuery('select[name=\"packageconfigoption[4]\"]').html(email+file+dns);
                        }

                        if(jQuery.inArray(parseInt(id[0]), basic) > -1)
                        {
                            jQuery('select[name=\"packageconfigoption[4]\"]').html(email);
                        }

                        if(jQuery.inArray(parseInt(id[0]), codesigning) > -1)
                        {
                            jQuery('select[name=\"packageconfigoption[4]\"]').html(email);
                        }

                        jQuery('select[name=\"packageconfigoption[4]\"]').val(selected);
                    }

                }
        </script>
";


    $configarray = array(
        "User"              => array(
            "Type"         => "text",
            "Size"         => "25",
            "FriendlyName" => CERTUM_Certificates_translate("Username"),
            "Description"  => $errorScript,
            "Default"      => "",
        ),
        "Pass"              => array(
            "Type"         => "password",
            "Size"         => "25",
            "FriendlyName" => CERTUM_Certificates_translate("Password"),
            "Description"  => "",
            "Default"      => "",
        ),
        "Product"           => array(
            "Type"         => "dropdown",
            "Size"         => "25",
            "Options"      => $products,
            "FriendlyName" => CERTUM_Certificates_translate("Product"),
            "Description"  => "",
            "Default"      => "",
        ),
        "ApproveMethod"     => array(
            "Type"         => "dropdown",
            "Size"         => 25,
            "Options"      => "ADMIN,FILE,DNS_TXT,DNS_CNAME,DNS_TXT_PREFIX,DNS_CNAME_PREFIX", # META removed
            "FriendlyName" => CERTUM_Certificates_translate("Approve Method"),
            "Description"  => "",
            "Default"      => ""
        ),
        "AdditionalDomains" => array(
            "Type"         => "yesno",
            "Size"         => "5",
            "FriendlyName" => CERTUM_Certificates_translate("Additional Domains"),
        ),
        "DomainsLimit"      => array(
            "Type"         => "text",
            "Size"         => "25",
            "FriendlyName" => CERTUM_Certificates_translate("Domains Limit")
        ),
        "AllowAdd"          => array(
            "FriendlyName" => CERTUM_Certificates_translate("Allow To Add More Domains"),
            "Type"         => "yesno",
            "Size"         => "5"
        ),
        "Validation"        => array(
            "Type"         => "dropdown",
            "Size"         => "25",
            "Options"      => "Basic,Extended",
            "FriendlyName" => CERTUM_Certificates_translate("Validation Type"),
            "Description"  => "",
        ),
        "WildCard"          => array(
            "Type"         => "yesno",
            "Size"         => "5",
            "FriendlyName" => CERTUM_Certificates_translate("WildCard")
        ),
        "TestMode"          => array(
            "Type"         => "dropdown",
            "Size"         => "5",
            "FriendlyName" => CERTUM_Certificates_translate("Mode"),
            "Options"      => array('testmode' => 'Test mode - gs.test', 'oldtestmode' => 'Test mode - old', 'production' => 'Production mode')
        ),
        "Language"          => array(
            "Type"         => "dropdown",
            "Size"         => "25",
            "Options"      => "pl,en,ru",
            "FriendlyName" => CERTUM_Certificates_translate("Language"),
            "Description"  => $jsScript
        ),
        "ProductName"       => array(
            "Type"          => "yesno",
            "Size"          => "5",
            "FriendlyName"  => CERTUM_Certificates_translate("DisplayProductName"),
        ),
        "DueDate"       => array(
            "Type"          => "yesno",
            "Size"          => "5",
            "FriendlyName"  => CERTUM_Certificates_translate("SetDueDate"),
        ),
        "RenewCA"       => array(
            "Type"          => "yesno",
            "Size"          => "5",
            "FriendlyName"  => CERTUM_Certificates_translate("RenewCA"),
        ),

    );

    return $configarray;
}

function CERTUM_Certificates_CreateAccount($params) {

    $isAddon = false;
    if(isset($params['addonId']) && !empty($params['addonId']))
    {
        $isAddon = true;
    }
    $row = DB::table('tblsslorders')->where('serviceid', '=', $params['serviceid'])->first();
    if($isAddon)
    {
        $row = DB::table('tblsslorders')->where('addon_id', '=', $params['addonId'])->first();
    }

    if ($row->remoteid) {
        return 'Certificate already exists';
    }

    GLOBAL $CONFIG;

    if($isAddon)
    {
        $usernamefield = DB::table('tblcustomfields')->where('type', 'addon')->where('fieldname', 'Username')->where('adminonly', 'on')->where('relid', $params['packageid'])->first();
        $passwordfield = DB::table('tblcustomfields')->where('type', 'addon')->where('fieldname', 'Password')->where('adminonly', 'on')->where('relid', $params['packageid'])->first();

        $usernameValue = DB::table('tblcustomfieldsvalues')->where('fieldid', $usernamefield->id)->where('relid', $params['addonId'])->first();
        $passwordValue = DB::table('tblcustomfieldsvalues')->where('fieldid', $passwordfield->id)->where('relid', $params['addonId'])->first();

        if(isset($usernameValue->value))
        {
            DB::table('tblcustomfieldsvalues')->where('fieldid', $usernamefield->id)->where('relid', $params['addonId'])->update(['value' => '']);
        }
        else
        {
            DB::table('tblcustomfieldsvalues')->insert(['value' => '', 'relid' => $params['addonId'], 'fieldid' => $usernamefield->id]);
        }

        if(isset($passwordValue->value))
        {
            DB::table('tblcustomfieldsvalues')->where('fieldid', $passwordfield->id)->where('relid', $params['addonId'])->update(['value' => '']);
        }
        else
        {
            DB::table('tblcustomfieldsvalues')->insert(['value' => '', 'relid' => $params['addonId'], 'fieldid' => $passwordfield->id]);
        }

        DB::table('tblsslorders')
                ->where([
                    ['addon_id', '=', $params['addonId']],
                    ['userid', '=', $params['clientsdetails']['userid']],
                ])->delete();

        $id = DB::table('tblsslorders')->insertGetId([
            'userid'    => $params['clientsdetails']['userid'],
            'addon_id' => $params['addonId'],
            'module'    => 'CERTUM_Certificates',
            'certtype'  => $params['configoption3'],
            'status'    => 'Awaiting Configuration'
        ]);
    }
    else
    {
        DB::table('tblhosting')
                ->where('id', '=', $params['serviceid'])
                ->update([
                    'username' => '',
                    'password' => '',
        ]);

        DB::table('tblsslorders')
                ->where([
                    ['serviceid', '=', $params['serviceid']],
                    ['userid', '=', $params['clientsdetails']['userid']],
                ])->delete();

        $id = DB::table('tblsslorders')->insertGetId([
            'userid'    => $params['clientsdetails']['userid'],
            'serviceid' => $params['serviceid'],
            'module'    => 'CERTUM_Certificates',
            'certtype'  => $params['configoption3'],
            'status'    => 'Awaiting Configuration'
        ]);
    }

    $url = '<a href="' . $CONFIG["SystemURL"] . '/configuressl.php?cert=' . md5($id) . '">' . $CONFIG["SystemURL"] . '/configuressl.php?cert=' . md5($id) . '</a>';
    $pid = explode('|', $params['configoption3']);

    $allProducts = CERTUM_Certificates_ProductsAvailable();
    $checkProduct = true;
    if(!isset($allProducts[$pid[0]]))
    {
        $checkProduct = false;
    }

    if (empty($params['configoption3']) || $params['configoption3'] == "0" || empty($pid[0]) || $checkProduct === false) {
        throw new Exception("The voucher code has not been generated. Please select a valid 'Product' value in Certum Certificates product configuration.");
    }

    $template = CERTUM_get_template($pid[0]);

    if($isAddon)
    {
        sendMessage($template, $params["addonId"], array(
            "ssl_configuration_link" => $url
                )
        );
    }
    else
    {
        sendMessage($template, $params["serviceid"], array(
            "ssl_configuration_link" => $url
                )
        );
    }

    return 'success';
}

function CERTUM_Certificates_revokeCertificate($params) {

    $isAddon = false;
    if(isset($params['addonId']) && !empty($params['addonId']))
    {
        $isAddon = true;
    }

    if($isAddon)
    {
        $details = DB::table('tblsslorders')->where('addon_id', '=', $params['addonId'])->first();
    }
    else
    {
        $details = DB::table('tblsslorders')->where('serviceid', '=', $params['serviceid'])->first();
    }

    $api = new PartnerAPIService($params['configoption1'], $params['configoption2'], $params['configoption10']);

    $certs = array();

    try {
        $op = $api->operationGetOrderByOrderID();
        $op->setOrderID($details->remoteid)->setOrderStatus(TRUE)->setCertificateDetails(TRUE)->setOrderDetails(TRUE);

        if ($op->call()) {
            $cert = $op->getOrders();

        } else {
            $error = $op->getErrorTexts();
            return $error[0]['text'];
        }
    } catch (Exception $e) {
        return $e->getMessage();
    }

    foreach($cert as $c)
    {
        if($c->certificateDetails->certificateStatus == 'VALID')
        {
            $dateTime = new DateTime($c->certificateDetails->startDate);
            $startdate = $dateTime->format('Y-m-d');
            $certs[] = array(
                'status' => $c->certificateDetails->certificateStatus,
                'date' => $startdate,
                'time' => strtotime($startdate),
                'number' => $c->certificateDetails->serialNumber,
                'csr' => $c->certificateDetails->X509Cert,
                'number_order' => $c->orderStatus->serialNumber
            );
        }
    }

    $certsnew = array_sort_new($certs, 'time', SORT_DESC);

    $product = new Product($params['pid']);
    $configuration = $product->getConfiguration();

    $api = new PartnerAPIService($configuration->configoption1, $configuration->configoption2, $configuration->configoption10);

    $sslService = new SslService($params['serviceid']);
    $sslService->setApiHandler($api);
    $lastCsr = $sslService->getLastCertificateSerialNumber();

    $pid = explode('|', $params['configoption3']);

    if ( $pid[0] == '631' || $pid[0] == '681' || $pid[0] == '721' || $pid[0] == '722' || $pid[0] == '723' || $pid[0] == '831'
        || $pid[0] == '832' || $pid[0] == '833' || $pid[0] == '971'
        || $pid[0] == '281' || $pid[0] == '282' || $pid[0] == '283' || $pid[0] == '641' || $pid[0] == '981'|| $pid[0] == '316'
        || $pid[0] == '317' || $pid[0] == '318' ||
        $pid[0] == '511' || $pid[0] == '512' || $pid[0] == '521' || $pid[0] == '522' || $pid[0] == '531' || $pid[0] == '532'
    )
    {
        $affiliationChanged = '<div style="position: relative">' .
            '<input type="radio" class="reasonRadio" id="AFFILIATIONCHANGED" name="reason" value="AFFILIATIONCHANGED" style="margin-right: 5px;">' .
            '<label>Subject'. "' " .'s name, organization name or address included in the certificate has changed</label>' .
            '</div>';
    }

    $templateVars = [
        'today' => date('Y-m-d'),
        "productId" => $params['pid'],
        "serviceId" => $params['serviceid'],
        'certumpid' => $pid[0],
        'affiliationChanged' => $affiliationChanged,
        'startDate' => $certsnew[0]['date'],
        "serial_number" => trim((string) $lastCsr['number']),
    ];

    $view = new View();
    $template = $view->loadTemplate("revoke_certificate.tpl", $templateVars);

    return array (
        'templatefile'  =>  'reissue',
        'breadcrumb'    =>  "",
        'vars'          =>  array('output' =>  $template)
    );
}

function CERTUM_Certificates_TerminateAccount($params) {

    $isAddon = false;
    if(isset($params['addonId']) && !empty($params['addonId']))
    {
        $isAddon = true;
    }

    if($isAddon)
    {
        $details = DB::table('tblsslorders')->where('addon_id', '=', $params['addonId'])->first();
    }
    else
    {
        $details = DB::table('tblsslorders')->where('serviceid', '=', $params['serviceid'])->first();
    }

    $api = new PartnerAPIService($params['configoption1'], $params['configoption2'], $params['configoption10']);

    $certs = array();

    try {
        $op = $api->operationGetOrderByOrderID();
        $op->setOrderID($details->remoteid)->setOrderStatus(TRUE)->setCertificateDetails(TRUE)->setOrderDetails(TRUE);

        if ($op->call()) {
            $cert = $op->getOrders();

        } else {
            $error = $op->getErrorTexts();
            return $error[0]['text'];
        }
    } catch (Exception $e) {
        return $e->getMessage();
    }

    foreach($cert as $c)
    {
        if($c->certificateDetails->certificateStatus == 'VALID')
        {
            $dateTime = new DateTime($c->certificateDetails->startDate);
            $startdate = $dateTime->format('Y-m-d H:i:s');
            $certs[] = array(
                'status' => $c->certificateDetails->certificateStatus,
                'date' => $startdate,
                'time' => strtotime($startdate),
                'number' => $c->certificateDetails->serialNumber,
                'csr' => $c->certificateDetails->X509Cert,
                'number_order' => $c->orderStatus->serialNumber
            );
        }
    }

    $certsnew = array_sort_new($certs, 'time', SORT_DESC);
    $csr = (string) reset($certsnew)['csr'];

    if (!empty($csr)) {
        try {
            $op = $api->operationRevokeCertificate();
            $op->setSerialNumber((string) reset($certsnew)['number_order']);
            if ($op->call()) {
                return "success";
            } else {
                $error = $op->getErrorTexts();
                return $error[0]['text'];
            }
        } catch (Exception $e) {
            $error = $op->getErrorTexts();
            return $error[0]['text'];
        }
    } else {
        return "Certificate not found.";
    }
}

/**
 * First step
 * @param type $params
 * @return boolean
 */
function CERTUM_Certificates_SSLStepOne($params) {

    unset($_SESSION['cert_assign']);
    unset($_SESSION['domains']);

    $product = explode('|', $params['configoption3']);
    $configuration = new CertificateConfiguration($product[0], $product[1]);
    $fields = $configuration->get();
    return $fields;
}

/**
 * Second step
 * @param type $params
 * @return array
 */
function CERTUM_Certificates_SSLStepTwo($params) {

    $isAddon = false;
    if(isset($params['addonId']) && !empty($params['addonId']))
    {
        $isAddon = true;
    }

    //whmcs 7.3 fix
    $r = DB::table('tblsslorders')->where(DB::raw('md5(id)'), '=', $_GET['cert'])->first();
    if($r->status == 'Awaiting Configuration')
    {
        $data = $_POST;
        unset($data['token']);
        $updateData = (IS_WHMCS_73_OR_HIGHER) ? ['configdata' => json_encode($data)] : ['configdata' => serialize($data)];

        DB::table('tblsslorders')->where(DB::raw('md5(id)'), '=', $_GET['cert'])->update($updateData);
    }

    if (!empty($params['orgname']) && empty($params['jobtitle'])) {
        return array(
            'error' => 'Job Title is required if Organization Name is set.'
        );
    }

    if (!empty($params['fields']['AdminName']) && strlen($params['fields']['AdminName']) > 64) {
        return array(
            'error' => 'Organization Name contains more than 64 characters.'
        );
    }
    
    $product = explode('|', $params['configoption3']);
    if($product[0] != '316' && $product[0] != '317' && $product[0] != '318' && 
       $product[0] != '641' && $product[0] != '981' && $product[0] != '631' && 
       $product[0] != '681' && $product[0] != '971' && $product[0] != '601' &&
       $product[0] != '741' && $product[0] != '961' &&
       $product[0] != '281' && $product[0] != '282' && $product[0] != '283'
            ){
        if (strpos($product['1'], 'EV') !== false || strpos($product['1'], 'Trusted') !== false) {
            if (empty($params['fields']['AdminLocality']) && empty($params['fields']['AdminStateProvince'])) {
                return array(
                    'error' => 'Locality or State Province is required.'
                );
            }
        }
    }
    
    if (strpos($product['1'], 'EV') !== false) {
        if($params['fields']['AdminBusinessCategory'] == 'Please choose...') {
            return array(
                'error' => 'Please choose BusinessCategory.'
            );
        }
    }
    
    if($product[0] == '831' || $product[0] == '832' || $product[0] == '833' ||
       $product[0] == '316' || $product[0] == '317' || $product[0] == '318' ||
       $product[0] == '721' || $product[0] == '722' || $product[0] == '723' ||
       $product[0] == '641' || $product[0] == '981' || $product[0] == '631' || 
       $product[0] == '681' || $product[0] == '971' || $product[0] == '281' || 
       $product[0] == '282' || $product[0] == '283'){
        if (empty($params['fields']['Locality']) && empty($params['fields']['StateProvince'])) {
            return array(
                'error' => 'Locality or State Province is required.'
            );
        }
    }

    if(
        $product[0] != '601' && $product[0] != '741' && $product[0] != '961' && $product[0] != '691' && $product[0] != '791' &&
        $product[0] != '731' && $product[0] != '732' && $product[0] != '733' &&
        $product[0] != '501' && $product[0] != '502' && $product[0] != '511' && $product[0] != '512' && $product[0] != '521' && $product[0] != '522' && $product[0] != '531' && $product[0] != '532'
    )
    {
        if (!filter_var($params['fields']['AdminEmail'], FILTER_VALIDATE_EMAIL)) {
            return array(
                'error' => 'Field Email is invalid.'
            );
        }
    }

    if(
        $product[0] == '601' || $product[0] == '741' || $product[0] == '961' || $product[0] == '691' || $product[0] == '791' ||
        $product[0] == '731' || $product[0] == '732' || $product[0] == '733' ||
        $product[0] == '501' || $product[0] == '502' || $product[0] == '511' || $product[0] == '512' || $product[0] == '521' || $product[0] == '522' || $product[0] == '531' || $product[0]== '532'
    )
    {
        if(
            (!empty($params['fields']['AdminFirstName']) || !empty($params['fields']['AdminLastName']) ||
            !empty($params['fields']['AdminPhone']) || !empty($params['fields']['AdminEmail']))
            &&
            (empty($params['fields']['AdminFirstName']) || empty($params['fields']['AdminLastName']) || empty($params['fields']['AdminEmail']))
        )
        {
            return array(
                'error' => CERTUM_Certificates_translate('contact_fields_error')
            );
        }

    }

    if (isset($params['configdata']['csr'])) {
        $data = openssl_csr_get_subject($params['configdata']['csr']);
        $domain = $data['CN'];
    }

    if (isset($params['csr'])) {
        $data = openssl_csr_get_subject($params['configdata']['csr']);
        $domain = $data['CN'];
    }
    if (empty($domain) && isset($_POST['csr'])) {
        $data = openssl_csr_get_subject($_POST['csr']);
        $domain = $data['CN'];
    }

    if (empty($domain)) {
        return array('error' => 'Invalid CSR');
    }
    
    if(is_array($domain) && $params['configoption5'] != 'on')
    {
        return array('error' => ' This is not a multidomain product, please provide CSR with one domain included in CN field.');
    }

    if ($params['configoption9'] == 'on' && substr($domain, 0, 2) != '*.') {
        return array('error' => 'CSR does not contain a wildcard domain as expected');
    }
    
    if (!isset($_POST['domain'])) {

        if($isAddon)
        {
            $r = DB::table('tblsslorders')->select('id')->where([
                ['addon_id', '=', $params['addonId']],
                ['userid', '=', $_SESSION['uid']],
            ])->first();
        }
        else
        {
            $r = DB::table('tblsslorders')->select('id')->where([
                        ['serviceid', '=', $params['serviceid']],
                        ['userid', '=', $_SESSION['uid']],
                    ])->first();
        }
        $_SESSION['certificate_details'] = $params;
        $cert_id = explode("|", $params['configoption3']);
        $signing = CERTUM_Certificates_CodeSigning();
        $id_certs = CERTUM_Certificates_IDCerts();
        $SMIME = CERTUM_Certificates_SMime();
        
        if (isset($signing[$cert_id[0]]) || isset($id_certs[$cert_id[0]]) || isset($SMIME[$cert_id[0]])) {
            header("Location: configurecertificate.php?cert=" . md5($r->id));
            die();
        }

        header("Location: configuressl2.php?cert=" . md5($r->id));
        die();
    }

    $domain = str_replace('*.', '', $domain);

    return array(
            'approveremails' => array(
                0 => 'admin@' . $domain,
                1 => 'administrator@' . $domain,
                2 => 'postmaster@' . $domain,
                3 => 'hostmaster@' . $domain,
                4 => 'webmaster@' . $domain
            )
        );
}

/**
 * Third step
 * @param type $params
 * @return boolean
 */
function CERTUM_Certificates_sslstepthree($params) {
    
    $isAddon = false;
    if(isset($params['addonId']) && !empty($params['addonId']))
    {
        $isAddon = true;
    }

    if ($_SESSION['cert_assign'] == 1)
        return;

    //Prepare CSR
    $csr = trim($params['configdata']['csr']);
    $csr = trim(preg_replace('/(.*)CERTIFICATE(.*)/', '', $csr));
    $csr = "-----BEGIN CERTIFICATE REQUEST-----\n" . $csr . "\n-----END CERTIFICATE REQUEST-----";
    $csr = trim($csr);
    $data = openssl_csr_get_subject($csr);
    $domain = $data['CN'];
    
    if(is_array($domain))
    {
        $domain = reset($domain);
    }
    
    $cn_d = $domain;
    $code_lang = CERTUM_Certificates_loadLanguage(true);
    $api = new PartnerAPIService($params['configoption1'], $params['configoption2'], $params['configoption10'], $code_lang);

    if (isset($params['approveremail']) && $params['approveremail'] != "" )
        $params['configdata']['approveremail'] = $params['approveremail'];

    if ($params['customfields']['method'] != "") {
        $params['configoption4'] = $params['customfields']['method'];
    }

    $apprTemp = array();

    try {
        $id_certs = CERTUM_Certificates_IDCerts();
        $orderid = uniqid();
        $pid = explode('|', $params['configoption3']);
        $product = $pid[0];

        if ($product == 1000) {
            $serials = explode("\n", $params['configdata']['fields']['AdminSerialNumbers']);
            $op = $api->operationOrderSNICertificate();
            $op
                    ->setCSR($csr)
                    ->setLanguage($params['configoption11'])
                    ->setOrganizationInfo($params['configdata']['fields']['AdminTax'])
                    ->addSerialNumber($serials);
        } else {
            
            if($product == '831' || $product == '832' || $product == '833' || 
               $product == '316' || $product == '317' || $product == '318' ||
               $product == '281' || $product == '282' || $product == '283')
            {
                $customer = $params['fields']['simplysign_account'];
            } 
            else
            {
                $customer = md5(\MGModule\CERTUM_Certificates\helpers\Customer::getCustomerHash($params['userid']));

                if(strlen($customer) > 64)
                {
                    $customer = substr($customer, 0, 63);
                    \MGModule\CERTUM_Certificates\helpers\Customer::saveCustomerHash(array('userid' => $params['userid'], 'customer' => $customer));
                }
            }

            $op = $api->operationQuickOrder();
            require_once dirname(__FILE__).DIRECTORY_SEPARATOR.'version.php';
            global $CONFIG;

            $op
                    ->setCSR($csr)
                    ->setCustomer($customer)
                    ->setLanguage($params['configoption11'])
                    ->setOrderID($orderid)
                    ->setProductCode($pid[0])
                    ->setUserAgent($_SERVER['HTTP_USER_AGENT'].'_WHMCS_'.$CONFIG['Version'].'_Plugin_'.$version);
            
            
            if (strpos($pid['1'], 'EV') !== false) {
                                
                $op->setJoisocn($params['configdata']['fields']['AdminJoisocn']);
                if(isset($params['configdata']['fields']['AdminLocality']) && !empty($params['configdata']['fields']['AdminLocality']))
                {
                    $op->setLocality($params['configdata']['fields']['AdminLocality']);
                }
                if(isset($params['configdata']['fields']['AdminStateProvince']) && !empty($params['configdata']['fields']['AdminStateProvince']))
                {
                    $op->setState($params['configdata']['fields']['AdminStateProvince']);
                }
                $op->setBusinessCategory($params['configdata']['fields']['AdminBusinessCategory']);
                $op->setSerialNumber($params['configdata']['fields']['AdminSerialNumber']);

            }

            if (strpos($pid['1'], 'Trusted') !== false) {
                if(isset($params['configdata']['fields']['AdminLocality']) && !empty($params['configdata']['fields']['AdminLocality']))
                {
                    $op->setLocality($params['configdata']['fields']['AdminLocality']);
                }
                if(isset($params['configdata']['fields']['AdminStateProvince']) && !empty($params['configdata']['fields']['AdminStateProvince']))
                {
                    $op->setState($params['configdata']['fields']['AdminStateProvince']);
                }
            }

            if (!empty($params['configdata']['fields']['AdminName']))
            {
                $op->setOrganization($params['configdata']['fields']['AdminName']);
            }

            if (!empty($params['configdata']['fields']['AdminName']) && !empty($params['configdata']['fields']['AdminTax']))
                $op->setOrganizationInfo(
                    $params['configdata']['fields']['AdminTax'], 
                    $params['configdata']['fields']['AdminVerificationPhone']
                );
        }
        
        if($product == '316' || $product == '317' || $product == '318' ||
           $product == '641' || $product == '981')
        {
            $op->setLocality($params['configdata']['fields']['Locality']);
            $op->setJoisocn($params['configdata']['fields']['Joisocn']);
            $op->setBusinessCategory($params['configdata']['fields']['BusinessCategory']);
            $op->setSerialNumber($params['configdata']['fields']['SerialNumber']);
        }
        
        if($product == '631' || $product == '681' || $product == '971')
        {
            $op->setLocality($params['configdata']['fields']['Locality']);
        }


        if(
            $product == '601' || $product == '741' || $product == '961' || $product == '691' ||
            $product == '791' || $product == '731' || $product == '732' || $product == '733' ||
            $product == '501' || $product == '502' || $product == '511' || $product == '512' || $product == '521' || $product == '522' || $product == '531' || $product == '532'
        ) {

            if(
                (isset($params['configdata']['fields']['AdminFirstName']) && !empty($params['configdata']['fields']['AdminFirstName'])) &&
                (isset($params['configdata']['fields']['AdminLastName']) && !empty($params['configdata']['fields']['AdminLastName'])) &&
                (isset($params['configdata']['fields']['AdminEmail']) && !empty($params['configdata']['fields']['AdminEmail']))
            )
            {
                $op->setRequestorInfoIndividual(
                    $params['configdata']['fields']['AdminFirstName'],
                    $params['configdata']['fields']['AdminLastName'],
                    $params['configdata']['fields']['AdminEmail'],
                    $params['configdata']['fields']['AdminPhone']
                );
            }

        }
        else {
            if ($product == '831' || $product == '832' || $product == '833' ||
                $product == '721' || $product == '722' || $product == '723' ||
                $product == '731' || $product == '732' || $product == '733' ||
                $product == '316' || $product == '317' || $product == '318' ||
                $product == '641' || $product == '981' ||
                $product == '501' || $product == '502' || $product == '511' || $product == '512' || $product == '521' || $product == '522' || $product == '531' || $product == '532'
            ) {
                if ($pid[0] == '731' || $pid[0] == '732' || $pid[0] == '733' ||
                    $pid[0] == '501' || $pid[0] == '502' || $pid[0] == '511' || $pid[0] == '512' || $pid[0] == '521' || $pid[0] == '522' || $pid[0] == '531' || $pid[0] == '532'
                ) {
                    $op
                        ->setRequestorInfoIndividual(
                            $params['configdata']['fields']['AdminFirstName'],
                            $params['configdata']['fields']['AdminLastName'],
                            $params['configdata']['fields']['AdminEmail'],
                            $params['configdata']['fields']['AdminPhone']
                        );
                } else {
                    $op->setRequestorInfoIndividual(
                        $params['configdata']['fields']['AdminFirstName'],
                        $params['configdata']['fields']['AdminLastName'],
                        $params['configdata']['fields']['AdminEmail'],
                        $params['configdata']['fields']['AdminPhone']
                    );
                }
            } else {
                $op->setRequestorInfoIndividual(
                    $params['configdata']['fields']['AdminFirstName'],
                    $params['configdata']['fields']['AdminLastName'],
                    $params['configdata']['fields']['AdminEmail'],
                    $params['configdata']['fields']['AdminPhone']
                );
            }
        }

        if (strpos($cn_d, '*') > -1) {
            $san = $cn_d;
            $domainUpdate = $cn_d;
        } else {
            $san = $domain;
            $domainUpdate = $cn_d;
        }

        $op->setCommonName($domainUpdate);
     
        $isSubdomain = false;
        if(count($apprTemp) > 1)
        {
            $isSubdomain = true;
        }

        if (strpos($domainUpdate, '*.') > -1) {
            $domainUpdateCheck = str_replace('*.', '', $domainUpdate);
        } else {
            $domainUpdateCheck = $domainUpdate;
        }

        if (isset($_SESSION['domains']) && count($_SESSION['domains']) > 0 && !isset($id_certs[$product])) {
                               
            $op->setApproverMethod($_SESSION['approvermethod']);
            if($_SESSION['approvermethod'] == 'ADMIN')
            {
                if($_SESSION['approveremailprefix'])
                {
                    $op->setApproverEmailPrefix($_SESSION['approveremailprefix']);
                }
            }
            else 
            {
                if($_SESSION['approveremailaddress'])
                {
                    $op->setApproverEmail($_SESSION['approveremailaddress']);
                }
            }
            
            $op->setApproverVerificationNotificationEnabled(false);
            if($_SESSION['approvenotification'])
            {
            $op->setApproverVerificationNotificationEnabled(true);
            }
            $i = 0;
            foreach($_SESSION['san_list'] as $host)
            {
                if(!empty($host))
                {
                    $san = $host;
                    $op->addSANEntry($san);

                    if (array_search($host, $_SESSION['www_domain']) !== false)
                    {
                        $op->addSANEntry('www.' . $host);
                    }
                }

                $i++;
            }
        }
        
        if($product == '831' || $product == '832' || $product == '833' ||
           $product == '721' || $product == '722' || $product == '723' ||
           $product == '731' || $product == '732' || $product == '733' ||
           $product == '501' || $product == '502' || $product == '511' || $product == '512' || $product == '521' || $product == '522' || $product == '531' || $product == '532'
        )
        {
            $emailtemp = $params['configdata']['fields']['AdminEmail'];
            if(!empty($params['configdata']['fields']['Email']))
            {
                $emailtemp = $params['configdata']['fields']['Email'];
            }
            $op->setCommonName($params['fields']['CommonName']);
            $op->setOrganization($params['fields']['Organization']);
            $op->setCountry($params['fields']['Country']);
            $op->setEmail($params['configdata']['fields']['Email']);
            $op->setLocality($params['fields']['Locality']);
            $op->setState($params['fields']['StateProvince']);
        }
        else 
        {
            $op->setCountry($params['fields']['AdminCountry']);
        }
        if($product == '601' || $product == '631' || $product == '641' ||
           $product == '681' || $product == '721' || 
           $product == '722' || $product == '723' || $product == '731' ||
           $product == '501' || $product == '502' || $product == '511' || $product == '512' || $product == '521' || $product == '522' || $product == '531' || $product == '532' ||
           $product == '732' || $product == '733' || $product == '741' ||
           $product == '961' || $product == '971' || $product == '981')
        {
            $op->setHashAlgorithm($params['hashalgorithm']);
        }

        if($product == '511' || $product == '512' || $product == '521' || $product == '522')
        {
            $op->setSurname($params['fields']['Surname']);
            $op->setGivenName($params['fields']['GivenName']);
        }

        if($product == '316' || $product == '317' || $product == '318' ||
           $product == '641' || $product == '981')
        {
            $op->setCommonName($params['fields']['CommonName']);
            $op->setOrganization($params['fields']['Organization']);
            $op->setLocality($params['fields']['Locality']);
            $op->setState($params['fields']['StateProvince']);
            $op->setCountry($params['fields']['Country']);
            $op->setSerialNumber($params['fields']['SerialNumber']);
            $op->setBusinessCategory($params['fields']['BusinessCategory']);
            $op->setStreetAddress($params['fields']['Street']);
            $op->setPostalCode($params['fields']['PostalCode']);
            $op->setJoiln($params['fields']['JoILN']);
            $op->setJoisopn($params['fields']['JoISoPN']);
            $op->setJoisocn($params['fields']['Joisocn']);
            $op->setRevocationContactEmail($params['fields']['AdminRevocationContactEmail']);
            
            if($product != '641' && $product != '981')
            {
                if(!empty($params['fields']['TaxIdentificationNumber']))
                {
                    $op->setOrganizationInfo(
                            $params['fields']['TaxIdentificationNumber'],
                            $params['fields']['VerificationPhoneNumber']
                    );
                }
            }
        }
        
        if($product == '281' || $product == '282' || $product == '283')
        {
            $op->setCommonName($params['fields']['CommonName']);
            $op->setOrganization($params['fields']['Organization']);
            $op->setCountry($params['fields']['Country']);
            $emailtemp = $params['configdata']['fields']['AdminEmail'];
            if(!empty($params['configdata']['fields']['Email']))
            {
                $emailtemp = $params['configdata']['fields']['Email'];
            }
            $op->setEmail($emailtemp);
            $op->setLocality($params['fields']['Locality']);
            $op->setState($params['fields']['StateProvince']);
            $op->setRevocationContactEmail($params['fields']['AdminRevocationContactEmail']);
        }
        
        if($product == '631' || $product == '681' || $product == '971')
        {
            $op->setCommonName($params['fields']['CommonName']);
            $op->setOrganization($params['fields']['Organization']);
            $op->setLocality($params['fields']['Locality']);
            $op->setState($params['fields']['StateProvince']);
            $op->setCountry($params['fields']['Country']);
            $op->setRevocationContactEmail($params['fields']['AdminRevocationContactEmail']);
            if(!empty($params['fields']['TaxIdentificationNumber']))
            {
                $op->setOrganizationInfo(
                        $params['fields']['TaxIdentificationNumber'],
                        $params['fields']['VerificationPhoneNumber']
                );
            }
        }
        
        if($product == '601' || $product == '741' || $product == '961')
        {
            $op->setCommonName($params['fields']['CommonName']);
            $op->setRevocationContactEmail($params['fields']['AdminRevocationContactEmail']);
        }
        
        if ($op->call()) {

            CERTUM_change_next_due_date($params);
            $id = $op->getOrderID();
            
            if(isset($params['fields']['CommonName']) && !empty($params['fields']['CommonName']))
            {
                $domainUpdate = $params['fields']['CommonName'];
            }
            
            if($isAddon)
            {
                $domainfield = DB::table('tblcustomfields')->where('type', 'addon')->where('fieldname', 'Domain')->where('adminonly', 'on')->where('relid', $params['packageid'])->first();

                if(!isset($domainfield->id) || empty($domainfield->id))
                {
                    DB::table('tblcustomfields')->insert(['type' => 'addon', 'relid' => $params['packageid'], 'fieldname' => 'Domain', 'adminonly' => 'on', 'sortorder' => '0', 'created_at' => date('Y-m-d H:i:s'), 'updated_at' => date('Y-m-d H:i:s')]);
                    $domainfield = DB::table('tblcustomfields')->where('type', 'addon')->where('fieldname', 'Domain')->where('adminonly', 'on')->where('relid', $params['packageid'])->first();
                }

                $domainfieldvalue = DB::table('tblcustomfieldsvalues')->where('fieldid', $domainfield->id)->where('relid', $params['addonId'])->first();

                DB::table('tblsslorders')->where('addon_id', '=', $params['addonId'])->update([
                    'remoteid' => $id,
                ]);

                if(isset($domainfieldvalue->value))
                {
                    DB::table('tblcustomfieldsvalues')->where('fieldid', $domainfield->id)->where('relid', $params['addonId'])->update(['value' => $domainUpdate]);
                }
                else
                {
                    DB::table('tblcustomfieldsvalues')->insert(['value' => $domainUpdate, 'relid' => $params['addonId'], 'fieldid' => $domainfield->id]);
                }
            }
            else
            {
                DB::table('tblsslorders')->where('serviceid', '=', $params['serviceid'])->update([
                    'remoteid' => $id,
                ]);
                DB::table('tblhosting')->where('id', '=', $params['serviceid'])->update(['domain' => $domainUpdate]);
            }

            $_SESSION['cert_assign'] = 1;
            unset($_SESSION['domains']);

            if($isAddon)
            {
                return array(
                    'remoteid' => $id
                );
            }
            else
            {
                return array(
                    'remoteid' => $id,
                    'domain'   => $domainUpdate
                );
            }

        } else {
            $error = $op->getErrorTexts();

            if(empty($error[0]['text']))
            {
                return array('error' => 'Error code: '. $error[0]['code']);
            }

            return array('error' => $error[0]['text']);
        }
    } catch (Exception $e) {
        return array('error' => $e->getMessage());
    }
}

/**
 * Resend cert email to client
 * @param type $params
 * @return type
 */
function CERTUM_Certificates_resend($params) {

    $isAddon = false;
    if(isset($params['addonId']) && !empty($params['addonId']))
    {
        $isAddon = true;
    }

    if($isAddon)
    {
        $r = DB::table('tblsslorders')->where('addon_id', '=', $params['addonId'])->first();
    }
    else
    {
        $r = DB::table('tblsslorders')->where('serviceid', '=', $params['serviceid'])->first();
    }

    if (!$r->id) {
        return "No Order exists for this product";
    }
    global $CONFIG;
    $sslconfigurationlink = $CONFIG['SystemURL'] . "/configuressl.php?cert=" . md5($r->id);
    $sslconfigurationlink = "<a href=\"{$sslconfigurationlink}\">{$sslconfigurationlink}</a>";
    $pid = explode("|", $params['configoption3']);

    $template = CERTUM_get_template($pid[0]);

    $res = sendMessage($template, $params['serviceid'], array(
        "ssl_configuration_link" => $sslconfigurationlink
    ));

    return "success";
}

function CERTUM_Certificates_resendnotification($params) {
    $api = new PartnerAPIService($params['configoption1'], $params['configoption2'], $params['configoption10']);

    $isAddon = false;
    if(isset($params['addonId']) && !empty($params['addonId']))
    {
        $isAddon = true;
    }

    if($isAddon)
    {
        $cert = DB::table('tblsslorders')->where('addon_id', '=', $params['addonId'])->first();
    }
    else
    {
        $cert = DB::table('tblsslorders')->where('serviceid', '=', $params['serviceid'])->first();
    }

    try {
        $op = $api->operationAddEmailVerification();
        $op->setOrderID($cert->remoteid);
        
        if ($op->call())
            return "success";
        else {
            $error = $op->getErrorTexts();
            return $error[0]['text'];
        }
    } catch (Exception $e) {
        return $e->getMessage();
    }
}

function CERTUM_Certificates_sendcertificate($params) {
    $isAddon = false;
    if(isset($params['addonId']) && !empty($params['addonId']))
    {
        $isAddon = true;
    }

    if($isAddon)
    {
        $r = DB::table('tblsslorders')->where('addon_id', '=', $params['addonId'])->first();
    }
    else
    {
        $r = DB::table('tblsslorders')->where('serviceid', '=', $params['serviceid'])->first();
    }

    if (empty($r->remoteid)) {
        return "Certificate not found.";
    }
    $api = new PartnerAPIService($params['configoption1'], $params['configoption2'], $params['configoption10']);
    $op = $api->operationGetOrderByOrderID();
    $op->setOrderID($r->remoteid)->setOrderStatus(TRUE)->setCertificateDetails(TRUE)->setOrderDetails(TRUE);
    try {
        if ($op->call()) {
            $cert_details = $op->getOrders();
            foreach($cert_details as $cert)
            {
                if ((string) $cert->certificateDetails->X509Cert != "") {

                    $row = DB::table('tblemailtemplates')
                            ->where('name', '=', 'CERTUM Certificates - Certificate Details')
                            ->count();
                    if ($row == 0) {
                        DB::table('tblemailtemplates')
                                ->insert([
                                    'type'       => "product",
                                    'name'       => "CERTUM Certificates - Certificate Details",
                                    'subject'    => "Certificate Details",
                                    'message'    => "<p>Dear {\$client_name},</p><p>Thank you for your order for an Certificate.</p><p>Your Certificate:</p><p>{\$ssl_csr}</p><p></p><p>{\$signature}</p>",
                                    'created_at' => date('Y-m-d H:i:s'),
                                    'updated_at' => date('Y-m-d H:i:s'),
                        ]);
                    }

                    if($isAddon)
                    {
                        $res = sendMessage("CERTUM Certificates - Certificate Details", $params['addonId'], array(
                            "ssl_csr" => (string) $cert->certificateDetails->X509Cert
                        ));
                    }
                    else
                    {
                        $res = sendMessage("CERTUM Certificates - Certificate Details", $params['serviceid'], array(
                            "ssl_csr" => (string) $cert->certificateDetails->X509Cert
                        )); 
                    }



                }
                else
                {
                    return "Certificate not found";
                }
            }
            return "success";
        }
        else {
            $error = $op->getErrorTexts();
            return $error[0]['text'];
        }
    } catch (Exception $e) {
        return $e->getMessage();
    }
}

/**
 * Display cert details in admin area
 * @param type $params
 * @return string
 */
function CERTUM_Certificates_AdminServicesTabFields($params) {

    try{
    
    $isAddon = false;
    if(isset($params['addonId']) && !empty($params['addonId']))
    {
        $isAddon = true;
    }
    $r = DB::table('tblsslorders')->where('serviceid', '=', $params['serviceid'])->first();
    if($isAddon)
    {
        $r = DB::table('tblsslorders')->where('addon_id', '=', $params['addonId'])->first();
    }

    $remoteid = $r->remoteid;
    if (!$r->id) {
        $remoteid = "-";
        // $r->status = "Not Yet Provisioned";
    }

    if (isset($_POST['ajax']) && $_POST['ajax'] == 1) {

        ob_clean();
        $msg = null;
        switch ($_POST['action']) {
            case 'getCertDetails':
                $api = new PartnerAPIService($params['configoption1'], $params['configoption2'], $params['configoption10']);
                $result = 0;
                try {
                    $op = $api->operationGetOrderByOrderID();
                    $op->setOrderID($remoteid)->setOrderStatus(TRUE)->setCertificateDetails(TRUE)->setOrderDetails(TRUE);
                    if ($op->call()) {
                        $certall = $op->getOrders();
                        foreach($certall as $singlecert)
                        {
                            if($singlecert->certificateDetails->serialNumber == $_POST['certnumber'])
                            {
                                $cert = $singlecert;
                            }
                        }
                        if($cert->certificateDetails->X509Cert == NULL || $cert->certificateDetails->X509Cert == "")
                        {
                            $result = 0;
                            $msg = 'Certificate not found.';
                        }
                        else
                            {
                            $result = 1;
                            $cert_details = "-----BEGIN CERTIFICATE-----\n" . trim((string) $cert->certificateDetails->X509Cert) . "\n-----END CERTIFICATE-----";
                        }

                    } else {
                        $error = $op->getErrorTexts();
                        $msg = $error[0]['text'];
                    }
                } catch (Exception $e) {
                    $msg = $e->getMessage();
                }

                echo json_encode(array('result' => $result, 'msg' => $msg, 'cert' => $cert_details));
                break;
            case 'getIntermediateCertDetails':
            case 'getRootCertDetails':
                $api = new PartnerAPIService($params['configoption1'], $params['configoption2'], $params['configoption10']);
                $result = 0;
                try
                {
                    $opGetCaBundle = $api->operationGetCertificate();
                    $opGetCaBundle->setOrderID($r->remoteid);

                    if($opGetCaBundle->call())
                    {
                        $caBundle = $opGetCaBundle->getCaBundle();
                        $intermediate_cert = trim((string) $caBundle->getX509Cert()[0]);
                        $root_cert = trim((string) $caBundle->getX509Cert()[1]);
                        $result = 1;
                    } else {
                        $error = $opGetCaBundle->getErrorTexts();
                        $msg = $error[0]['text'];
                    }

                }
                catch (Exception $e)
                {
                    $msg = $e->getMessage();
                }
                echo json_encode(array('result' => $result, 'msg' => $msg, 'intermediate_cert' => $intermediate_cert, 'root_cert' => $root_cert));
                break;
            case 'renewCert':

                $params['configdata'] = (IS_WHMCS_73_OR_HIGHER) ? (array)json_decode($r->configdata) : unserialize($r->configdata);

                if ($r->remoteid > 0) {
                    $pid = explode('|', $params['configoption3']);
                    $renew = CERTUM_Certificates_ProductsRenew();
                    $new = $renew[$pid[0]];
                    if (!isset($new)) {
                        die(json_encode(array('success' => 0, 'msg' => 'This certificate cannot be renewed.')));
                    }

                    $api = new PartnerAPIService($params['configoption1'], $params['configoption2'], $params['configoption10']);
                    try {
                        $op = $api->operationRenewCertificate();
                        $op->setCSR($_POST['csr']);
                        if (isset($_POST['pem']) && !empty($_POST['pem'])) {
                            $op->setX509Cert($_POST['pem']);
                        } elseif (isset($_POST['serial']) && !empty($_POST['serial'])) {
                            $op->setSerialNumber($_POST['serial']);
                        }
                        $customer = md5(\MGModule\CERTUM_Certificates\helpers\Customer::getCustomerHash($params['userid']));
                        $op->setCustomer($customer)->setProductCode($new);
                        
                        require_once dirname(__FILE__).DIRECTORY_SEPARATOR.'version.php';
                        global $CONFIG;
                        $op->setUserAgent($_SERVER['HTTP_USER_AGENT'].'_WHMCS_'.$CONFIG['Version'].'_Plugin_'.$version);
                        
                        if ($op->call())
                            $id = $op->getOrderID();
                        else {
                            $error = $op->getErrorTexts();
                            $error = $error[0]['text'];
                        }
                    } catch (Exception $e) {
                        $error = $e->getMessage();
                    }

                    if (!empty($error)) {
                        echo json_encode(array('success' => 0, 'msg' => $error));
                    } else {
                        echo json_encode(array('success' => 1));
                    }

                    die();
                } else {
                    return "Certificate not found.";
                }

                return "success";

                break;
        }
        die();
    }

    $api = new PartnerAPIService($params['configoption1'], $params['configoption2'], $params['configoption10']);
    $op = $api->operationGetOrderStateByOrderID();
    $op->setOrderID($remoteid);
    $op->call();
    $tableVerificationSAN = '';
    $orderState = $op->getData();
    $buttonverify = '';
    
    $productid_SSLCertum = explode('|', $params['configoption3'])[0]; 
    
    if($orderState->orderStatus != NULL && $orderState->orderStatus != 'ENROLLED' && $orderState->orderStatus != 'REJECTED'
    && ($productid_SSLCertum == '601' || $productid_SSLCertum == '631' || $productid_SSLCertum == '641' 
        || $productid_SSLCertum == '681' || $productid_SSLCertum == '691' || $productid_SSLCertum == '741' 
        || $productid_SSLCertum == '961' || $productid_SSLCertum == '971' || $productid_SSLCertum == '981')        
    )
    {
        $op2 = $api->operationGetSanVerificationState();
        $op2->setOrderID($remoteid);
        $op2->call();

        $verificationSANs = $op2->getSanVerifications();
        
        $buttonverify = '<button style="margin-left:5px;" type="button" id="btnshowsanverify" class="btn btn-primary">Show domain verification</button>';
        $tableVerificationSAN = '<table class="table table-bordered"><tbody>';

        foreach($verificationSANs as $verificationSAN)
        {

            $statehtml = '';
            
            $expirydate = (string)$verificationSAN->manualVerification->expireDate;
            if(!empty($expirydate))
            {
                $expirydate = ' - Expire Date: '.date('Y-m-d H:i:s', strtotime($expirydate));
            }
            
            $state = (string)$verificationSAN->manualVerification->state;
            if($state == 'VERIFIED')
            {
                $statehtml = '<span style="font-size:15px;" class="label label-success">'.$state.'</span>'.$expirydate;
            }
            else 
            {
                $statehtml = $state.$expirydate;
            }


            $systemVerifyError = (array)$verificationSAN->systemVerification->method;

            $systemverificationhtml = '';
            if(!empty($systemVerifyError))
            {
                $systemverificationhtml = '<tr><td>System verification errors</td><td>'. implode(',', $systemVerifyError).'</td></tr>';
            }


            $info = (string)$verificationSAN->manualVerification->info;

            $manualverificationhtml = '';
            if(!empty($info))
            {
                $manualverificationhtml = '<tr><td>Manual verification errors</td><td>'.$info.'</td></tr>';
            }

            $tableVerificationSAN .= '
                                    <tr>
                                        <td style="background:#ddd;font-weight:700;">Domain</td><td style="background:#ddd;font-weight:700;">'.$verificationSAN->FQDN.'</td>
                                    </tr>
                                    <tr>
                                        <td>Manual verification state</td><td>'.$statehtml.'</td>
                                    </tr>'.$manualverificationhtml.$systemverificationhtml;
        }
        $tableVerificationSAN .= '</tbody></table>';
    }
        
         
         
         if($orderState->orderStatus != NULL)
         {
         $stateTableVerification = '';
         
        
         
         foreach($orderState->verifications->verification as $ver)
         {
             $exptext = '';
             if($ver->expireDate != NULL)
             {
                 $exptext = ' - Expire Date: '.date('Y-m-d H:i:s', strtotime($ver->expireDate));
             }
             
             $stateTableVerification .= '<tr><td>'.$ver->type.'</td>
                                        <td>'.$ver->state.$exptext.'</td></tr>';
         }
          
         
         $statusLabel = 'default';
         if($orderState->orderStatus == 'ENROLLED')
         {
             $statusLabel = 'success';
         }
         
         $stateTable = '<table class="table table-bordered">
             
                        <tbody>
                            
                            <tr>
                                <td>Order Status</td>
                                <td><div style="font-size:15px;" class="label label-'.$statusLabel.'">'.$orderState->orderStatus.'</div></td>
                            </tr>
                            <tr>
                                <td>Last Update Date</td>
                                <td>'.date('Y-m-d H:i:s', strtotime($orderState->lastUpdateDate)).'</td>
                            </tr>
                            
                            '.$stateTableVerification.'

                        </tbody>


                        </table>';
         }
         
    $sslService = new SslService($params['serviceid']);
	$sslService->setApiHandler($api);
    $allCert = $sslService->getCertificates();

    $csrrenew = '';
    $rr = DB::table('certum_renewals')->where('serviceid', '=', $params['serviceid'])->first();
    if($isAddon)
    {
        $rr = DB::table('certum_renewals')->where('addonid', '=', $params['addonId'])->first();
    }
    if(isset($rr->csr) && !empty($rr->csr))
    {
        $csrrenew = $rr->csr;
    }
    
         if($orderState->orderStatus != NULL)
         {
    
    $orderStateJS = "<script type='text/javascript'>
                            jQuery('body').unbind('click').on('click','#btnshowstate', function(){
                                jQuery('#order-state').toggle();
                            });
                            jQuery('body').on('click','#btnshowsanverify', function(){
                                jQuery('#san-state').toggle();
                            });
                    </script>";
    $orderStateHtml = '<div id="order-state" style="margin-top:20px;display:none;">'.$stateTable.'</div>
                       <div id="san-state" style="margin-top:20px;display:none;">'.$tableVerificationSAN.'</div>';
         }
         
        if($r->status == null)
        {
            $r->status = '';       
        }   
         
         if($orderState->orderStatus != NULL)
         {
                   $fieldsarray = array(
        "Order State"              => $orderStateJS.'<button type="button" id="btnshowstate" class="btn btn-primary">Show order state</button>'.$buttonverify.$orderStateHtml,
        "Renew CSR (only for recurring products)"                => '<textarea class="form-control" style="width:50%;height:400px;" name="csr_renew">'.$csrrenew.'</textarea>',
        "Order ID"                 => $remoteid,
        "SSL Configuration Status" => $r->status,
    );
         }
         else
         {
              $fieldsarray = array(
        "Renew CSR (only for recurring products)"                => '<textarea class="form-control" style="width:50%;height:400px;" name="csr_renew">'.$csrrenew.'</textarea>',
        "Order ID"                 => $remoteid,
        "SSL Configuration Status" => $r->status,
    );
         }
         
   

    $lastcsr = $sslService->getLastCertificateSerialNumber();

    $buttons = '';
    $latestStartDate = "2000-01-01";
    foreach($allCert as $certsingle)
    {
        $dateTime = new DateTime($certsingle->certificateDetails->endDate);
        $enddate = $dateTime->format('Y-m-d H:i:s P');
        $dateTime = new DateTime($certsingle->certificateDetails->startDate);
        $startdate = $dateTime->format('Y-m-d H:i:s P');

        if(empty((string)$certsingle->certificateDetails->certificateStatus))
        {
            $buttons .= '<button style="margin-right:10px;" class="btn getCertDetails">Details</button>';
        }
        else
        {
            $buttons .= '<div style="margin-bottom:10px;margin-right:10px;background:#ddd;display: inline-block;padding: 6px 12px;font-size: 14px;font-weight: 400;line-height: 1.42857143;text-align: center;vertical-align: middle;background-image: none;border: 1px solid transparent;border-radius: 4px;" class="getCertDetails" data-id="'.$certsingle->certificateDetails->serialNumber.'">Details - '.$certsingle->certificateDetails->serialNumber.'<span style="display:block;font-size:10px;text-align:left;">Validity date: '.$startdate.' - '.$enddate.' Status: '.$certsingle->certificateDetails->certificateStatus.'</span></div>';

            $startdate = $dateTime->format('Y-m-d');
            if ($startdate > $latestStartDate)
            {
                $latestStartDate = $startdate;
            }
        }
    }

    $fieldsarray["X.506 Certificate"] = "<div>".$buttons."
                                            <textarea id='certDetails' style='display:none;width:700px;height:300px;margin-top:5px;' onclick='select();'></textarea>
                                            <script type='text/javascript'>
                                                jQuery(document).ready(function()
                                                {
                                                    jQuery('input[value=Renew]').removeAttr('onclick');
                                                    jQuery('.getCertDetails').click(function()
                                                    {
                                                        var certnumber = jQuery(this).attr('data-id');
                                                        jQuery.post(window.location.href, {'ajax': 1, 'action': 'getCertDetails', 'certnumber': certnumber}, function(data)
                                                        {
                                                            if(data.result  == 1)
                                                            {
                                                                jQuery('#certDetails').html(data.cert).show();
                                                            } else
                                                            {
                                                                alert(data.msg);
                                                            }
                                                        },'json');
                                                        return false;
                                                    });

                                                    jQuery('input[value=Renew]').click(function(){
                                                        jQuery( '#renewModal' ).dialog({width: 500} );
                                                        return false;
                                                    });

                                                    jQuery('.renewCert').click(function(){
                                                        jQuery.post(window.location.href,
                                                            {'ajax':1,'action':'renewCert','serial': jQuery('input[name=\"renew[serial]\"]').val(),'pem': jQuery('textarea[name=\"renew[pem]\"]').val(), 'csr': jQuery('textarea[name=\"renew[csr]\"]').val()},
                                                            function(data){
                                                                jQuery('.successbox,.errorbox').remove();
                                                                if(data.success == 1)
                                                                {
                                                                    jQuery('#modcmdresult').after('<div class=\"successbox\"><strong><span class=\"title\">Module Command Success</span></strong><br>Action Completed Successfully</div>');
                                                                } else {
                                                                    jQuery('#modcmdresult').after('<div class=\"errorbox\"><strong><span class=\"title\">Module Command Error</span></strong><br>'+data.msg+'</div>');
                                                                }
                                                            },'json');
                                                        return false;
                                                    });

                                                    jQuery( document ).ajaxStart(function() {
                                                        jQuery('#loader').show();
                                                    }).ajaxStop(function() { jQuery('#loader').hide(); });




                                                });
                                              </script>
                                              <div id='renewModal' title='Renew Certificate' >
                                                    <div class='row'><label>Serial Number</label> <input type='text' name='renew[serial]' /></div>
                                                    <div class='row'><label>PEM</label> <textarea name='renew[pem]'></textarea></div>
                                                    <div class='row'><label>CSR</label> <textarea name='renew[csr]'></textarea></div>
                                                    <div class='row'><label>&nbsp;</label> <input type='submit' class='renewCert btn' value='Renew Certificate' /> <span id='loader' style='display:none;'><img src='images/loader.gif' alt='' /></span></div>
                                              </div>
                                              <style type='text/css'>
                                                #renewModal {
                                                    width:500px;
                                                    padding: 10px;
                                                    display:none;
                                                }
                                                #renewModal .row {
                                                    margin-bottom:10px;
                                                    display:block;
                                                    clear:both;
                                                }

                                                #renewModal .row label {
                                                    width:150px;
                                                    float:left;
                                                }

                                                #renewModal .row input[type=text] {
                                                    width:300px;
                                                }

                                                #renewModal .row textarea {
                                                    width:300px;
                                                    height:100px;
                                                }
                                                </style>

        "
    ;

    $approvemethod = '<option>FILE</option>
                            <option>DNS_TXT</option><option>DNS_CNAME</option><option>DNS_TXT_PREFIX</option><option>DNS_CNAME_PREFIX</option>
                            <option>ADMIN</option>';
    
    try{

        $op = $api->operationGetSanVerificationState();
        $op->setOrderID($r->remoteid);
        $op->call();
        $dataSanVerifications = $op->getSanVerifications();

        foreach($dataSanVerifications as $domainver)
        {
            if (strpos($domainver->FQDN, '*.') !== false) 
            {
                $approvemethod = '<option>DNS_TXT</option><option>DNS_CNAME</option><option>DNS_TXT_PREFIX</option><option>DNS_CNAME_PREFIX</option>
                            <option>ADMIN</option>';
            }
        }

    } catch (\Exception $e) {


    }

    $pid = explode('|', $params['configoption3']);
    $productsWithoutApprovers = CERTUM_Certificates_CodeSigning() + CERTUM_Certificates_IDCerts();
    $approvers = '';
    $simplysign = false;
    if(isset($productsWithoutApprovers[$pid[0]]) && !empty($productsWithoutApprovers[$pid[0]]))
    {
        $approvers = '$(".approvers_visible").remove();';
    }
    if($pid[0] == '831' || $pid[0] == '832' || $pid[0] == '833' ||
        $pid[0] == '316' || $pid[0] == '317' || $pid[0] == '318' ||
        $pid[0] == '281' || $pid[0] == '282' || $pid[0] == '283')
    {
        $simplysign = '<div class="row"><div class="form-group col-sm-12 col-xs-12">
                 <label>SimplySign Account</label>
                 <input type="email" name="simplysign" class="form-control" placeholder="sample@email.com" style="width: 260px;">
             </div></div>';
    }

    if (empty($lastcsr))
    {
        $revocationError = '<tr><div class="alert alert-danger" role="alert">Certificate cannot be revoked!</div></tr>';
    }

    if ( $pid[0] == '631' || $pid[0] == '681' || $pid[0] == '721' || $pid[0] == '722' || $pid[0] == '723' || $pid[0] == '831'
        || $pid[0] == '832' || $pid[0] == '833' || $pid[0] == '971'
        || $pid[0] == '281' || $pid[0] == '282' || $pid[0] == '283' || $pid[0] == '641' || $pid[0] == '981'|| $pid[0] == '316'
        || $pid[0] == '317' || $pid[0] == '318' || $pid[0] == '511' || $pid[0] == '512' || $pid[0] == '521' || $pid[0] == '522' || $pid[0] == '531' || $pid[0] == '532')
    {
        $affiliationChanged = '<div style="position: relative">' .
            '<input type="radio" class="reasonRadio" id="AFFILIATIONCHANGED" name="reason" value="AFFILIATIONCHANGED" style="margin-right: 5px;">' .
            '<label>Subject'. "' " .'s name, organization name or address included in the certificate has changed</label>' .
            '</div>';
    }

    $modalParams = [
        "approvemethod" => $approvemethod,
        "productId" => $params['packageid'],
        "serviceId" => $params['serviceid'],
        'simplysign' => $simplysign,
        'approvers' => $approvers,
        'certumpid' => $pid[0],
        "serial" => trim((string) $lastcsr['number']),
        'affiliationChanged' => $affiliationChanged,
        'today' => date('Y-m-d'),
        'startDate' => $latestStartDate,
        'revocationError' => $revocationError,
    ];
    
    $reissueTpl = new Template("modals/reissue_adminarea.tpl");
    $reissueCertificateView = $reissueTpl->merge($modalParams);

    $revokeTpl = new Template("modals/revoke_adminarea.tpl");
    $revokeCertificateView = $revokeTpl->merge($modalParams);

    $fieldsarray['X.506 Certificate'] .= $reissueCertificateView;
    $fieldsarray['X.506 Certificate'] .= $revokeCertificateView;

    $fieldsarray['Intermediate Certificate'] = "<div><button id='getIntermediateCertDetails' class='btn'>Details</button></div>
                                                <textarea id='certIntermediateDetails' style='display:none;width:700px;height:300px;margin-top:5px;' onclick='select();'></textarea>
                                                <script type='text/javascript'>
                                                    jQuery(document).ready(function()
                                                    {
                                                        jQuery('#getIntermediateCertDetails').click(function()
                                                        {
                                                            jQuery.post(window.location.href, {'ajax': 1, 'action': 'getIntermediateCertDetails'}, function(data)
                                                            {
                                                                if(data.result  == 1)
                                                                {
                                                                    jQuery('#certIntermediateDetails').html(data.intermediate_cert).show();
                                                                } else
                                                                {
                                                                    alert(data.msg);
                                                                }
                                                            },'json');
                                                            return false;
                                                        });
                                                    });
                                              </script>";
    $fieldsarray['Root Certificate'] = "<div><button id='getRootCertDetails' class='btn'>Details</button></div>
                                                <textarea id='certRootDetails' style='display:none;width:700px;height:300px;margin-top:5px;' onclick='select();'></textarea>
                                                <script type='text/javascript'>
                                                    jQuery(document).ready(function()
                                                    {
                                                        jQuery('#getRootCertDetails').click(function()
                                                        {
                                                            jQuery.post(window.location.href, {'ajax': 1, 'action': 'getRootCertDetails'}, function(data)
                                                            {
                                                                if(data.result  == 1)
                                                                {
                                                                    jQuery('#certRootDetails').html(data.root_cert).show();
                                                                } else
                                                                {
                                                                    alert(data.msg);
                                                                }
                                                            },'json');
                                                            return false;
                                                        });
                                                    });
                                              </script>";

    } catch (\Exception $exf) {
        
        $fieldsarray = [];
        $fieldsarray['Error'] = '<span class="label label-danger">'.$exf->getMessage().'</span>'."<script type='text/javascript'>
                                                    jQuery(document).ready(function()
                                                    {
                                                        $('#modcmdbtns').remove();
                                                    });
                                              </script>";
        DB::table('tblhosting')->where('id', $params['serviceid'])->update(['domainstatus' => 'Pending']);
        
    }

    $pid = explode('|', $params['configoption3']);
    $allProducts = CERTUM_Certificates_ProductsAvailable();
    if(!isset($allProducts[$pid[0]]))
    {
        unset($fieldsarray['Renew CSR (only for recurring products)']);
    }

    return $fieldsarray;
}

function CERTUM_Certificates_AdminCustomButtonArray($params) {
    
    $pid = explode('|', $params['configoption3']);


    $productsCertum = CERTUM_Certificates_CodeSigning()+CERTUM_Certificates_IDCerts();
    $productsMime =   CERTUM_Certificates_SMime();


    $buttonarray = array(
        "Renew Certificate"          => "customRenew",
        "Resend Configuration Email" => "resend",
        //"Change verification" => "changeverification",
        "Resend Notifications Email" => "resendnotification",
        "Send Certificate"           => "sendcertificate",
        //"Renew"                      => "Renew",
        "Reissue"                    => "Reissue", ## added by Vitalii Aloksa
        "Cancel Order"               => "cancelOrder" ## added by Vitalii Aloksa
    );
    
    if(!isset($productsCertum[$pid[0]]) || empty($productsCertum[$pid[0]]))
    {
       $buttonarray = array(
            "Renew Certificate"                      => "customRenew",
            "Resend Configuration Email" => "resend",
            "Change/resend verification" => "changeverification",
            "Send Certificate"           => "sendcertificate",
            //"Renew"                      => "Renew",
            "Reissue"                    => "Reissue", ## added by Vitalii Aloksa
            "Cancel Order"                    => "cancelOrder" ## added by Vitalii Aloksa
        );
    }

    if(isset($productsMime[$pid[0]]) && !empty($productsMime[$pid[0]]))
    {
        $buttonarray = array(
            "Renew Certificate"                      => "customRenew",
            "Resend Configuration Email" => "resend",
            "Resend Notifications Email" => "resendnotification",
            "Send Certificate"           => "sendcertificate",
            //"Send Certificate"           => "sendcertificate",
            //"Renew"                      => "Renew",
            "Reissue"                    => "Reissue", ## added by Vitalii Aloksa
            "Cancel Order"                    => "cancelOrder" ## added by Vitalii Aloksa
        );
    }

    $allProducts = CERTUM_Certificates_ProductsAvailable();

    if(!isset($allProducts[$pid[0]]))
    {
        if(isset($buttonarray['Renew Certificate']))
        {
            unset($buttonarray['Renew Certificate']);
        }
        if(isset($buttonarray['Reissue']))
        {
            unset($buttonarray['Reissue']);
        }
        if(isset($buttonarray['Resend Notifications Email']))
        {
            unset($buttonarray['Resend Notifications Email']);
        }
        if(isset($buttonarray['Change/resend verification']))
        {
            unset($buttonarray['Change/resend verification']);
        }
    }

    return $buttonarray;
}

function CERTUM_Certificates_cancelOrder($params) {
    
    $isAddon = false;
    if(isset($params['addonId']) && !empty($params['addonId']))
    {
        $isAddon = true;
    }

    if($isAddon)
    {
        $details = DB::table('tblsslorders')->where('addon_id', '=', $params['addonId'])->first();
    }
    else
    {
        $details = DB::table('tblsslorders')->where('serviceid', '=', $params['serviceid'])->first();
    }

    $api = new PartnerAPIService($params['configoption1'], $params['configoption2'], $params['configoption10']);

    try {
        $op = $api->operationCancelOrder();
        $op->setOrderID($details->remoteid);

        if (!$op->call()) {
            $error = $op->getErrorTexts();
            return $error[0]['text'];
        }
    } catch (Exception $e) {
        return $e->getMessage();
    }

    return 'success';
    
}


/*
 * Added by Vitalli Aloksa
 */

function CERTUM_Certificates_Reissue($params)
{
    global $CONFIG;


    $pid = explode('|', $params['configoption3']);

    $allProducts = CERTUM_Certificates_ProductsAvailable();
    if(!isset($allProducts[$pid[0]]))
    {
        redir('action=productdetails&id='.$params['serviceid'], 'clientarea.php');
    }

    $product = new Product($params['pid']);
    $configuration = $product->getConfiguration();

    $methods = $product->getApproverMethods();

    $api = new PartnerAPIService($configuration->configoption1, $configuration->configoption2, $configuration->configoption10);

	$sslService = new SslService($params['serviceid']);
	$sslService->setApiHandler($api);

	$lastCsr = $sslService->getLastCertificateSerialNumber();

    $templateVars = [
        "methods" => $methods,
        "add_sans" => $configuration->configoption7,
        "productId" => $params['pid'],
        "serviceId" => $params['serviceid'],
        "serial_number" => trim((string) $lastCsr['number']),
        "SystemURL" => $CONFIG['SystemURL']
    ];

    $view = new View();
    $template = $view->loadTemplate("reissue_certificate.tpl", $templateVars);

    return array (
        'templatefile'  =>  'reissue',
        'breadcrumb'    =>  "",
        'vars'          =>  array('output' =>  $template)
    );
}

function CERTUM_Certificates_verifyCSRData() {
    if ($_REQUEST['CSR'] == '' && $_REQUEST['CSR_key'] == '' && $_REQUEST['CSR_serial'] == '') {
        return 'Please provide one of the parameter: CSR, Srial Number, Pem CSR';
    }
}

function CERTUM_Certificates_ClientAreaCustomButtonArray($params) {
    
    $r = DB::table('tblsslorders')->where('serviceid', '=', $params['serviceid'])->first();
    $remoteid = $r->remoteid;

    $api = new PartnerAPIService($params['configoption1'], $params['configoption2'], $params['configoption10']);
    $op = $api->operationGetOrderStateByOrderID();
    $op->setOrderID($remoteid);
    $op->call();
    $orderState = $op->getData();

    $adddomainverification = false;
    if($orderState->orderStatus != NULL && $orderState->orderStatus != 'ENROLLED' && $orderState->orderStatus != 'REJECTED')
    {
       $adddomainverification = true;
    }
    $orderstatebtn = false;
    if($orderState->orderStatus != NULL)
    {
        $orderstatebtn = true;
    }
    
    $pid = explode('|', $params['configoption3']);



    $productsCertum = CERTUM_Certificates_CodeSigning()+CERTUM_Certificates_IDCerts();

    $buttons = array
        (
        CERTUM_Certificates_translate('get_certificate')     => 'getcert',
        CERTUM_Certificates_translate('renew_csr')           => 'renewcsr',
        CERTUM_Certificates_translate('contact_management')  => 'editcontact',
        CERTUM_Certificates_translate('send_certificate')    => 'sendcertificate',
        CERTUM_Certificates_translate('resend_notification') => 'resendnotification',
        //CERTUM_Certificates_translate('change_verification')     => 'changeverification',
        CERTUM_Certificates_translate('reissue_certificate') => 'Reissue',
        "Revoke Certificate"         => "revokeCertificate",
        "Show order state"           => "showOrderState",
        "Show domain verification"   => "showDomainVerification"
    );
    
    if(!isset($productsCertum[$pid[0]]) || empty($productsCertum[$pid[0]]))
    {
       $buttons = array
            (
            CERTUM_Certificates_translate('get_certificate')     => 'getcert',
            CERTUM_Certificates_translate('renew_csr')           => 'renewcsr',
            CERTUM_Certificates_translate('contact_management')  => 'editcontact',
            CERTUM_Certificates_translate('send_certificate')    => 'sendcertificate',
            //CERTUM_Certificates_translate('resend_notification') => 'resendnotification',
            CERTUM_Certificates_translate('change_verification_resend')     => 'changeverification',
            CERTUM_Certificates_translate('reissue_certificate') => 'Reissue',
           "Revoke Certificate"         => "revokeCertificate",
           "Show order state"           => "showOrderState",
           "Show domain verification"   => "showDomainVerification"
        );
    }

    $productsMime =   CERTUM_Certificates_SMime();


    if(isset($productsMime[$pid[0]]) && !empty($productsMime[$pid[0]]))
    {
        $buttons = array
        (
            CERTUM_Certificates_translate('reissue_certificate') => 'Reissue',
            CERTUM_Certificates_translate('renew_csr')           => 'renewcsr',
            CERTUM_Certificates_translate('contact_management')  => 'editcontact',
            "Show order state"           => "showOrderState",
            CERTUM_Certificates_translate('resend_notification') => 'resendnotification',
            CERTUM_Certificates_translate('get_certificate')     => 'getcert',
            "Revoke Certificate"         => "revokeCertificate",
        );
    }


    if($orderstatebtn === false)
    {
        unset($buttons['Show order state']);
    }
    if($pid[0] != '601' && $pid[0] != '631' && $pid[0] != '641' 
        && $pid[0] != '681' && $pid[0] != '691' && $pid[0] != '741' 
        && $pid[0] != '961' && $pid[0] != '971' && $pid[0] != '981' || $adddomainverification === false)
    {
        unset($buttons['Show domain verification']);
    }
    
    if($params['configoption14'] != 'on')
    {
       $buttons[ CERTUM_Certificates_translate('renew')] = 'renewcert';
    }

    $allProducts = CERTUM_Certificates_ProductsAvailable();
    if(!isset($allProducts[$pid[0]]))
    {
        if(isset($buttons[CERTUM_Certificates_translate('renew_csr')]))
        {
            unset($buttons[CERTUM_Certificates_translate('renew_csr')]);
        }
        if(isset($buttons[CERTUM_Certificates_translate('reissue_certificate')]))
        {
            unset($buttons[CERTUM_Certificates_translate('reissue_certificate')]);
        }
        if(isset($buttons[CERTUM_Certificates_translate('renew')]))
        {
            unset($buttons[CERTUM_Certificates_translate('renew')]);
        }
    }

    return $buttons;
}

function CERTUM_Certificates_renewcert($params, $html = false) {
    $_LANG = CERTUM_Certificates_loadLanguage();


    $pid = explode('|', $params['configoption3']);

    $allProducts = CERTUM_Certificates_ProductsAvailable();
    if(!isset($allProducts[$pid[0]]))
    {
        redir('action=productdetails&id='.$params['serviceid'], 'clientarea.php');
    }

    $isAddon = false;
    if(isset($params['addonId']) && !empty($params['addonId']))
    {
        $isAddon = true;
    }
    $r = DB::table('tblsslorders')->where('serviceid', '=', $params['serviceid'])->first();
    if($isAddon)
    {
        $r = DB::table('tblsslorders')->where('addon_id', '=', $params['addonId'])->first();
    }
    
    if (empty($r->remoteid)) {
        return array
                    (
                    'templatefile' => 'renew',
                    'breadcrumb'   => '> <a href="#">Get cert</a>',
                    'vars'         => array
                        (
                        'lang' => $_LANG,
                        'error' => 'Certificate not found.'
                    )
                );

    }
    if (isset($_POST['doAction']) && $_POST['doAction'] == 'renew') {

        if(isset($_POST['simplysign']) && !empty($_POST['simplysign'])) {
            DB::table('tblconfiguration')->insert([
                'setting' => 'simplysign_certum_service_' . $params['serviceid'],
                'value' => $_POST['simplysign']
            ]);
        }
        $csr = (IS_WHMCS_73_OR_HIGHER) ? (array)json_decode($r->configdata) : unserialize($r->configdata);
        if(!empty($r->remoteid)){
            $pid = explode('|', $params['configoption3']);
            $renew = CERTUM_Certificates_ProductsRenew(); 
            $new = $renew[$pid[0]];
            if (!isset($new)) {

                return array
                    (
                    'templatefile' => 'renew',
                    'breadcrumb'   => '> <a href="#">Get cert</a>',
                    'vars'         => array
                        (
                        'lang' => $_LANG,
                        'error' => 'This certificate cannot be renewed.'
                    )
                );

            }

            if (empty($_POST['fields']['serial']) && empty($_POST['fields']['pem'])) {

                return array
                    (
                    'templatefile' => 'renew',
                    'breadcrumb'   => '> <a href="#">Get cert</a>',
                    'vars'         => array
                        (
                        'lang' => $_LANG,
                        'error' => 'Please fill field "serial" or "pem"'
                    )
                );

            }

            if (empty($_POST['fields']['csr'])) {

                return array
                    (
                    'templatefile' => 'renew',
                    'breadcrumb'   => '> <a href="#">Get cert</a>',
                    'vars'         => array
                        (
                        'lang' => $_LANG,
                        'error' => 'Please fill field "CSR"'
                    )
                );

            }
            
            if(isset($_POST['method']) &&
                (
                    $_POST['method'] == 'FILE' ||
                    $_POST['method'] == 'DNS' ||
                    $_POST['method'] == 'DNS_TXT' ||
                    $_POST['method'] == 'DNS_CNAME' ||
                    $_POST['method'] == 'DNS_TXT_PREFIX' ||
                    $_POST['method'] == 'DNS_CNAME_PREFIX'
                )
                && empty($_POST['emailaddress']))
            {
                return array
                    (
                    'templatefile' => 'renew',
                    'breadcrumb'   => '> <a href="#">Get cert</a>',
                    'vars'         => array
                        (
                        'lang' => $_LANG,
                        'error' => 'Please provide email address'
                    )
                );
            }
            
            if(isset($_POST['method']) &&
                (
                    $_POST['method'] == 'FILE' ||
                    $_POST['method'] == 'DNS' ||
                    $_POST['method'] == 'DNS_TXT' ||
                    $_POST['method'] == 'DNS_CNAME' ||
                    $_POST['method'] == 'DNS_TXT_PREFIX' ||
                    $_POST['method'] == 'DNS_CNAME_PREFIX'
                )
                && !filter_var($_POST['emailaddress'], FILTER_VALIDATE_EMAIL)) {
                return array
                    (
                    'templatefile' => 'renew',
                    'breadcrumb'   => '> <a href="#">Get cert</a>',
                    'vars'         => array
                        (
                        'lang' => $_LANG,
                        'error' => 'Email address is incorrect!'
                    )
                );
            }

            if($isAddon)
            {
                $infoCert = DB::table('certum_renewals')->where('addonid', '=', $params['addonId'])->count();
                $infoApprovers = DB::table('certum_approvers')->where('addonid', '=', $params['addonId'])->count();
            }
            else
            {
                $infoCert = DB::table('certum_renewals')->where('serviceid', '=', $params['serviceid'])->count();
                $infoApprovers = DB::table('certum_approvers')->where('serviceid', '=', $params['serviceid'])->count();
            }
            
            
            if ($infoApprovers == 0) {
                if($isAddon)
                {
                    $infoA = DB::table('certum_approvers')->insert([
                        'addonid' => $params['addonId'],
                        'data' => serialize([
                            'approvermethod' => $_POST['method'],
                            'approveremailprefix' => $_POST['emailprefix'],
                            'approveremailaddress' => $_POST['emailaddress'],
                            'approvenotification' => $_POST['approvenotification']
                        ])
                    ]);
                }
                else
                {
                    $infoA = DB::table('certum_approvers')->insert([
                        'serviceid' => $params['serviceid'],
                        'data' => serialize([
                            'approvermethod' => $_POST['method'],
                            'approveremailprefix' => $_POST['emailprefix'],
                            'approveremailaddress' => $_POST['emailaddress'],
                            'approvenotification' => $_POST['approvenotification']
                        ])
                    ]);
                }
            } else {
                if($isAddon)
                {
                    $infoA = DB::table('certum_approvers')
                            ->where('addonid', '=', $params['addonId'])
                            ->update([
                        'data' => serialize([
                            'approvermethod' => $_POST['method'],
                            'approveremailprefix' => $_POST['emailprefix'],
                            'approveremailaddress' => $_POST['emailaddress'],
                            'approvenotification' => $_POST['approvenotification']
                        ])
                    ]);
                }
                else
                {
                    $infoA = DB::table('certum_approvers')
                            ->where('serviceid', '=', $params['serviceid'])
                            ->update([
                        'data' => serialize([
                            'approvermethod' => $_POST['method'],
                            'approveremailprefix' => $_POST['emailprefix'],
                            'approveremailaddress' => $_POST['emailaddress'],
                            'approvenotification' => $_POST['approvenotification']
                        ])
                    ]);
                }               
            }
                

            if ($infoCert == 0) {
                if($isAddon)
                {
                    $info = DB::table('certum_renewals')->insert([
                        'addonid' => $params['addonId'],
                        'serial'    => $_POST['fields']['serial'],
                        'pem'       => $_POST['fields']['pem'],
                        'csr'       => $_POST['fields']['csr'],
                    ]);
                }
                else
                {
                    $info = DB::table('certum_renewals')->insert([
                        'serviceid' => $params['serviceid'],
                        'serial'    => $_POST['fields']['serial'],
                        'pem'       => $_POST['fields']['pem'],
                        'csr'       => $_POST['fields']['csr'],
                    ]);
                }
            } else {
                if($isAddon)
                {
                    $info = DB::table('certum_renewals')
                            ->where('addonid', '=', $params['addonId'])
                            ->update([
                        'serial' => $_POST['fields']['serial'],
                        'pem'    => $_POST['fields']['pem'],
                        'csr'    => $_POST['fields']['csr'],
                    ]);
                }
                else
                {
                    $info = DB::table('certum_renewals')
                            ->where('serviceid', '=', $params['serviceid'])
                            ->update([
                        'serial' => $_POST['fields']['serial'],
                        'pem'    => $_POST['fields']['pem'],
                        'csr'    => $_POST['fields']['csr'],
                    ]);
                }
            }
            // mysql_safequery("REPLACE INTO `certum_renewals` VALUES(?,?,?,?)", array($params['serviceid'], $_POST['fields']['serial'], $_POST['fields']['pem'], $_POST['fields']['csr']));

            $admin = DB::table('tbladmins')->select('username')->orderBy('roleid', 'asc')->first();

            if($isAddon)
            {
                $results = localAPI("geninvoices", array("clientid" => $_SESSION['uid'], 'addonids' => array($params['addonId'])), $admin->username);
            }
            else
            {
                $results = localAPI("geninvoices", array("clientid" => $_SESSION['uid'], 'serviceids' => array($params['serviceid'])), $admin->username);
            }

            if ($results['result'] == 'success' && $results['latestinvoiceid'] == 0) {
                return CERTUM_Certificates_Renew($params);
            } elseif ($results['latestinvoiceid'] > 0) {
                ob_clean();
                header("Location: viewinvoice.php?id=" . $results['latestinvoiceid']);
                die();
            }

            return "success";
        } else {

            return array
                (
                'templatefile' => 'renew',
                'breadcrumb'   => '> <a href="#">Get cert</a>',
                'vars'         => array
                    (
                    'lang' => $_LANG,
                    'error' => "Certificate not found."
                )
            );

        }

        return "success";
    }

    if($html)
    {
        return '

            <h3>'.$_LANG['renew'].'</h3>
            <form action="" method="post">
               <table class="table">
                   <tr>
                       <td>'.$_LANG['serial_number'].'</td>
                       <td><input type="text" name="fields[serial]" value="" /></td>
                   </tr>
                   <tr>
                       <td>'.$_LANG['pem'].'</td>
                       <td><textarea style="width:400px;height:150px;" name="fields[pem]"></textarea></td>
                   </tr>
                   <tr>
                       <td>'.$_LANG['csr'].'</td>
                       <td><textarea style="width:400px;height:150px;" name="fields[csr]" placeholder=""></textarea></td>
                   </tr>
               </table>
               <input type="submit" class="btn btn-success" value="'.$_LANG['renew'].'" />
               <input type="hidden" name="doAction" value="renew" />
            </form>

        ';
    }

    $pid = explode('|', $params['configoption3']);
    $productsWithoutApprovers = CERTUM_Certificates_CodeSigning() + CERTUM_Certificates_IDCerts();
    $approvers = true;
    $simplysign = false;
    if(isset($productsWithoutApprovers[$pid[0]]) && !empty($productsWithoutApprovers[$pid[0]]))
    {
        $approvers = false;
    }
    if($pid[0] == '831' || $pid[0] == '832' || $pid[0] == '833' ||
       $pid[0] == '316' || $pid[0] == '317' || $pid[0] == '318' ||
       $pid[0] == '281' || $pid[0] == '282' || $pid[0] == '283')
    {
        $simplysign = true;
    }

    return array
        (
        'templatefile' => 'renew',
        'breadcrumb'   => '> <a href="#">Get cert</a>',
        'vars'         => array
            (
            'lang' => $_LANG,
            'approvers' => $approvers,
            'simplysign' => $simplysign
        )
    );
}

function CERTUM_Certificates_renewcsr($params, $html = false) {


    $pid = explode('|', $params['configoption3']);

    $allProducts = CERTUM_Certificates_ProductsAvailable();
    if(!isset($allProducts[$pid[0]]))
    {
        redir('action=productdetails&id='.$params['serviceid'], 'clientarea.php');
    }


    $_LANG = CERTUM_Certificates_loadLanguage();
    $error = '';
    $success = '';
    if($_POST['renew_csr'])
    {
        $data = openssl_csr_get_subject($_POST['renew_csr']);

        if($data !== false)
        {
            $check = DB::table('certum_renewals')->where('serviceid', '=', $params['serviceid'])->first();

            if(isset($check->serviceid))
            {
                DB::table('certum_renewals')->where('serviceid', '=', $params['serviceid'])->update(array('csr' => $_POST['renew_csr']));
            }
            else
            {
                DB::table('certum_renewals')->insert(array('csr' => $_POST['renew_csr'], 'serviceid' => $params['serviceid']));
            }
            $success = 'CSR has been updated.';
        }
        else
        {
            $error = 'Incorrect CSR.';
        }
    }

    $renewcsr = DB::table('certum_renewals')->where('serviceid', $params['serviceid'])->first();

    $newcsr = '';
    if(isset($renewcsr->csr) && !empty($renewcsr->csr))
    {
        $newcsr = $renewcsr->csr;
    }

    return array
        (
        'templatefile' => 'renewcsr',
        'breadcrumb'   => '> <a href="#">Get cert</a>',
        'vars'         => array
            (
            'lang' => $_LANG,
            'newcsr' => $newcsr,
            'error' => $error,
            'success' => $success
        )
    );


}

function CERTUM_Certificates_changeverification($params, $html = false) {

    $pid = explode('|', $params['configoption3']);

    $allProducts = CERTUM_Certificates_ProductsAvailable();
    if(!isset($allProducts[$pid[0]]))
    {
        redir('action=productdetails&id='.$params['serviceid'], 'clientarea.php');
    }


    $_LANG = CERTUM_Certificates_loadLanguage();

    $isAddon = false;
    if(isset($params['addonId']) && !empty($params['addonId']))
    {
        $isAddon = true;
    }

    if($isAddon)
    {
        $r = DB::table('tblsslorders')->where('addon_id', $params['addonId'])->first();
        $certum_approvers = DB::table('certum_approvers')->where('addonid', $params['addonId'])->first();
        $r->approver_details = $certum_approvers->data;
    }
    else
    {
        $r = DB::table('tblsslorders')
                ->where('tblsslorders.serviceid', '=', $params['serviceid'])
                ->first();
    }

    $api = new PartnerAPIService($params['configoption1'], $params['configoption2'], $params['configoption10']);
    $pid = explode('|', $params['configoption3']);
    
    
    $wildcardcheck = false;
    
    try{

        $op = $api->operationGetSanVerificationState();
        $op->setOrderID($r->remoteid);
        $op->call();
        $dataSanVerifications = $op->getSanVerifications();

        foreach($dataSanVerifications as $domainver)
        {
            if (strpos($domainver->FQDN, '*.') !== false) 
            {
                $wildcardcheck = true;
            }
        }

    } catch (\Exception $e) {


    }

    if (isset($_POST['doAction']) && $_POST['doAction'] == 'changeverification') {
        

        $op = $api->operationChangeVerification();

        if (empty($r->remoteid)) {
            $error = "Certificate not found.";
        }

        $op->setOrderID($r->remoteid);
        
        $op->setSANApprover($_POST['method'], $_POST['emailaddress'], $_POST['emailprefix'], $_POST['approvenotification']);
        
        try {

            if ($op->call()) {

                if(empty($op->getErrorTexts())){

                    return "success";
                }
            } else {
                $error = $op->getErrorTexts();
                return $error[0]['text'];
            }
            
        } catch (Exception $e) {
            return $e->getMessage();
        }
    }
    $approve_method = CERTUM_get_approved_method($pid[0]);
    if($wildcardcheck === true)
    {
        $approve_method = str_replace('<option>FILE</option>', '', $approve_method);
    }
    
    return array
        (
        'templatefile' => 'changeverification',
        'breadcrumb'   => '> <a href="#">Get cert</a>',
        'vars'         => array
            (
            'lang'           => $_LANG,
            'serviceid'      => $params['serviceid'],
            'wildcard'       => $params['configoption9'],
            'validation'     => $params['configoption8'],
            'approve_method' => $approve_method,

        )
    );
}

/**
 * Display certificate in client area
 * @param type $params
 * @return type
 */
function CERTUM_Certificates_getcert($params, $html = false) {

    $_LANG = CERTUM_Certificates_loadLanguage();
    $code_lang = CERTUM_Certificates_loadLanguage(true);

    $isAddon = false;
    if(isset($params['addonId']) && !empty($params['addonId']))
    {
        $isAddon = true;
    }

    if($isAddon)
    {
        $r = DB::table('tblsslorders')->where('addon_id', '=', $params['addonId'])->first();
    }
    else
    {
        $r = DB::table('tblsslorders')->where('serviceid', '=', $params['serviceid'])->first();
    }


    if (empty($r->remoteid)) {
        return "Certificate not found.";
    }


    $api = new PartnerAPIService($params['configoption1'], $params['configoption2'], $params['configoption10'], $code_lang);
    try {
        $op = $api->operationGetOrderByOrderID();
        $op->setOrderID($r->remoteid)->setOrderStatus(TRUE)->setCertificateDetails(TRUE)->setOrderDetails(TRUE);

        if ($op->call()) {
            $cert = $op->getOrders();
            $allCert = $cert;
            $cert = $cert[0];

            $certs = array();

            foreach($allCert as $singlecert)
            {
                $dateTime = new DateTime($singlecert->certificateDetails->endDate);
                $enddate = $dateTime->format('Y-m-d H:i:s P');
                $dateTime = new DateTime($singlecert->certificateDetails->startDate);
                $startdate = $dateTime->format('Y-m-d H:i:s P');
                $certs[] = array(
                    'certificate' => $singlecert->certificateDetails->X509Cert,
                    'serialnumber' => $singlecert->certificateDetails->serialNumber,
                    'enddate' => $enddate,
                    'startdate' => $startdate,
                    'status' => $singlecert->certificateDetails->certificateStatus
                );
            }

            $opGetCaBundle = $api->operationGetCertificate();
            $opGetCaBundle->setOrderID($r->remoteid);
            if($opGetCaBundle->call())
            {
                $caBundle = $opGetCaBundle->getCaBundle();
                $intermediate_cert = $caBundle->getX509Cert()[0];
                $root_cert = $caBundle->getX509Cert()[1];
            }
            if ($_GET['save'] == 'yes') {

                foreach($certs as $c)
                {
                    if($_GET['number'] == $c['serialnumber'])
                    {
                        $cert = $c['certificate'];
                    }
                }

                ob_clean();
                header('Content-Disposition: attachment; filename="' . $params['domain'] . '_'.$_GET['number'].'.cer"');
                echo "-----BEGIN CERTIFICATE-----\n" . trim((string) $cert) . "\n-----END CERTIFICATE-----";
                die();
            }
            if ($_GET['intermediate_save'] == 'yes') {
                ob_clean();
                header('Content-Disposition: attachment; filename="' . $params['domain'] . '_intermediate.cer"');
                echo trim((string) $intermediate_cert);
                die();
            }
            if ($_GET['root_save'] == 'yes') {
                ob_clean();
                header('Content-Disposition: attachment; filename="' . $params['domain'] . '_root.cer"');
                echo trim((string) $root_cert);
                die();
            }

            $csr = (string) $cert->certificateDetails->X509Cert;

            if (empty($csr)) {
                throw new Exception('Unable to get the certificate');
            }


            if($isAddon)
            {
                if($html)
                {

                    $certforeach = '';
                    foreach($certs as $c)
                    {
                        $certforeach .= '
                            <h3>'.$_LANG['your_certificate'].' '.$c['serialnumber'].'</h3><span style="display: block;margin-top:-10px;margin-bottom: 5px;">'.$_LANG['validity_date'].' '.$c['startdate'].' - '.$c['enddate'].'</span>
                            <textarea style="width: 100%; height: 300px" readonly>-----BEGIN CERTIFICATE-----
                            '.$c['certificate'].'
                                -----END CERTIFICATE-----</textarea>
                            <br >
                            <p style="margin-top: 10px">
                                <a href="clientarea.php?action=productdetails&id='.$params['serviceid'].'&moduleaction=getcert&save=yes&number='.$c['serialnumber'].'#tabAddons" class="btn btn-mini btn-info"><i class="icon-download-alt"></i> '.$_LANG['download'].'</a>
                            </p>
                        ';
                    }



                    return '

                        <a href="clientarea.php?action=productdetails&id='.$params['serviceid'].'#tabAddons" class="btn btn-mini"><i style="font-size:16px" class="fa">&#xf060;</i> '.$_LANG['back'].'</a>
                        '.$certforeach.'
                        <h3>'.$_LANG['intermediate_certificate'].'</h3>
                        <textarea style="width: 100%; height: 300px" readonly>'.trim((string) $intermediate_cert).'</textarea>
                        <br >
                        <p style="margin-top: 10px">
                            <a href="clientarea.php?action=productdetails&id='.$params['serviceid'].'&moduleaction=getcert&intermediate_save=yes#tabAddons" class="btn btn-mini btn-info"><i class="icon-download-alt"></i> '.$_LANG['download'].'</a>
                        </p>
                        <h3>'.$_LANG['root_certificate'].'</h3>
                        <textarea style="width: 100%; height: 300px" readonly>'.trim((string) $root_cert).'</textarea>
                        <br >
                        <p style="margin-top: 10px">
                            <a href="clientarea.php?action=productdetails&id='.$params['serviceid'].'&moduleaction=getcert&root_save=yes#tabAddons" class="btn btn-mini btn-info"><i class="icon-download-alt"></i> '.$_LANG['download'].'</a>
                        </p>

                    ';


                }


                return array
                    (
                    'templatefile' => 'getcert',
                    'breadcrumb'   => '> <a href="#">Get cert</a>',
                    'vars'         => array
                        (
                        'certs' => $certs,
                        'cert'      => "-----BEGIN CERTIFICATE-----\n" . trim((string) $cert->certificateDetails->X509Cert) . "\n-----END CERTIFICATE-----",
                        'intermediate_cert' => trim((string) $intermediate_cert),
                        'root_cert' => trim((string) $root_cert),
                        'lang'      => $_LANG,
                        'serviceid' => $params['addonId']
                    )
                );
            }
            else
            {
                return array
                    (
                    'templatefile' => 'getcert',
                    'breadcrumb'   => '> <a href="#">Get cert</a>',
                    'vars'         => array
                        (
                        'certs' => $certs,
                        'cert'      => "-----BEGIN CERTIFICATE-----\n" . trim((string) $cert->certificateDetails->X509Cert) . "\n-----END CERTIFICATE-----",
                        'intermediate_cert' => trim((string) $intermediate_cert),
                        'root_cert' => trim((string) $root_cert),
                        'lang'      => $_LANG,
                        'serviceid' => $params['serviceid']
                    )
                );
            }
        } else {
            $error = $op->getErrorTexts();
            return $error[0]['text'];
        }
    } catch (Exception $e) {
        return $e->getMessage();
    }
}

/**
 * Renew certificate. This function should be called automatically
 * @param type $params
 * @return type
 */
function CERTUM_Certificates_Renew($params) {

    $isAddon = false;
    if(isset($params['addonId']) && !empty($params['addonId']))
    {
        $isAddon = true;
    }

    if($isAddon)
    {
        $r = DB::table('tblsslorders')->where('addon_id', $params['addonId'])->first();
        $certum_renewals = DB::table('certum_renewals')->where('addonid', $params['addonId'])->first();
        $r->newcsr = $certum_renewals->csr;
        $r->pem = $certum_renewals->pem;
        $r->serial = $certum_renewals->serial;
    }
    else
    {
        $r = DB::table('tblsslorders')
            ->select('tblsslorders.*', 'certum_renewals.*', 'certum_renewals.csr as newcsr')
            ->join('certum_renewals', 'certum_renewals.serviceid', '=', 'tblsslorders.serviceid')
            ->where('tblsslorders.serviceid', '=', $params['serviceid'])
            ->first();
    }

    if(!isset($r->remoteid) || empty($r->remoteid))
    {
        $r = DB::table('tblsslorders')->where('serviceid', $params['serviceid'])->first();
    }


    $pid = explode('|', $params['configoption3']);

    $allProducts = CERTUM_Certificates_ProductsAvailable();
    if(!isset($allProducts[$pid[0]]))
    {
        return 'This product is no longer available.';
    }


    $api = new PartnerAPIService($params['configoption1'], $params['configoption2'], $params['configoption10']);
    $certs = array();

    $customerID = '';

    try {
        $op = $api->operationGetOrderByOrderID();
        $op->setOrderID($r->remoteid)->setOrderStatus(TRUE)->setCertificateDetails(TRUE)->setOrderDetails(TRUE);

        if ($op->call()) {
            $cert = $op->getOrders();

            foreach($cert as $c)
            {
                if($c->certificateDetails->certificateStatus == 'VALID')
                {
                  $dateTime = new DateTime($c->certificateDetails->startDate);
                  $startdate = $dateTime->format('Y-m-d H:i:s');
                  $certs[] = array(
                      'status' => $c->certificateDetails->certificateStatus,
                      'date' => $startdate,
                      'time' => strtotime($startdate),
                      'number' => $c->certificateDetails->serialNumber
                  );
                }

                if(empty($customerID))
                {
                  $customerID = $c->orderStatus->customer;
                }
            }

        }
    } catch (Exception $e) {
        return $e->getMessage();
    }
    
    $renewclientserial = false;
    if(isset($r->serial) && !empty($r->serial))
    {
        $renewclientserial = $r->serial;
    }
    
    $csr = (IS_WHMCS_73_OR_HIGHER) ? (array)json_decode($r->configdata) : unserialize($r->configdata);
    if(isset($r->newcsr) && !empty($r->newcsr))
    {
        $certsnew = array_sort_new($certs, 'time', SORT_DESC);
        $r->serial = reset($certsnew)['number'];
        $csr = $r->newcsr;
    }
    else
    {
        $csr = trim($csr['csr']);
        $certsnew = array_sort_new($certs, 'time', SORT_DESC);
        $r->serial = reset($certsnew)['number'];
    }

    $api = new PartnerAPIService($params['configoption1'], $params['configoption2'], $params['configoption10']);
    try {
        $pid = explode('|', $params['configoption3']);
        $renew = CERTUM_Certificates_ProductsRenew();
        $new = $renew[$pid[0]];
        if (!isset($new)) {
            return 'This certificate cannot be renewed.';
        }

        $op = $api->operationRenewCertificate();
        
        if($isAddon)
        {
            $approversData = DB::table('certum_approvers')->where('addonid', $params['addonId'])->first();
        }
        else
        {
            $approversData = DB::table('certum_approvers')->where('serviceid', $params['serviceid'])->first();
        }
        
        $approversData = unserialize($approversData->data);

        if(!empty($approversData['approvermethod'])) {
            $op->setSANApprover($approversData['approvermethod'], $approversData['approveremailaddress'], $approversData['approveremailprefix'], $approversData['approvenotification']);
        }
        
        $op->setCSR($csr);
        if (isset($r->pem) && !empty($r->pem)) {
            $op->setX509Cert($r->pem);
        } elseif (isset($r->serial) && !empty($r->serial)) {
            $op->setSerialNumber($r->serial);
        }
        if($renewclientserial && empty($r->serial))
        {
            $op->setSerialNumber($renewclientserial);
        }

        $customer = md5(\MGModule\CERTUM_Certificates\helpers\Customer::getCustomerHash($params['userid']));

        if(empty($customerID))
        {
          $customerID = $customer;
        }

        $simplysing = DB::table('tblconfiguration')->where('setting','simplysign_certum_service_'.$params['serviceid'])->first();
        if(isset($simplysing->value) && !empty($simplysing->value))
        {
            $customerID = $simplysing->value;
            DB::table('tblconfiguration')->where('setting','simplysign_certum_service_'.$params['serviceid'])->delete();
        }

        $op->setCustomer($customerID)->setProductCode($new);
        
        require_once dirname(__FILE__).DIRECTORY_SEPARATOR.'version.php';
        global $CONFIG;
        $op->setUserAgent($_SERVER['HTTP_USER_AGENT'].'_WHMCS_'.$CONFIG['Version'].'_Plugin_'.$version);
        
        if ($op->call()) {

            CERTUM_change_next_due_date($params);

            $order_id = (string) $op->getOrderID();

            if ($order_id != "") {

                if($isAddon)
                {

                    DB::table('certum_renewals')
                        ->where('addonid', '=', $params['addonId'])
                        ->update([
                        'csr' => '',
                    ]);


                    DB::table('tblsslorders')
                        ->where('addon_id', '=', $params['addonId'])
                        ->update([
                        'remoteid'  => $order_id,
                        'addon_id' => $params['addonId'],
                    ]);
                }
                else
                {

                    DB::table('certum_renewals')
                        ->where('serviceid', '=', $params['serviceid'])
                        ->update([
                        'csr' => '',
                    ]);

                    DB::table('tblsslorders')
                        ->where('serviceid', '=', $params['serviceid'])
                        ->update([
                        'remoteid'  => $order_id,
                        'serviceid' => $params['serviceid'],
                    ]);
                }
            }
        } else {
            $error = $op->getErrorTexts();

            if(!isset($error[0]['text']) || empty($error[0]['text']))
            {
                return 'Unknown error, please check the logs.';
            }

            return $error[0]['text'];
        }
    } catch (Exception $e) {
        return $e->getMessage();
    }

    return 'success';
}

/**
 * Display details about cert in client area
 * @param type $params
 * @return string
 */
function CERTUM_Certificates_ClientArea($params) {

   global $CONFIG;

   if(isset($_REQUEST['modop']) && $_REQUEST['modop'] == 'custom' && isset($_REQUEST['a']) && $_REQUEST['a'] == 'editcontact')
   {
       return CERTUM_Certificates_editcontact($params);
   }

    $codefunction = '';

    if(isset($_GET['moduleaction']) && !empty($_GET['moduleaction']))
    {
        $functioncall = 'CERTUM_Certificates_'.$_GET['moduleaction'];
        $codefunction = $functioncall($params, true);

        if($codefunction == 'success')
        {
            $codefunction = '<div class="alert alert-success">Module action has been completed successfully.</div>';
        }
        elseif(strlen($codefunction) < 100)
        {
            $codefunction = '<div class="alert alert-danger">'.$codefunction.'</div>';
        }

    }

    $productInformation = '';
    $pid = explode('|', $params['configoption3']);

    $allProducts = CERTUM_Certificates_ProductsAvailable();
    if(!isset($allProducts[$pid[0]]))
    {
        $productInformation = '<div class="alert alert-danger">This product is no longer available.</div>';
    }

    $_LANG = CERTUM_Certificates_loadLanguage();

    $isAddon = false;
    if(isset($params['addonId']) && !empty($params['addonId']))
    {
        $isAddon = true;
    }
    $r = DB::table('tblsslorders')->where('serviceid', '=', $params['serviceid'])->first();
    if($isAddon)
    {
        $r = DB::table('tblsslorders')->where('addon_id', '=', $params['addonId'])->first();
    }

    $cert_id = $r->id;
    $code_lang = CERTUM_Certificates_loadLanguage(true);

    $code = '<h3>' . CERTUM_Certificates_translate('SSL Certificate Details') . '</h3>';

    $renewals = DB::table('certum_renewals')->where('serviceid', '=', $params['serviceid'])->first();
    if($isAddon)
    {
        $renewals = DB::table('certum_renewals')->where('addonid', '=', $params['addonId'])->first();
    }

    $modulequeue = DB::table('tblmodulequeue')
            ->where('service_id', $params['serviceid'])
            ->where('module_name', 'CERTUM_Certificates')
            ->where('service_type', 'service')
            ->where('completed', '0')
            ->where('module_action', 'Renew')
            ->first();

    if(isset($modulequeue->id))
    {
        $code .= '<div class="alert alert-danger">There was a problem during the auto renew certificate, please contact the administrator.</div>';
    }

    if(!isset($renewals->csr) && empty($renewals->csr) && $params['model']->product->paytype == 'recurring' && isset($r->status) && ($r->status == 'Completed' || $r->status == 'Configuration Submitted'))
    {
        $urltorenew = $CONFIG['SystemURL'].'/clientarea.php?action=productdetails&id='.$params['serviceid'].'&modop=custom&a=renewcsr';
        $code .= '<div class="alert alert-warning">Auto renewal of this certificate may not work properly. Please provide new CSR, go to <a href="'.$urltorenew.'">Provide new CSR to Renew</a></div>';
    }

    $code .= '<table style="width: 100%" class="table">';
    if ($r->status == 'Completed' || $r->status == 'Configuration Submitted') {
        $api = new PartnerAPIService($params['configoption1'], $params['configoption2'], $params['configoption10'], $code_lang);
        try {
            $op = $api->operationGetOrderByOrderID();
            $op->setOrderID($r->remoteid)->setOrderStatus(TRUE)->setCertificateDetails(TRUE)->setOrderDetails(TRUE);

            if ($op->call()) {
                $cert = $op->getOrders();
                $cert = $cert[0];
            }
        } catch (Exception $e) {
            $error = $op->getErrorTexts();
            return $error[0]['text'];
        }
        $product = explode('|', $r->certtype);
        $status = $cert->certificateDetails->certificateStatus != "" ? (string) $cert->certificateDetails->certificateStatus : (string) $cert->orderStatus->orderStatus;

        if($isAddon)
        {
            $code .= '<tr><td style="border-top:0;">' . CERTUM_Certificates_translate('certificate_details') . '</td><td style="border-top:0;"><button class="btn btn-mini btn-info" onclick="document.location=\'clientarea.php?action=productdetails&id=1&moduleaction=getcert#tabAddons\'">' . CERTUM_Certificates_translate('get_certificate') . '</button></td></tr>';
            $code .= '<tr><td>' . CERTUM_Certificates_translate('Contact') . '</td><td><button class="btn btn-mini btn-warning" onclick="document.location=\'clientarea.php?action=productdetails&id='.$params['serviceid'].'&moduleaction=editcontact#tabAddons\'">' . CERTUM_Certificates_translate('management') . '</button></td></tr>';
        }
        else
        {
            $code .= '<tr><td style="border-top:0;">' . CERTUM_Certificates_translate('certificate_details') . '</td><td style="border-top:0;"><button class="btn btn-mini btn-info" onclick="document.location=\'clientarea.php?action=productdetails&id=' . $params['serviceid'] . '&modop=custom&a=getcert\'">' . CERTUM_Certificates_translate('get_certificate') . '</button></td></tr>';
            $code .= '<tr><td>' . CERTUM_Certificates_translate('Contact') . '</td><td><button class="btn btn-mini btn-warning" onclick="document.location=\'clientarea.php?action=productdetails&id=' . $params['serviceid'] . '&modop=custom&a=editcontact\'">' . CERTUM_Certificates_translate('management') . '</button></td></tr>';
        }

        $code .= '<tr><td>' . CERTUM_Certificates_translate('domain') . '</td><td>' . $params['domain'] . '</td></tr>';

        if($params['moduletype']=='CERTUM_Certificates' && $params['configoption12'] == 'on')
        {
            $r = mysql_fetch_assoc(mysql_query("SELECT `name` FROM tblhosting AS h INNER JOIN tblproducts AS p ON (p.id =h.packageid) WHERE h.id=".$params['serviceid']." AND h.userid=".$_SESSION['uid']));
            $code .= '<tr><td>'.CERTUM_Certificates_translate('Product').'</td><td>'.$r['name'].'</td></tr>';
        }
        else
        {
            $code .= '<tr><td>'.CERTUM_Certificates_translate('Product').'</td><td>'.$product[1].'</td></tr>';
        }

        if ($cert->certificateDetails->serialNumber != "")
            $code .= '<tr><td>' . CERTUM_Certificates_translate('Serial Number') . '</td><td>' . $cert->certificateDetails->serialNumber . '</td></tr>';

        $code .= '<tr><td>' . CERTUM_Certificates_translate('Created At') . '</td><td>' . date('Y-m-d H:i:s', strtotime((string) $cert->orderStatus->orderDate)) . '</td></tr>';
        if ($cert->certificateDetails->endDate != "")
            $code .= '<tr><td>' . CERTUM_Certificates_translate('Expired Date') . '</td><td>' . date('Y-m-d H:i:s', strtotime((string) $cert->certificateDetails->endDate)) . '</td></tr>';

        if($isAddon)
        {

            $inputs = '<input type="hidden" name="action" value="productdetails"><input type="hidden" name="id" value="'.$params['serviceid'].'">';
            $button_sendcertificate = '<form style="margin-bottom:10px;">'.$inputs.'<input type="hidden" name="moduleaction" value="sendcertificate"><button class="btn btn-primary">'.CERTUM_Certificates_translate('send_certificate').'</button></form>';
            $button_resendnotification = '<form style="margin-bottom:10px;">'.$inputs.'<input type="hidden" name="moduleaction" value="resendnotification"><button class="btn btn-primary">'.CERTUM_Certificates_translate('resend_notification').'</button></form>';

            $pid = explode('|', $params['configoption3']);
            $button_renewcert = '<form>'.$inputs.'<input type="hidden" name="moduleaction" value="renewcert"><button class="btn btn-primary">'.CERTUM_Certificates_translate('renew').'</button></form>';
            $code .= '<tr><td>Actions</td><td>'.$button_sendcertificate.$button_resendnotification.$button_renewcert.'</td></tr>';
        }
    }
    else {
        if(empty($productInformation)) {
            $code .= '<td style="border-top:0;text-align:center;"><a href="configuressl.php?cert=' . md5($cert_id) . '">' . CERTUM_Certificates_translate('configure_now') . '</a></td></tr>';
        }
        else
        {
            $code .= $productInformation;
        }
    }

    $code .= '</table>';
    return $codefunction.$code;
}

function CERTUM_Certificates_editcontact($params, $html = false) {

    $_LANG = CERTUM_Certificates_loadLanguage();
    $isAddon = false;
    if(isset($params['addonId']) && !empty($params['addonId']))
    {
        $isAddon = true;
    }
    $r = DB::table('tblsslorders')->where('serviceid', '=', $params['serviceid'])->first();
    if($isAddon)
    {
        $r = DB::table('tblsslorders')->where('addon_id', '=', $params['addonId'])->first();
    }
    if (empty($r->remoteid)) {
        return "Certificate not found.";
    }
    $api = new PartnerAPIService($params['configoption1'], $params['configoption2'], $params['configoption10']);
    try {
        $op = $api->operationGetOrderByOrderID();
        $op->setOrderID($r->remoteid)->setOrderStatus(TRUE)->setCertificateDetails(TRUE)->setOrderDetails(TRUE);
      
        if ($op->call()) {
            $cert = $op->getOrders();
            $cert = $cert[0];
        }

    
        $contacts = $cert->orderDetails->requestorInfo;
        if(isset($cert->orderDetails->organizationInfo->organizationName))
        {
            if ((string) $cert->orderDetails->organizationInfo->organizationName != "") {
                $company = (string) $cert->orderDetails->organizationInfo->organizationName;
                $tax = (string) $cert->orderDetails->organizationInfo->taxIdentificationNumber;
            }
        }
        if($isAddon)
        {

            if($html)
            {
                $taxhtml = '';
                if($tax != "")
                {
                    $taxhtml = '<tr><td width="120" class="fieldarea">'.$_LANG['tax'].'</td><td><input type="text" name="fields[Tax]" size="30" value="'.$tax.'" readonly> </td></tr>';
                }

                $companyhtml = '';
                if($company != "")
                {
                    $companyhtml = '<tr><td width="120" class="fieldarea">'.$_LANG['org_name'].'</td><td><input type="text" name="fields[Name]" size="30" value="'.$company.'" readonly> </td></tr>';
                }

                return '

                <h3>'.$_LANG['contact_details'].'</h3>
                <form action="" method="post">
                <table class="table">
                    <tbody>
                        <tr><td width="120" class="fieldarea">'.$_LANG['first_name'].'</td><td><input type="text" name="fields[FirstName]" size="30" value="'.$contacts->firstName.'" readonly> </td></tr>
                        <tr><td width="120" class="fieldarea">'.$_LANG['last_name'].'</td><td><input type="text" name="fields[LastName]" size="30" value="'.$contacts->lastName.'" readonly> </td></tr>
                        '.$companyhtml.$taxhtml.'
                        <tr><td width="120" class="fieldarea">'.$_LANG['address'].'</td><td><input type="text" name="fields[Address1]" size="30" value="'.$contacts->addressLine1.' '.$contacts->addressLine2.'" readonly> </td></tr>
                        <tr><td width="120" class="fieldarea">'.$_LANG['city'].'</td><td><input type="text" name="fields[City]" size="30" value="'.$contacts->city.'" readonly> </td></tr>
                        <tr><td width="120" class="fieldarea">'.$_LANG['postal_code'].'</td><td><input type="text" name="fields[PostalCode]" size="30" value="'.$contacts->postalCode.'" readonly> </td></tr>
                        <tr><td width="120" class="fieldarea">'.$_LANG['country'].'</td><td><select name="fields[Country]" id="Country"  style="width:220px;" disabled="disabled"><option value="AF">Afghanistan</option><option value="AX">Aland Islands</option><option value="AL">Albania</option><option value="DZ">Algeria</option><option value="AS">American Samoa</option><option value="AD">Andorra</option><option value="AO">Angola</option><option value="AI">Anguilla</option><option value="AQ">Antarctica</option><option value="AG">Antigua And Barbuda</option><option value="AR">Argentina</option><option value="AM">Armenia</option><option value="AW">Aruba</option><option value="AU">Australia</option><option value="AT">Austria</option><option value="AZ">Azerbaijan</option><option value="BS">Bahamas</option><option value="BH">Bahrain</option><option value="BD">Bangladesh</option><option value="BB">Barbados</option><option value="BY">Belarus</option><option value="BE">Belgium</option><option value="BZ">Belize</option><option value="BJ">Benin</option><option value="BM">Bermuda</option><option value="BT">Bhutan</option><option value="BO">Bolivia</option><option value="BA">Bosnia And Herzegovina</option><option value="BW">Botswana</option><option value="BV">Bouvet Island</option><option value="BR">Brazil</option><option value="IO">British Indian Ocean Territory</option><option value="BN">Brunei Darussalam</option><option value="BG">Bulgaria</option><option value="BF">Burkina Faso</option><option value="BI">Burundi</option><option value="KH">Cambodia</option><option value="CM">Cameroon</option><option value="CA">Canada</option><option value="CV">Cape Verde</option><option value="KY">Cayman Islands</option><option value="CF">Central African Republic</option><option value="TD">Chad</option><option value="CL">Chile</option><option value="CN">China</option><option value="CX">Christmas Island</option><option value="CC">Cocos (Keeling) Islands</option><option value="CO">Colombia</option><option value="KM">Comoros</option><option value="CG">Congo</option><option value="CD">Congo, Democratic Republic</option><option value="CK">Cook Islands</option><option value="CR">Costa Rica</option><option value="CI">Cote D\'Ivoire</option><option value="HR">Croatia</option><option value="CU">Cuba</option><option value="CW">Curacao</option><option value="CY">Cyprus</option><option value="CZ">Czech Republic</option><option value="DK">Denmark</option><option value="DJ">Djibouti</option><option value="DM">Dominica</option><option value="DO">Dominican Republic</option><option value="EC">Ecuador</option><option value="EG">Egypt</option><option value="SV">El Salvador</option><option value="GQ">Equatorial Guinea</option><option value="ER">Eritrea</option><option value="EE">Estonia</option><option value="ET">Ethiopia</option><option value="FK">Falkland Islands (Malvinas)</option><option value="FO">Faroe Islands</option><option value="FJ">Fiji</option><option value="FI">Finland</option><option value="FR">France</option><option value="GF">French Guiana</option><option value="PF">French Polynesia</option><option value="TF">French Southern Territories</option><option value="GA">Gabon</option><option value="GM">Gambia</option><option value="GE">Georgia</option><option value="DE">Germany</option><option value="GH">Ghana</option><option value="GI">Gibraltar</option><option value="GR">Greece</option><option value="GL">Greenland</option><option value="GD">Grenada</option><option value="GP">Guadeloupe</option><option value="GU">Guam</option><option value="GT">Guatemala</option><option value="GG">Guernsey</option><option value="GN">Guinea</option><option value="GW">Guinea-Bissau</option><option value="GY">Guyana</option><option value="HT">Haiti</option><option value="HM">Heard Island &amp; Mcdonald Islands</option><option value="VA">Holy See (Vatican City State)</option><option value="HN">Honduras</option><option value="HK">Hong Kong</option><option value="HU">Hungary</option><option value="IS">Iceland</option><option value="IN">India</option><option value="ID">Indonesia</option><option value="IR">Iran, Islamic Republic Of</option><option value="IQ">Iraq</option><option value="IE">Ireland</option><option value="IM">Isle Of Man</option><option value="IL">Israel</option><option value="IT">Italy</option><option value="JM">Jamaica</option><option value="JP">Japan</option><option value="JE">Jersey</option><option value="JO">Jordan</option><option value="KZ">Kazakhstan</option><option value="KE">Kenya</option><option value="KI">Kiribati</option><option value="KR">Korea</option><option value="KW">Kuwait</option><option value="KG">Kyrgyzstan</option><option value="LA">Lao People\'s Democratic Republic</option><option value="LV">Latvia</option><option value="LB">Lebanon</option><option value="LS">Lesotho</option><option value="LR">Liberia</option><option value="LY">Libyan Arab Jamahiriya</option><option value="LI">Liechtenstein</option><option value="LT">Lithuania</option><option value="LU">Luxembourg</option><option value="MO">Macao</option><option value="MK">Macedonia</option><option value="MG">Madagascar</option><option value="MW">Malawi</option><option value="MY">Malaysia</option><option value="MV">Maldives</option><option value="ML">Mali</option><option value="MT">Malta</option><option value="MH">Marshall Islands</option><option value="MQ">Martinique</option><option value="MR">Mauritania</option><option value="MU">Mauritius</option><option value="YT">Mayotte</option><option value="MX">Mexico</option><option value="FM">Micronesia, Federated States Of</option><option value="MD">Moldova</option><option value="MC">Monaco</option><option value="MN">Mongolia</option><option value="ME">Montenegro</option><option value="MS">Montserrat</option><option value="MA">Morocco</option><option value="MZ">Mozambique</option><option value="MM">Myanmar</option><option value="NA">Namibia</option><option value="NR">Nauru</option><option value="NP">Nepal</option><option value="NL">Netherlands</option><option value="AN">Netherlands Antilles</option><option value="NC">New Caledonia</option><option value="NZ">New Zealand</option><option value="NI">Nicaragua</option><option value="NE">Niger</option><option value="NG">Nigeria</option><option value="NU">Niue</option><option value="NF">Norfolk Island</option><option value="MP">Northern Mariana Islands</option><option value="NO">Norway</option><option value="OM">Oman</option><option value="PK">Pakistan</option><option value="PW">Palau</option><option value="PS">Palestinian Territory, Occupied</option><option value="PA">Panama</option><option value="PG">Papua New Guinea</option><option value="PY">Paraguay</option><option value="PE">Peru</option><option value="PH">Philippines</option><option value="PN">Pitcairn</option><option value="PL">Poland</option><option value="PT">Portugal</option><option value="PR">Puerto Rico</option><option value="QA">Qatar</option><option value="RE">Reunion</option><option value="RO">Romania</option><option value="RU">Russian Federation</option><option value="RW">Rwanda</option><option value="BL">Saint Barthelemy</option><option value="SH">Saint Helena</option><option value="KN">Saint Kitts And Nevis</option><option value="LC">Saint Lucia</option><option value="MF">Saint Martin</option><option value="PM">Saint Pierre And Miquelon</option><option value="VC">Saint Vincent And Grenadines</option><option value="WS">Samoa</option><option value="SM">San Marino</option><option value="ST">Sao Tome And Principe</option><option value="SA">Saudi Arabia</option><option value="SN">Senegal</option><option value="RS">Serbia</option><option value="SC">Seychelles</option><option value="SL">Sierra Leone</option><option value="SG">Singapore</option><option value="SK">Slovakia</option><option value="SI">Slovenia</option><option value="SB">Solomon Islands</option><option value="SO">Somalia</option><option value="ZA">South Africa</option><option value="GS">South Georgia And Sandwich Isl.</option><option value="ES">Spain</option><option value="LK">Sri Lanka</option><option value="SD">Sudan</option><option value="SR">Suriname</option><option value="SJ">Svalbard And Jan Mayen</option><option value="SZ">Swaziland</option><option value="SE">Sweden</option><option value="CH">Switzerland</option><option value="SY">Syrian Arab Republic</option><option value="TW">Taiwan</option><option value="TJ">Tajikistan</option><option value="TZ">Tanzania</option><option value="TH">Thailand</option><option value="TL">Timor-Leste</option><option value="TG">Togo</option><option value="TK">Tokelau</option><option value="TO">Tonga</option><option value="TT">Trinidad And Tobago</option><option value="TN">Tunisia</option><option value="TR">Turkey</option><option value="TM">Turkmenistan</option><option value="TC">Turks And Caicos Islands</option><option value="TV">Tuvalu</option><option value="UG">Uganda</option><option value="UA">Ukraine</option><option value="AE">United Arab Emirates</option><option value="GB">United Kingdom</option><option value="US" selected="selected">United States</option><option value="UM">United States Outlying Islands</option><option value="UY">Uruguay</option><option value="UZ">Uzbekistan</option><option value="VU">Vanuatu</option><option value="VE">Venezuela</option><option value="VN">Viet Nam</option><option value="VG">Virgin Islands, British</option><option value="VI">Virgin Islands, U.S.</option><option value="WF">Wallis And Futuna</option><option value="EH">Western Sahara</option><option value="YE">Yemen</option><option value="ZM">Zambia</option><option value="ZW">Zimbabwe</option></select> </td></tr>
                        <tr><td width="120" class="fieldarea">'.$_LANG['phone'].'</td><td><input type="text" name="fields[Phone]" size="30" value="'.$contacts->phone.'" readonly></td></tr>
                        <tr><td width="120" class="fieldarea">'.$_LANG['email'].'</td><td><input type="text" name="fields[Email]" size="30" value="'.$contacts->email.'" readonly> </td></tr>
                    </tbody>
                </table>
                <a href="clientarea.php?action=productdetails&id='.$params['serviceid'].'#tabAddons" class="btn btn-warning">'.$_LANG['back'].'</a>
                </form>

                <script type="text/javascript">
                    jQuery(document).ready(function()
                    {
                        jQuery("#Country").val("'.$contacts->country.'");
                    });
                </script>


                ';
            }

            return array
                (
                'templatefile' => 'editcontact',
                'breadcrumb'   => '> <a href="#">Contact Management</a>',
                'vars'         => array
                    (
                    'contacts'  => $contacts,
                    'company'   => $company,
                    'tax'       => $tax,
                    'lang'      => $_LANG,
                    'addonId' => $params['addonId'],
                )
            );
        }
        else
        {
            return array
                (
                'templatefile' => 'editcontact',
                'breadcrumb'   => '> <a href="#">Contact Management</a>',
                'vars'         => array
                    (
                    'contacts'  => (array) reset($contacts),
                    'company'   => $company,
                    'tax'       => $tax,
                    'lang'      => $_LANG,
                    'serviceid' => $params['serviceid'],
                )
            );
        }
    } catch (Exception $e) {
        $error = $op->getErrorTexts();
        return $error[0]['text'];
    }
}

//LOAD LANGUAGE
function CERTUM_Certificates_loadLanguage($code = false) {
    $language = null;
    if (isset($_SESSION['Language'])) { // GET LANG FROM SESSION
        $language = strtolower($_SESSION['Language']);
    } else {
        $row = DB::table('tblclients')->select('language')->where('id', '=', $_SESSION['uid'])->first();

        if ($row->language)
            $language = $row->language;
    }



    if (!$language) { //Ouuuh?
        $row = DB::table('tblconfiguration')->select('value')->where('setting', '=', 'Language')->first();
        $language = $row->value;
    }
    $langfilename = dirname(__FILE__) . DS . 'lang' . DS . $language . '.php';
    $deflangfilename = dirname(__FILE__) . DS . 'lang' . DS . 'english.php';

    if ($code) {
        if ($language == 'english')
            return 'en';
        else
            return 'pl';
    }

    if (file_exists($langfilename))
        include($langfilename);
    else
        include($deflangfilename);

    return $_LANG;
}

function CERTUM_Certificates_translate($key) {
    $_LANG = CERTUM_Certificates_loadLanguage();
    if (isset($_LANG[$key]))
        return $_LANG[$key];

    return $key;
}

function CERTUM_get_template($pid) {
    if (in_array($pid, array_keys(CERTUM_Certificates_CodeSigning()))) {
        $template = 'CERTUM Certificates - Code Signing Certificate Configuration Required';
    } elseif (in_array($pid, array_keys(CERTUM_Certificates_IDCerts()))) {
        $template = 'CERTUM Certificates - ID Certificate Configuration Required';
    } else {
        $template = 'CERTUM Certificates - SSL Certificate Configuration Required';
    }
    return $template;
}

function CERTUM_get_approved_method($pid) {
    $email = '<option>ADMIN</option>';
    $file = '<option>FILE</option>';
    $dns = '<option>DNS_TXT</option><option>DNS_CNAME</option><option>DNS_TXT_PREFIX</option><option>DNS_CNAME_PREFIX</option>';

    if (in_array($pid, array_keys(CERTUM_Certificates_Commercial()))) {
        $fields = $email . $file . $dns;
    }

    if (in_array($pid, array_keys(CERTUM_Certificates_Trusted()))) {
        $fields = $email . $file . $dns;
    }

    if (in_array($pid, array_keys(CERTUM_Certificates_PremiumEVSSL()))) {
        $fields = $email . $file . $dns;
    }

    if (in_array($pid, array_keys(CERTUM_Certificates_IDCerts()))) {
        $fields = $email;
    }

    if (in_array($pid, array_keys(CERTUM_Certificates_CodeSigning()))) {
        $fields = $email;
    }

    return $fields;
}

function CERTUM_change_next_due_date($params)
{


    $isAddon = false;
    if(isset($params['addonId']) && !empty($params['addonId']))
    {
        $isAddon = true;
    }

    if($isAddon)
    {
        $hostingaddon = DB::table('tblhostingaddons')->where('id', $params['addonId'])->first();
        $addon = DB::table('tbladdons')->where('id', $hostingaddon->addonid)->first();
        $addonConfig = DB::table('tblmodule_configuration')->where('entity_type', 'addon')->where('entity_id', $hostingaddon->addonid)->get();

        $q = new stdClass();
        $q->servertype = $addon->module;

        foreach($addonConfig as $v)
        {
            $q->{$v->setting_name} = $v->value;
        }

    }
    else
    {
        $q = DB::table('tblhosting AS h')
                    ->select('p.servertype','p.configoption3','h.regdate','p.configoption13')
                    ->join('tblproducts AS p', 'p.id', '=', 'h.packageid')
                    ->where('h.id', '=', $params['serviceid'])
                    ->first();
    }

    if($q->servertype == "CERTUM_Certificates" && $q->configoption13 == "on")
    {
        $now = date("Y-m-d");
        $data= explode('-', $now);

        if(strpos($q->configoption3, '1 Year') !== false)
        {
            $duedatenewyear = intval($data[0])+1;
            $duedate =  $duedatenewyear.'-'.$data[1].'-'.$data[2];
        }
        elseif(strpos($q->configoption3, '2 Years') !== false)
        {
            $duedatenewyear = intval($data[0])+2;
            $duedate =  $duedatenewyear.'-'.$data[1].'-'.$data[2];
        }
        elseif(strpos($q->configoption3, '3 Years') !== false)
        {
            $duedatenewyear = intval($data[0])+3;
            $duedate =  $duedatenewyear.'-'.$data[1].'-'.$data[2];
        }
        else
        {
            return true;
        }

        if($isAddon)
        {
            DB::table('tblhostingaddons')
            ->where('id', '=', $params['addonId'])
            ->update(['nextduedate' => $duedate]);
        }
        else
        {
            DB::table('tblhosting')
            ->where('id', '=', $params['serviceid'])
            ->update(['nextduedate' => $duedate]);
        }

    }
}
function array_sort_new($array, $on, $order=SORT_ASC)
{
    $new_array = array();
    $sortable_array = array();

    if (count($array) > 0) {
        foreach ($array as $k => $v) {
            if (is_array($v)) {
                foreach ($v as $k2 => $v2) {
                    if ($k2 == $on) {
                        $sortable_array[$k] = $v2;
                    }
                }
            } else {
                $sortable_array[$k] = $v;
            }
        }

        switch ($order) {
            case SORT_ASC:
                asort($sortable_array);
            break;
            case SORT_DESC:
                arsort($sortable_array);
            break;
        }

        foreach ($sortable_array as $k => $v) {
            $new_array[$k] = $array[$k];
        }
    }

    return $new_array;
}

function approversCheck($approvers, $domain)
{
    $result = false;
    foreach($approvers as $approver => $details)
    {
        if($approver == $domain)
        {
            $result = true;
        }
    }
    return $result;
}
