var Reissue = {

	init: function()
	{
		$('#btnReissue').removeAttr("onclick");

		$('#btnReissue').on("click", function() {
			$('#CSRModal').modal("show");
		});

		Reissue.addHandlers();
	},

	addHandlers: function()
	{
		Reissue.modalShowHandlers();
		Reissue.addSanHandler();
		Reissue.removeSanHandler();
		Reissue.changeValidationMethodHandler();
		Reissue.changeSanHandler();
		Reissue.reissueHandler();
	},

	modalShowHandlers: function()
	{
	    $('#CSRModal').on('show.bs.modal', function() {
                
                        $('#CSRModal button[name="add_new_domain"]').parent('td').parent('tr').remove();
                
                        $('#CSRModal .approve_section').remove();
			$("div[class*='errorMessage']").hide();
			$('#CSRModal textarea#csr').val("");

			var serialNumber = $('#CSRModal input#serial_number').attr("value");
			$('#CSRModal input#csr_serial').val(serialNumber);

	    	var params = {
	    		productId: $("#CSRModal input[name='productId']").val(),
	    		serviceId: $("#CSRModal input[name='serviceId']").val()
	    	};

	    	$('#CSRModal div.loader').show();
        	Reissue.sendRequest("GetSanConfigurationForm", params);
    	});
	},

	addSanHandler: function()
	{
                $("body").on('input', '#CSRModal input.reissue_san', function(){
            
                    var iswildcard = false;
                    var lastIndex = Reissue.getLastSanIndex();
                    var clone_add_prefix = '<input type="checkbox" class="form-check-input" name="add_prefix_www_'+lastIndex+'"><label class="form-check-label">Add prefix \'www\'</label>';
                    
                    $("#CSRModal input.reissue_san").each(function( index ) {

                        var domainapprover = $(this).val();
                        if(domainapprover == '')
                        {
                            return false;
                        }

                        if(domainapprover.indexOf('*.') !== -1 )
                        {
                            iswildcard = true;
                        }

                    });

                    
                    
                    if(iswildcard === true)
                    {
                        $("#CSRModal #approvermethod option").each(function( index ) {
                            if($(this).text() == 'FILE')
                            {
                                $(this).remove();
                            }
                        });
                        
                        $(this).parent('td').next('td').find('.form-check-input').remove();
                        $(this).parent('td').next('td').find('.form-check-label').remove();
                        
                    }
                    else
                    {
                        var checkfile = false;

                        $("#CSRModal #approvermethod option").each(function( index ) {
                            if($(this).text() == 'FILE')
                            {
                                checkfile = true;
                            }
                        });


                        if(checkfile === false)
                        {
                            $("#CSRModal #approvermethod").append('<option>FILE</option>');
                        }
                        
                        if(!$(this).parent('td').next('td').find('.form-check-input').length)
                        {
                            $(this).parent('td').next('td').find('div').append(clone_add_prefix);
                        }
                        
                    }

                });
            
            
            
            
                $('#CSRModal').on('click', "button[name='add_new_domain']", function(event) {

			event.preventDefault();
                        
                        $("#CSRModal button[name='add_san']").click();
                        $("#CSRModal button[name='add_san']").show();
                        $('#CSRModal .approve_section').show();
                        
                        $(this).parent('td').parent('tr').remove();
                });
                
                
		$('#CSRModal').on('click', "button[name='add_san']", function(event) {

			event.preventDefault();

			var lastIndex = Reissue.getLastSanIndex();
			var newIndex = parseInt(lastIndex) + 1;

			var newSanBlock = $("tr[name='additional_san']").clone();

			newSanBlock.removeAttr("name");
                        newSanBlock.find("input[name='san']").addClass("reissue_san");
			newSanBlock.find("input[name='san']").attr("name", "san_" + newIndex);
			newSanBlock.find("select[name='verification_method']").attr("name", "verification_method_" + newIndex);
			newSanBlock.find("select[name='verification_email']").attr("name", "verification_email_" + newIndex);
			newSanBlock.find("input[name='add_prefix_www']").attr("name", "add_prefix_www_" + newIndex);

			if($("input[name*='san_']").length > 0)
			{
				$("input[name='san_" + lastIndex + "']").parent().parent().after(newSanBlock);
			}
			else
			{
				var tr = $("<tr />");
				var td = $("<td />", {colspan: 2});
				var table = $('<table />', {style: "width: 200px;"});

				table.append(newSanBlock);
				td.append(table);
				tr.append(td);

				$('#CSRModal textarea#csr').parent().parent().after(tr);
			}

			var verificationMethodSelect = newSanBlock.find("select[name='verification_method_" + newIndex + "']");
			Reissue.toggleValidationMethod(verificationMethodSelect);
			newSanBlock.show();
		});
	},

	removeSanHandler: function()
	{
		$('#CSRModal').on('click', "button[name='remove_san']", function(event) {
			event.preventDefault();
			$(this).parent().parent().remove();
		});
	},

	changeValidationMethodHandler: function()
	{
		$('#CSRModal').on('change', "select[name*='verification_method_']", function() {
			Reissue.toggleValidationMethod($(this));
		});
	},

	changeSanHandler: function()
	{
		
	},

	changeCsrHandler: function()
	{
		$('#CSRModal').on('change keyup', "textarea#csr", function() {

			var params = {
				csr: $(this).val()
			};

			$('#CSRModal div.loader').show();
			Reissue.sendRequest("GetDomainFromCsr", params);
		});
	},

	reissueHandler: function()
	{
		$('#CSRModal').on('click', "button[name='reissue_confirm']", function(event) {
			event.preventDefault();

			var params = {
                                serviceId: $("#CSRModal input[name='serviceId']").val(),
				productId: $("#CSRModal input[name='productId']").val(),
				csr: $('#CSRModal textarea#csr').val(),
				csr_serial: $('#CSRModal input#csr_serial').val(),
                                method:$("#CSRModal select[name='method']").val(),
                                email:$("#CSRModal input[name='emailaddress']").val(),
                                emailprefix:$("#CSRModal select[name='emailprefix']").val(),
                                approvenotification:$("#CSRModal input[name='approvenotification']:checked").val()
			};

			sans = [];

			$("#CSRModal input[data-type='new'][name*='san_']").each(function() {

				var index = ($(this).attr("name")).replace("san_", "");
				var domain = $(this).val();

				var prefix_www = $("#CSRModal input[name*='add_prefix_www_" + index + "']").prop("checked");
				prefix_www = prefix_www?1:0;

				sans.push({domain: domain, prefix_www: prefix_www});
			});

			params.sans = sans;
                        
			$('#CSRModal div.loader').show();
			Reissue.sendRequest("ReissueCertificate", params);
		});
	},

	toggleValidationMethod: function(element)
	{
		var selectedMethod = element.find("option:selected").val();

		if(selectedMethod == "ADMIN")
		{
			element.parent().next().find("select[name*='verification_email_']").show();
		}
		else
		{
			element.parent().next().find("select[name*='verification_email_']").hide();
		}
	},

	getLastSanIndex: function()
	{
		var lastSanInput = $("input[name*='san_']:last");

		if(lastSanInput.length == 0)
		{
			return 0;
		}

		var name = $("input[name*='san_']:last").attr("name");
		var lastSanIndex = name.replace("san_", "");

		return lastSanIndex;
	},

	sendRequest: function (action, params)
    {
        $.ajax({
            url: "../modules/servers/CERTUM_Certificates/ajax.php",
            type: 'POST',
            async: true,
            dataType: 'json',
            data: {request: action, parameters: params},
            error: function (response) {
                console.log(response);
            },
            success: function (response) {
                Reissue.handleResponse(action, response, params);
            }
        });
    },

    handleResponse: function (action, response, params)
    {
    	$('#CSRModal div.loader').hide();
		$("div[class*='errorMessage']").hide();
		$("div[class*='successMessage']").hide();

        switch (action)
        {
            case 'GenerateDomainApproverEmails':
                Reissue.handleGenerateDomainApproverEmailsResponse(response, params);
                break;
            case 'GetSanConfigurationForm':
            	Reissue.handleGetSanConfigurationFormResponse(response, params);
                break;
            case 'ReissueCertificate':
            	Reissue.handleReissueCertificateResponse(response, params);
                break; 
            case 'GetDomainFromCsr':
            	Reissue.handleGetDomainFromCsrResponse(response, params);
                break;    
        }
    },

    handleGenerateDomainApproverEmailsResponse: function(response, params)
    {
    	if(response.result == "success")
    	{
    		var emailSelect = $("#CSRModal select[name*='verification_email_" + params.sanIndex + "']");
    		emailSelect.empty();

    		for(var i = 0; i < (response.emails).length; i++)
    		{
    			var option = $("<option />", {value: response.emails[i], text: response.emails[i]});
    			emailSelect.append(option);
    		}
    	}
    	else
    	{
    		$("div[class*='errorMessage'] span.content").text(response.message);
    		$("div[class*='errorMessage']").show();
    	}
    },

    handleGetSanConfigurationFormResponse: function(response, params)
    {
    	$("#CSRModal table tbody tr:nth-child(3)").remove();
    	$("#CSRModal table tbody tr[name='additional_san']").remove();
    	$("#CSRModal table tbody button[name='add_san']").parent().parent().remove();

    	if(response.result == "success")
    	{
    		if(response.html)
    		{
	    		$("#CSRModal table tbody").append($(response.html));
	    		$("#CSRModal select[name*='verification_method_']").each(function() {
					Reissue.toggleValidationMethod($(this));
				});
	    	}
                if(response.html2)
    		{
                    $("#CSRModal .modal-body").append($(response.html2));
	    	}
    	}
    	else
    	{
    		$("div[class*='errorMessage'] span.content").text(response.message);
    		$("div[class*='errorMessage']").show();
    	}
    },

    handleGetDomainFromCsrResponse: function(response, params)
    {
    	if((response.result == "success"))
    	{
    		if($("#CSRModal input[data-type='main']").length > 0)
    		{
	    		var mainDomainIndex = ($("#CSRModal input[data-type='main']").attr('name')).replace("san_", "");
	    		$("#CSRModal input[name*='san_'][data-type='main']").attr("value", response.domain);

	    		var params = {
					domain: response.domain,
					sanIndex: mainDomainIndex
				};

				Reissue.sendRequest("GenerateDomainApproverEmails", params);
			}
    	}
    	else
    	{
    		$("div[class*='errorMessage'] span.content").text(response.message);
    		$("div[class*='errorMessage']").show();
    	}
    },

    handleReissueCertificateResponse: function(response, params)
    {
    	if((response.result == "error"))
    	{
    		$("div[class*='errorMessage'] span.content").text(response.message);
    		$("div[class*='errorMessage']").show();
    	}
    	else
    	{
    		$('#CSRModal input#serial_number').val(params.csr_serial);
    		$("div[class*='successMessage'] span.content").text("Certificate has been reissued successfully");
    		$("div[class*='successMessage']").show();
    	}
    }
};


var ChangeVerification = {

	init: function()
	{
		$('#btnChange_verification').removeAttr("onclick");

		$('#btnChange_verification').on("click", function() {
			$('#ChangeVerificationModal').modal("show");
		});
                
                $('#btnChange_resend_verification').removeAttr("onclick");

		$('#btnChange_resend_verification').on("click", function() {
			$('#ChangeVerificationModal').modal("show");
		});

		ChangeVerification.addHandlers();
	},

	addHandlers: function()
	{
		ChangeVerification.modalShowHandlers();
		ChangeVerification.changeverificationHandler();
	},

	modalShowHandlers: function()
	{
	    $('#ChangeVerificationModal').on('show.bs.modal', function() {

                $("div[class*='errorMessage']").hide();
			
            });
	},
	sendRequest: function (action, params)
        {
            $.ajax({
                url: "../modules/servers/CERTUM_Certificates/ajax.php",
                type: 'POST',
                async: true,
                dataType: 'json',
                data: {request: action, parameters: params},
                error: function (response) {
                    console.log(response);
                },
                success: function (response) {
                    ChangeVerification.handleResponse(action, response, params);
                }
            });
        },
        handleResponse: function (action, response, params)
        {
            $('#ChangeVerificationModal div.loader').hide();
                    $("div[class*='errorMessage']").hide();
                    $("div[class*='successMessage']").hide();

            switch (action)
            {
                case 'ChangeVerification':
                    ChangeVerification.handleChangeVerificationResponse(response, params);
                    break;   
            }
        },
        handleChangeVerificationResponse: function(response, params)
        {
            if((response.result == "error"))
            {
                    $("div[class*='errorMessage'] span.content").text(response.message);
                    $("div[class*='errorMessage']").show();
            }
            else
            {
                    $("div[class*='successMessage'] span.content").text("Change verification completed successfully");
                    $("div[class*='successMessage']").show();
            }
        },
	changeverificationHandler: function()
	{
            $('#ChangeVerificationModal').on('click', "button[name='changeverification_confirm']", function(event) {
                event.preventDefault();

                var params = {
                    productId: $("#ChangeVerificationModal input[name='productId']").val(),
                    serviceId: $("#ChangeVerificationModal input[name='serviceId']").val(),
                    method:$("#ChangeVerificationModal select[name='method']").val(),
                    email:$("#ChangeVerificationModal input[name='emailaddress']").val(),
                    emailprefix:$("#ChangeVerificationModal select[name='emailprefix']").val(),
                    approvenotification:$("#ChangeVerificationModal input[name='approvenotification']:checked").val()
                };



                $('#ChangeVerificationModal div.loader').show();
                ChangeVerification.sendRequest("ChangeVerification", params);
            });
	},
};

var RenewCertificate = {

	init: function()
	{
		$('#btnRenew_Certificate').removeAttr("onclick");
                $('#btnRenew_Certificate').html("Renew");

		$('#btnRenew_Certificate').on("click", function() {
			$('#RenewCertificateModal').modal("show");
		});

		RenewCertificate.addHandlers();
	},

	addHandlers: function()
	{
		RenewCertificate.modalShowHandlers();
		RenewCertificate.renewcertificateHandler();
	},

	modalShowHandlers: function()
	{
	    $('#RenewCertificateModal').on('show.bs.modal', function() {

                $("div[class*='errorMessage']").hide();
			
            });
	},
	sendRequest: function (action, params)
        {
            $.ajax({
                url: "../modules/servers/CERTUM_Certificates/ajax.php",
                type: 'POST',
                async: true,
                dataType: 'json',
                data: {request: action, parameters: params},
                error: function (response) {
                    console.log(response);
                },
                success: function (response) {
                    RenewCertificate.handleResponse(action, response, params);
                }
            });
        },
        handleResponse: function (action, response, params)
        {
            $('#RenewCertificateModal div.loader').hide();
                    $("div[class*='errorMessage']").hide();
                    $("div[class*='successMessage']").hide();

            switch (action)
            {
                case 'RenewCertificate':
                    RenewCertificate.handlerenewcertificateResponse(response, params);
                    break;   
            }
        },
        handlerenewcertificateResponse: function(response, params)
        {
            if((response.result == "error"))
            {
                    $("div[class*='errorMessage'] span.content").text(response.message);
                    $("div[class*='errorMessage']").show();
            }
            else
            {
                    runModuleCommand("renew");
                    $('#RenewCertificateModal').modal("hide");
            }
        },
	renewcertificateHandler: function()
	{
            
             
            var checkfileglobal = false;
            $("#RenewCertificateModal #approvermethod option").each(function( index ) {
                if($(this).text() == 'FILE')
                {
                    checkfileglobal = true
                }
            });
            

             $("body").on('input', '#RenewCertificateModal textarea[name="csr"]', function(){
                 

  
                    $.ajax({
                        method      : "get", 
                        dataType    : "json",
                        contentType : "application/json",
                        data        : {
                            "ajax" : "1",
                            "action" : "getDetailsCSR",
                            "csrform": $(this).val()
                        },
                        success : function(data) {
                            var domaincsr = '';
                            if(data.CN)
                            {
                                domaincsr = data.CN;
                            }
                             console.dir(domaincsr);
                            var iswildcard = false;
                            if(domaincsr.indexOf('*.') !== -1 )
                            {
                                iswildcard = true;
                            }
                   
                            if(iswildcard === true)
                            {
                                $("#RenewCertificateModal #approvermethod option").each(function( index ) {
                                    if($(this).text() == 'FILE')
                                    {
                                        $(this).remove();
                                    }
                                });
                            }
                            else
                            {
                                var checkfile = false;

                                $("#RenewCertificateModal #approvermethod option").each(function( index ) {
                                    if($(this).text() == 'FILE')
                                    {
                                        checkfile = true;
                                    }
                                });

                                if(checkfile === false && checkfileglobal === true)
                                {
                                    $("#RenewCertificateModal #approvermethod").append('<option>FILE</option>');
                                }
                            }
                            
                            
                            
                        },
                        beforeSend: function() {

                        },
                    });
        
                
                 
                 
                 
                 
                 //console.dir($(this).val());
                 
             });
            
            
            
            $('#RenewCertificateModal').on('click', "button[name='renewcertificate_confirm']", function(event) {
                event.preventDefault();

                var params = {
                    productId: $("#RenewCertificateModal input[name='productId']").val(),
                    serviceId: $("#RenewCertificateModal input[name='serviceId']").val(),
                    serial:$("#RenewCertificateModal input[name='serial']").val(),
                    pem:$("#RenewCertificateModal textarea[name='pem']").val(),
                    csr:$("#RenewCertificateModal textarea[name='csr']").val(),
                    method:$("#RenewCertificateModal select[name='method']").val(),
                    email:$("#RenewCertificateModal input[name='emailaddress']").val(),
                    emailprefix:$("#RenewCertificateModal select[name='emailprefix']").val(),
                    approvenotification:$("#RenewCertificateModal input[name='approvenotification']:checked").val()
                };
                
                $('#RenewCertificateModal div.loader').show();
                RenewCertificate.sendRequest("RenewCertificate", params);
            });
	},
};

$(document).ready(function() {
    
        $('button[onclick="jQuery(\'#modalModuleRenew\').modal(\'show\');"]').remove();
    
	Reissue.init();
        ChangeVerification.init();
        RenewCertificate.init();
        
        var approvermethod = jQuery('#approvermethod').val();

        if(approvermethod == 'ADMIN')
        {
            jQuery('select[name="emailprefix"]').parent('.form-group').parent('.row').show();
            jQuery('input[name="emailaddress"]').parent('.form-group').parent('.row').hide();
            jQuery('select[name="emailprefix"]').prop("disabled", false);
            jQuery('input[name="emailaddress"]').prop("true", false);
        }
        else
        {
            jQuery('input[name="emailaddress"]').prop("disabled", false);
            jQuery('select[name="emailprefix"]').prop("true", false);
            jQuery('select[name="emailprefix"]').parent('.form-group').parent('.row').hide();
            jQuery('input[name="emailaddress"]').parent('.form-group').parent('.row').show();
        }

		let size = 255;

		$('body').on('input','input[name="emailaddress"]', function (){

			let length = $(this).val().length;
			if(length > size)
			{
				$('input[name="emailaddress"]').parent('div').find('span.counter-char').addClass("red");
			}
			else
			{
				$('input[name="emailaddress"]').parent('div').find('span.counter-char').removeClass("red");
			}
			$('input[name="emailaddress"]').parent('div').find('span.counter-char').html(length+'/'+size);

			if($(this).val() != '')
			{
				let reg = /^([A-Za-z0-9_\-\.])+\@([A-Za-z0-9_\-\.])+\.([A-Za-z]{2,4})$/;
				if (reg.test($(this).val()) == false)
				{
					$('input[name="emailaddress"]').parent('div').find('span.counter-char').addClass("red");
					$('input[name="emailaddress"]').parent('div').find('span.counter-char').html('The email address is incorrect '+length+'/'+size);
				}
				else
				{
					if(length < size)
					{
						$('input[name="emailaddress"]').parent('div').find('span.counter-char').removeClass("red");
					}
					$('input[name="emailaddress"]').parent('div').find('span.counter-char').html(length+'/'+size);
				}
			}

		});


        jQuery("body").on("change", "#approvermethod", function() {

            var approvermethod = jQuery(this).val();

            if(approvermethod == 'ADMIN')
            {
                jQuery('select[name="emailprefix"]').parent('.form-group').parent('.row').show();
                jQuery('input[name="emailaddress"]').parent('.form-group').parent('.row').hide();
                jQuery('select[name="emailprefix"]').prop("disabled", false);
                jQuery('input[name="emailaddress"]').prop("true", false);
            }
            else
            {
                jQuery('input[name="emailaddress"]').prop("disabled", false);
                jQuery('select[name="emailprefix"]').prop("true", false);
                jQuery('select[name="emailprefix"]').parent('.form-group').parent('.row').hide();
                jQuery('input[name="emailaddress"]').parent('.form-group').parent('.row').show();
            }

        });
        
        
            $("body").on('input', 'input[name="serial"]', function(){
                checkPemAndSerial();
            });

            $("body").on('input', 'textarea[name="pem"]', function(){
                checkPemAndSerial();
            });


            function checkPemAndSerial()
            {
                var serial = $('input[name="serial"]').val();
                var pem = $('textarea[name="pem"]').val();

                if(serial != '')
                {
                    $('textarea[name="pem"]').prop("readonly", true);
                    $('textarea[name="pem"]').val("");
                }
                else
                {
                    $('textarea[name="pem"]').prop("readonly", false);
                }

                if(pem != '')
                {
                    $('input[name="serial"]').prop("readonly", true);
                    $('input[name="serial"]').val("");
                }
                else
                {
                    $('input[name="serial"]').prop("readonly", false);
                }

            }
            
            var certumpid = $('input[name="certumpid"]').val();
            if(certumpid == '281' || certumpid == '282' || certumpid == '283' || 
               certumpid == '316' || certumpid == '317' || certumpid == '318' ||
               certumpid == '831' || certumpid == '832' || certumpid == '833')
            {
                $('#btnReissue').attr('disabled','disabled');
                $('#btnChange_verification').attr('disabled','disabled');
                $('#btnRenew_Certificate').attr('disabled','disabled');
            }

			if(certumpid == '501' || certumpid == '502' || certumpid == '511' ||
				certumpid == '512' || certumpid == '521' || certumpid == '522' ||
				certumpid == '531' || certumpid == '532')
			{
				$('#btnRenew_Certificate').attr('disabled','disabled');
			}


			var certumBilling = $('select[name="billingcycle"]').val();
			if(certumBilling != 'One Time' && certumBilling != 'Free Account')
			{
				$("#btnRenew_Certificate").remove();
			}

});
