var Reissue = {

	init: function()
	{
		var serialNumber = $('input#serial_number').attr("value");
		$('input#csr_serial').val(serialNumber);
		Reissue.addHandlers();
	},

	addHandlers: function()
	{
		Reissue.addSanHandler();
		Reissue.removeSanHandler();
		Reissue.changeValidationMethodHandler();
		Reissue.changeSanHandler();
		Reissue.reissueHandler();
	},

	addSanHandler: function()
	{       
                var checkfileglobal = false;
                $("#approvermethod option").each(function( index ) {
                    if($(this).text() == 'FILE')
                    {
                        checkfileglobal = true
                    }
                });
                
                $("body").on('input', 'input.reissue_san', function(){
            
                    var iswildcard = false;
                    var lastIndex = Reissue.getLastSanIndex();
                    var clone_add_prefix = '<input type="checkbox" class="form-check-input" name="add_prefix_www_'+lastIndex+'"><label class="form-check-label">Add prefix \'www\'</label>';
                    
                    $("input.reissue_san").each(function( index ) {

                        var domainapprover = $(this).val();
                        if(domainapprover == '')
                        {
                            return false;
                        }

                        if(domainapprover.indexOf('*.') !== -1 )
                        {
                            iswildcard = true;
                        }

                    });

                    
                    
                    if(iswildcard === true)
                    {
                        $("#approvermethod option").each(function( index ) {
                            if($(this).text() == 'FILE')
                            {
                                $(this).remove();
                            }
                        });
                        
                        $(this).parent('td').next('td').find('.form-check-input').remove();
                        $(this).parent('td').next('td').find('.form-check-label').remove();
                        
                    }
                    else
                    {
                        var checkfile = false;

                        $("#approvermethod option").each(function( index ) {
                            if($(this).text() == 'FILE')
                            {
                                checkfile = true;
                            }
                        });

                        if(checkfile === false && checkfileglobal === true)
                        {
                            $("#approvermethod").append('<option>FILE</option>');
                        }
                        
                        if(!$(this).parent('td').next('td').find('.form-check-input').length)
                        {
                            $(this).parent('td').next('td').find('div').append(clone_add_prefix);
                        }
                        
                    }

                });
            
                $('body').on('click', "button[name='add_new_domain']", function(event) {

			event.preventDefault();
                        
                        $("button[name='add_san']").click();
                        $("button[name='add_san']").show();
                        $('.approve_section').show();
                        
                        $(this).parent('td').parent('tr').remove();
                });
            
            
		$("button[name='add_san']").on('click', function(event) {

			event.preventDefault();

			var lastIndex = Reissue.getLastSanIndex();
			var newIndex = parseInt(lastIndex) + 1;

			var newSanBlock = $("tr[name='additional_san']").clone();

			newSanBlock.removeAttr("name");
                        newSanBlock.find("input[name='san']").addClass("reissue_san");
			newSanBlock.find("input[name='san']").attr("name", "san_" + newIndex);
			newSanBlock.find("select[name='verification_method']").attr("name", "verification_method_" + newIndex);
			newSanBlock.find("select[name='verification_email']").attr("name", "verification_email_" + newIndex);
			newSanBlock.find("input[name='add_prefix_www']").attr("name", "add_prefix_www_" + newIndex);

			if($("input[name*='san_']").length > 0)
			{
				$("input[name='san_" + lastIndex + "']").parent().parent().after(newSanBlock);
			}
			else
			{
				var tr = $("<tr />");
				var td = $("<td />", {colspan: 2});
				var table = $('<table />', {style: "width: 200px;"});

				table.append(newSanBlock);
				td.append(table);
				tr.append($("<td />"));
				tr.append(td);

				$('textarea#csr').parent().parent().after(tr);
			}

			var verificationMethodSelect = newSanBlock.find("select[name='verification_method_" + newIndex + "']");
			Reissue.toggleValidationMethod(verificationMethodSelect);
			newSanBlock.show();
		});
	},

	removeSanHandler: function()
	{
		$('body').on('click', "button[name='remove_san']", function(event) {
			event.preventDefault();
			$(this).parent().parent().remove();
		});
	},

	changeValidationMethodHandler: function()
	{
		$("body").on('change', "select[name*='verification_method_']", function() {
			Reissue.toggleValidationMethod($(this));
		});
	},

	changeSanHandler: function()
	{

	},

	reissueHandler: function()
	{
		$('body').on('click', "button[name='reissue_confirm']", function(event) {
			event.preventDefault();

			var params = {
                                serviceId: $("input[name='serviceId']").val(),
                                productId: $("input[name='productId']").val(),
                            	csr: $('textarea#csr').val(),
                            	csr_serial: $('input#csr_serial').val(),
                                method:$("select[name='method']").val(),
                                email:$("input[name='emailaddress']").val(),
                                emailprefix:$("select[name='emailprefix']").val(),
                                approvenotification:$("input[name='approvenotification']:checked").val()
			};

			sans = [];

			$("body input[data-type='new'][name*='san_']").each(function() {

				var index = ($(this).attr("name")).replace("san_", "");
				var domain = $(this).val();
			
				var prefix_www = $("body input[name*='add_prefix_www_" + index + "']").prop("checked");
				prefix_www = prefix_www?1:0;

				sans.push({domain: domain, prefix_www: prefix_www});
			});

			params.sans = sans;

			 $('div.loader').show();
			 Reissue.sendRequest("ReissueCertificate", params);
		});
	},

	sendRequest: function (action, params)
    {
        $.ajax({
            url: "../modules/servers/CERTUM_Certificates/ajax.php",
            type: 'POST',
            async: true,
            dataType: 'json',
            data: {request: action, parameters: params},
            error: function (response) {
                console.log(response);
            },
            success: function (response) {
                Reissue.handleResponse(action, response, params);
            }
        });
    },

    handleResponse: function (action, response, params)
    {
    	$('div.loader').hide();
		$("div[class*='errorMessage']").hide();
		$("div[class*='successMessage']").hide();

        switch (action)
        {
            case 'GenerateDomainApproverEmails':
                Reissue.handleGenerateDomainApproverEmailsResponse(response, params);
                break;
            case 'ReissueCertificate':
            	Reissue.handleReissueCertificateResponse(response, params);
                break;    
        }
    },

    handleGenerateDomainApproverEmailsResponse: function(response, params)
    {
    	if(response.result == "success")
    	{
    		var emailSelect = $("body select[name*='verification_email_" + params.sanIndex + "']");
    		emailSelect.empty();

    		for(var i = 0; i < (response.emails).length; i++)
    		{
    			var option = $("<option />", {value: response.emails[i], text: response.emails[i]});
    			emailSelect.append(option);
    		}
    	}
    	else
    	{
    		$("div[class*='errorMessage'] span.content").text(response.message);
    		$("div[class*='errorMessage']").show();
    	}
    },

    handleReissueCertificateResponse: function(response, params)
    {
    	if((response.result == "error"))
    	{
    		$("div[class*='errorMessage'] span.content").text(response.message);
    		$("div[class*='errorMessage']").show();
    	}
    	else
    	{
    		$('body input#serial_number').val(params.csr_serial);
    		$("div[class*='successMessage'] span.content").text("Certificate has been reissued successfully");
    		$("div[class*='successMessage']").show();
    	}
    },

	toggleValidationMethod: function(element)
	{
		var selectedMethod = element.find("option:selected").val();

		if(selectedMethod == "ADMIN")
		{
			element.parent().next().find("select[name*='verification_email_']").show();
		}
		else
		{
			element.parent().next().find("select[name*='verification_email_']").hide();
		}
	},

	getLastSanIndex: function()
	{
		var lastSanInput = $("input[name*='san_']:last");

		if(lastSanInput.length == 0)
		{
			return 0;
		}

		var name = $("input[name*='san_']:last").attr("name");
		var lastSanIndex = name.replace("san_", "");

		return lastSanIndex;
	},
};

$(document).ready(function() 
{
	Reissue.init();
});