var Revoke = {

    init: function()
    {
        Revoke.addHandlers();
    },

    addHandlers: function()
    {
        Revoke.activateDatePicker();
        Revoke.revokeHandler();
        Revoke.getCheckedReason();
    },

    activateDatePicker: function ()
    {
        var certumpid = $('input[name="certumpid"]').val();
        var max = $('input[name="maxDatePicker"]').val();
        var min = $('input[name="minDatePicker"]').val();

        $('.reasonRadio').change(function () {
            if ($('#KEYCOMPROMISE').prop("checked") && certumpid != '831' && certumpid != '832' && certumpid != '833'
                && certumpid != '841' && certumpid != '842' && certumpid != '843' && certumpid != '316'
                && certumpid != '317' && certumpid != '318') {
                $('.datePicker').append(
                    '<td class="datePickerTR">Key compromitation date</td>' +
                    '<td class="datePickerTR">' +
                    '<input id="compromitationDate" type="date" name="startdate" value="" max="'+ max +'" min="' + min + '"/>' +
                    '</td>'
                );
            }else {
                $('.datePickerTR').remove();
            }
        });
    },

    getCheckedReason: function () {
        let reasonName;

        $('.reasonRadio').each(function () {
            if ($(this).prop("checked")){
                reasonName = $(this).attr('id');
            }
        });

        return reasonName;
    },

    revokeHandler: function () {
        $('body').on('click', "button[name='revoke_confirm']", function(event) {
            event.preventDefault();

            var params = {
                serviceId: $("input[name='serviceId']").val(),
                productId: $("input[name='productId']").val(),
                serial_number: $("input[name='serial_number']").val(),
                reason: Revoke.getCheckedReason(),
                compromitationDate: $('#compromitationDate').val(),
                revokationNotes: $('#revokationNotes').val()
            };

            Revoke.sendRequest("RevokeCertificate", params);
            $('#revokeButton').prop( "disabled", true );
        });
    },

    sendRequest: function (action, params)
    {
        $.ajax({
            url: "../modules/servers/CERTUM_Certificates/ajax.php",
            type: 'POST',
            async: true,
            dataType: 'json',
            data: {request: action, parameters: params},
            error: function (response) {
                console.log(response);
            },
            success: function (response) {
                Revoke.handleResponse(response['result'], response['message']);
            }
        });
    },

    handleResponse: function (response, message)
    {
        if (response == 'success'){
            if (! $('#alertS').length ) {
                $('#alertDiv').append(
                    '<div id="alertS" class="alert alert-success" role="alert">Success!</div>'
                );
            }
            setTimeout(Revoke.forwardToHome, 250);
        }else {
            if (! $('#alertD').length ){
                $('#alertDiv').append(
                    '<div id="alertD" class="alert alert-danger" role="alert">' + message + '</div>'
                );
            }
            $('#revokeButton').prop( "disabled", false );
        }
    },

    forwardToHome: function () {
        let url = window.location.href;
        window.location.replace(url.replace("&modop=custom&a=revokeCertificate", ""));
    },
};

$(document).ready(function(){
    Revoke.init();

    var certumpid = $('input[name="certumpid"]').val();
    if (certumpid === '831' || certumpid === '832' || certumpid === '833' || certumpid === '841' ||
        certumpid === '842' || certumpid === '843' || certumpid === '316' || certumpid === '317' ||
        certumpid === '318')
    {
        $('.datePickerTR').remove();
    }

    var serial = $('input[name="serial_number"]').val();console.log(serial);
    if (!serial){
        Revoke.forwardToHome();
    }
});