<?php
/**
 * Partner API Library
 * 
 * @copyright Copyright (c) 2015 Unizeto Technologies SA
 * @license license.txt
 */

require_once 'message.php';
require_once ROOTDIR.'/modules/servers/CERTUM_Certificates//certumPartnerAPI/types/typeChangeVerificationRequest.php';

/*
<message name="PartnerServicePortType_changeVerification">
	<part element="tns:addSanVerification" name="addSanVerification">
	</part>
</message>
<xs:element name="addSanVerification" nillable="true" type="tns:changeVerificationRequest"/>
*/

/**
 * This class represents the PartnerServicePortType_changeVerification WSDL message.
 *
 * It has one part 'addSanVerification' accessible as property or by invoking a getter method.
 *
 * @method PartnerAPIMessageChangeVerification setCredentials(string $userName, string $password) Overriden method. Read documentation for PartnerAPIMessage class
 * @property PartnerAPITypeChangeVerificationRequest $changeVerification
 * @method PartnerAPITypeChangeVerificationRequest getChangeVerification()
 * 
 * @package messages
 */
class PartnerAPIMessageChangeVerification extends PartnerAPIMessage {
    
    /**
     * Defines the part with credentials data.
     * 
     * @var string
     */
    protected $partWithCredentials = 'addSanVerification';
    
    /**
     * This method returns initial data for the message's parts.
     * 
     * @return array
     */
    protected function initParts() {
        return array(
            'addSanVerification' => new PartnerAPITypeChangeVerificationRequest()
        );
    }


}
