<?php
/**
 * Partner API Library
 *
 * @copyright Copyright (c) 2020 Asseco Data Systems SA
 * @license license.txt
 */

require_once 'message.php';
require_once ROOTDIR.'/modules/servers/CERTUM_Certificates/certumPartnerAPI/types/typePerformSanVerificationResponse.php';

/*
<message name="PartnerServicePortType_performSanVerificationResponse">
    <part name="performSanVerificationResponse" element="tns:performSanVerificationResponse">
    </part>
</message>
<xs:element name="performSanVerificationResponse" nillable="true" type="tns:performSanVerificationResponse"/>
*/

/**
 * This class represents the PartnerServicePortType_performSanVerificationResponse WSDL message.
 *
 * It has one part 'performSanVerificationResponse' accessible as property or by invoking a getter method.
 *
 * @property PartnerAPITypePerformSanVerificationResponse $performSanVerificationResponse
 * @method PartnerAPITypePerformSanVerificationResponse getPerformSanVerificationResponse()
 *
 * @package messages
 */
class PartnerAPIMessagePerformSanVerificationResponse extends PartnerAPIMessage {


    /**
     * This method returns initial data for the message's parts.
     *
     * @return array
     */
    protected function initParts() {
        return array(
            'performSanVerificationResponse' => new PartnerAPITypePerformSanVerificationResponse()
        );
    }


}
