<?php
/**
 * Partner API Library
 * 
 * @copyright Copyright (c) 2015 Unizeto Technologies SA
 * @license license.txt
 */

require_once 'operation.php';
require_once ROOTDIR.'/modules/servers/CERTUM_Certificates//certumPartnerAPI/messages/messageGetOrderStateByOrderID.php';
require_once ROOTDIR.'/modules/servers/CERTUM_Certificates//certumPartnerAPI/messages/messageGetOrderStateByOrderIDResponse.php';

/*
<operation name="getOrderByOrderID" parameterOrder="getOrderByOrderID">
	<input message="tns:PartnerServicePortType_getOrderByOrderID">
	</input>
	<output message="tns:PartnerServicePortType_getOrderByOrderIDResponse">
	</output>
</operation>
*/

/**
 * This class represents the getOrderByOrderID WSDL operation.
 *
 * It is based on the PartnerAPIOperation class and derives some properties and methods from that class.
 *
 * @method PartnerAPIMessageGetOrderStateByOrderIDResponse getResponseMessage() A complete response from a service
 * 
 * @package operations
 */
class PartnerAPIOperationGetOrderStateByOrderID extends PartnerAPIOperation {

    /**
     * @var PartnerAPIMessageGetOrderStateByOrderID
     */
    protected $_input = NULL;
    
    /**
     * @var PartnerAPIMessageGetOrderStateByOrderIDResponse
     */
    protected $_output = NULL;

    /**
     * @var string
     */
    protected $_operation = 'getOrderState';
    
    /**
     * The constructor.
     * 
     * It initializes input and output data.
     */
    public function __construct() {
        $this->_input  = new PartnerAPIMessageGetOrderStateByOrderID();
        $this->_output = new PartnerAPIMessageGetOrderStateByOrderIDResponse();
    }
    
    /**
     * Sets an order ID for the request.
     * 
     * Setting this value is required.
     * 
     * @param string $orderID
     * @return PartnerAPIOperationGetOrderByOrderID
     */
    public function setOrderID($orderID) {
        $this->_input->getOrderStateByOrderID->setOrderID($orderID);
        return $this;
    }
    
    public function getData() {
        $orderList = array();
        return $this->_output->getOrderStateByOrderIDResponse;
    }

}
