<?php
/**
 * Partner API Library
 * 
 * @copyright Copyright (c) 2013-2014 Unizeto Technologies SA
 * @license license.txt
 */

require_once 'type.php';
require_once 'typeProduct.php';

/*
    <xs:complexType name="getProductListResponse">
		<xs:complexContent>
			<xs:extension base="tns:response">
				<xs:sequence>
					<xs:element minOccurs="0" name="products">
						<xs:complexType>
							<xs:sequence>
								<xs:element maxOccurs="unbounded" name="product" type="tns:product"/>
							</xs:sequence>
						</xs:complexType>
					</xs:element>
				</xs:sequence>
			</xs:extension>
		</xs:complexContent>
	</xs:complexType>
*/

/**
 * This class represents the "products" WSDL type.
 * 
 * It is based on the PartnerAPIType class and derives some properties and methods from that class.
 * 
 * @method PartnerAPITypeProducts setProduct(PartnerAPITypeProduct $value The product to be set) Sets the "product" element. This method removes all previously added "product" elements and creates a new set of "product" elements.
 * @method PartnerAPITypeProducts addProduct(PartnerAPITypeProduct $value The product to be added) Adds a new "product" element to the existing set.
 * @method PartnerAPITypeProduct|PartnerAPITypeProduct[] getProduct() Gets the "product" element. If there is only one element, it will be returned, otherwise an array of PartnerAPITypeProduct objects will be returned.
 * @property PartnerAPITypeProduct|PartnerAPITypeProduct[] $product Gets the "product" element. If there is only one element, it will be returned, otherwise an array of PartnerAPITypeProduct objects will be returned.
 * 
 * @package types
 * @since 1.3.0
 */
class PartnerAPITypeProducts extends PartnerAPIType {
    
    protected function initData() {
        return array(
            'product' => array('min' => 1, 'max' => NULL, 'value' => new PartnerAPITypeProduct(), 'type' => 'PartnerAPITypeProduct', 'nillable' => FALSE)
        );
    }

}
