<?php
/**
 * Partner API Library
 * 
 * @copyright Copyright (c) 2015 Unizeto Technologies SA
 * @license license.txt
 */

require_once 'type.php';
require_once 'typeValidityPeriod.php';

/**
 * This class represents the orderParameters WSDL type.
 *
 * It is based on the PartnerAPIType class and derives properties and methods from that class.
 * 
 * @method PartnerAPITypeSanApprovers setApproverMethod(string $value)
 * 
 * @method PartnerAPITypeSanApprovers setApproverEmail(string $value)
 * 
 * @method PartnerAPITypeSanApprovers setApproverEmailPrefix(string $value)
 * 
 * @method PartnerAPITypeSanApprovers setVerificationNotificationEnabled(boolean $value) 
 * 

 * @package types
 */
class PartnerAPITypeSanApprovers extends PartnerAPIType {
    
    protected function initData() {
        $n = array(
            'approverMethod'                   => array('min' => 0, 'max' => 1, 'value' => NULL, 'type' => 'string', 'nillable' => FALSE),
            'approverEmail'                    => array('min' => 0, 'max' => 1, 'value' => NULL, 'type' => 'string', 'nillable' => FALSE),
            'approverEmailPrefix'              => array('min' => 0, 'max' => 1, 'value' => NULL, 'type' => 'string', 'nillable' => FALSE),
            'verificationNotificationEnabled'  => array('min' => 0, 'max' => 1, 'value' => NULL, 'type' => 'boolean', 'nillable' => FALSE)
        );
        return $n;
    }


}
