<?php

namespace MGModule\CERTUM_Certificates\helpers;

use WHMCS\Database\Capsule;

abstract class Ajax
{
    private $parameters = null;
    
    public function __construct($params)
    {
        $this->parameters = $params;   
    }
    
    public function execute()
    {
        try 
        {
            $this->auth();
            $response = $this->action($this->parameters);
        } 
        catch (\Exception $e) 
        {
            $response = ["result" => "error", "message" => $e->getMessage()];
        }
        finally
        {
            return json_encode($response);
        }
    }

    private function auth()
    {
        if(isset($_SESSION['adminid']) && !empty($_SESSION['adminid']))
        {
            return true;
        }

        if(isset($_SESSION['uid']) && !empty($_SESSION['uid']))
        {
            if(!isset($this->parameters['serviceId']))
            {
                return true;
            }

            $checkService = Capsule::table('tblhosting')
                ->where('id', $this->parameters['serviceId'])
                ->where('userid', $_SESSION['uid'])
                ->first();

            if(isset($checkService->id))
            {
                return true;
            }
        }

        throw new \Exception('401 – Unauthorized');

    }
    
    abstract public function action($params);
}
