<?php

namespace MGModule\CERTUM_Certificates\helpers\AjaxRequests;

use MGModule\CERTUM_Certificates\helpers\Ajax;
use MGModule\CERTUM_Certificates\helpers\Product;
use PartnerAPIService;
use WHMCS\Database\Capsule as DB;

require_once dirname(__DIR__).DIRECTORY_SEPARATOR."Ajax.php";
require_once dirname(__DIR__).DIRECTORY_SEPARATOR."Product.php";
require_once dirname(__DIR__).DIRECTORY_SEPARATOR."SslService.php";
require_once dirname(__DIR__).DIRECTORY_SEPARATOR."Domain.php";
require_once dirname(dirname(__DIR__)).DIRECTORY_SEPARATOR."certumPartnerAPI".DIRECTORY_SEPARATOR."service.php";

class ChangeVerification extends Ajax
{
    public function __construct($params = [])
    {
        parent::__construct($params);
    }
    
    public function action($parameters)
    {   

        $product = new Product($parameters['productId']);
        $configuration = $product->getConfiguration();

        $api = new PartnerAPIService($configuration->configoption1, $configuration->configoption2, $configuration->configoption10);

        $r = DB::table('tblsslorders')
                ->select('tblsslorders.*', 'certum_approvers.data as approver_details')
                ->join('certum_approvers', 'certum_approvers.serviceid', '=', 'tblsslorders.serviceid')
                ->where('tblsslorders.serviceid', '=', $parameters['serviceId'])
                ->first();
        
        $op = $api->operationChangeVerification();

        if (empty($r->remoteid)) {
            throw new Exception("Certificate not found.");
        }
        
        $op->setOrderID($r->remoteid);
        
        $op->setSANApprover($parameters['method'], $parameters['email'], $parameters['emailprefix'], $parameters['approvenotification']);
 

        if (!$op->call()) {
            $error = $op->getErrorTexts();

            if ($error[0]['text']) 
            {
                throw new \Exception($error[0]['text']);
            } 
            else 
            {
                $errors = $op->getErrors();
                throw new \Exception('Change verification error: ' . $errors[0]->errorCode);
            }
        }

        return ["result" => "success"];
    }
}