<?php

namespace MGModule\CERTUM_Certificates\helpers\AjaxRequests;

use MGModule\CERTUM_Certificates\helpers\Ajax;
use MGModule\CERTUM_Certificates\helpers\Domain;

require_once dirname(__DIR__).DIRECTORY_SEPARATOR."Ajax.php";
require_once dirname(__DIR__).DIRECTORY_SEPARATOR."Domain.php";

class GenerateDomainApproverEmails extends Ajax
{
    public function __construct($params = [])
    {
        parent::__construct($params);
    }
    
    public function action($parameters)
    {   
    	if(!isset($parameters['domain']))
    	{
    		throw new \Exception("'Domain' parameter is not defined");
    	}

        if(empty($parameters['domain']))
        {
            $approverEmails = [];
        }
        else
        {
        	$domain = new Domain($parameters['domain']);
        	$approverEmails = $domain->generateApproverEmails();
        }

    	return ["result" => "success", "emails" => $approverEmails];
    }
}
