<?php

namespace MGModule\CERTUM_Certificates\helpers\AjaxRequests;

use MGModule\CERTUM_Certificates\helpers\Ajax;
use MGModule\CERTUM_Certificates\helpers\Certificate;

require_once dirname(__DIR__).DIRECTORY_SEPARATOR."Ajax.php";
require_once dirname(__DIR__).DIRECTORY_SEPARATOR."Certificate.php";

class GetDomainFromCsr extends Ajax
{
    public function __construct($params = [])
    {
        parent::__construct($params);
    }
    
    public function action($parameters)
    {   

    	if(!isset($parameters['csr']))
    	{
    		throw new \Exception("'CSR' parameter is not defined");
    	}

    	$domain = Certificate::getSubject($parameters['csr'], Certificate::SUBJECT_COMMON_NAME);

        if(!$domain)
        {
            throw new \Exception("Invalid CSR");
        }
        
    	return ["result" => "success", "domain" => $domain];
    }
}