<?php

namespace MGModule\CERTUM_Certificates\helpers\AjaxRequests;

use MGModule\CERTUM_Certificates\helpers\Ajax;
use MGModule\CERTUM_Certificates\helpers\Product;
use MGModule\CERTUM_Certificates\helpers\Domain;
use MGModule\CERTUM_Certificates\utilities\Collection;
use PartnerAPIService;

require_once dirname(__DIR__).DIRECTORY_SEPARATOR."Ajax.php";
require_once dirname(__DIR__).DIRECTORY_SEPARATOR."Product.php";
require_once dirname(__DIR__).DIRECTORY_SEPARATOR."Domain.php";
require_once dirname(dirname(__DIR__)).DIRECTORY_SEPARATOR."certumPartnerAPI".DIRECTORY_SEPARATOR."service.php";
require_once dirname(dirname(__DIR__)).DIRECTORY_SEPARATOR."utilities".DIRECTORY_SEPARATOR."Collection.php";

class GetSanConfigurationForm extends Ajax
{
    public function __construct($params = [])
    {
        parent::__construct($params);
    }
    
    public function action($parameters)
    {   
        if(!isset($parameters['productId']) || !isset($parameters['serviceId']))
        {
            throw new \Exception("'Product ID' or 'Service ID' parameter is not defined");
        }

        $product = new Product($parameters['productId']);
        $configuration = $product->getConfiguration();

        $api = new PartnerAPIService($configuration->configoption1, $configuration->configoption2, $configuration->configoption10);
        
        $methods = $product->getApproverMethods();

        $html = "";
        
        $html2 = "";

        if($configuration->configoption7 == "on")
        {
            $html .= '<tr name="additional_san" style="display:none;">
                <td style="width:33%">
                    <input type="text" class="radius" style="max-width:200px;" data-type="new" name="san" />
                </td>
                <td style="width:33%">
                    <div class="form-group" style="width: 150px;padding-top:18px;">
                        <input type="checkbox" class="form-check-input" name="add_prefix_www" />
                        <label class="form-check-label">Add prefix \'www\'</label>
                    </div>
                </td>
                <td style="width:33%">
                    <button class="btn btn-danger" name="remove_san">Remove</button>
                </td>
                </tr>';

                $html .= '<tr><td colspan="5"><button class="btn btn-info" name="add_new_domain" style="float:right;">Add New Domain</button></td></tr><tr><td colspan="5"><button class="btn btn-info" style="display:none;float:right;" name="add_san">Add New Domain</button></td></tr>';
                
                $html2 = '<div class="approve_section" style="display:none;"><div class="row" style="margin-top: 30px;">
                    <div class="form-group col-sm-12 col-xs-12">
                        <select id="approvermethod" class="form-control method" name="method" style="width: 260px;float: left;margin-right: 15px;margin-top: -5px;">
                            <option>FILE</option>
                            <option>DNS_TXT</option><option>DNS_CNAME</option><option>DNS_TXT_PREFIX</option><option>DNS_CNAME_PREFIX</option>
                            <option>ADMIN</option>
                        </select> Approve method
                    </div>
                    </div>

                    <div class="row">   
                    <div class="form-group col-sm-12 col-xs-12">
                        <input type="email" name="emailaddress" class="form-control" placeholder="Email address" style="width: 260px;float: left;margin-right: 15px;margin-top: -5px;"> This e-mail address will receive verification message*
                    </div>
                    </div>

                    <div class="row" style="display:none">
                    <div class="form-group col-sm-12 col-xs-12">
                        <select class="emailprefix form-control" name="emailprefix" style="width: 260px;float: left;margin-right: 15px;margin-top: -5px;" disabled>
                           <option value="ADMIN">ADMIN</option>
                            <option value="ADMINISTRATOR">ADMINISTRATOR</option>
                            <option value="HOSTMASTER">HOSTMASTER</option>
                            <option value="POSTMASTER">POSTMASTER</option>
                            <option value="WEBMASTER">WEBMASTER</option>
                        </select> Administrative email type
                    </div>
                    </div>

                    <div class="checkbox">
                        <label>
                            <input type="checkbox" name="approvenotification" checked value="1"> Send verification messages
                        </label>
                    </div>
                </div></div>';
                             
        }

        return ["result" => "success", "html" => $html, 'html2' => $html2];
    }
}