<?php

namespace MGModule\CERTUM_Certificates\helpers;

class Certificate
{
    const SUBJECT_ORGANIZATION = "O";
    const SUBJECT_ORGANIZATION_UNIT = "OU";
    const SUBJECT_EMAIL = "emailAddress";
    const SUBJECT_LOCATION = "L";
    const SUBJECT_COUNTRY = "C";
    const SUBJECT_COMMON_NAME = "CN";
    const SUBJECT_STATE = "ST";

    public static function getSubject($csr, $subjectParam = null)
    {
        $subject = openssl_csr_get_subject($csr);

        if(!is_null($subjectParam) && isset($subject[$subjectParam]))
        {
            return $subject[$subjectParam];
        }

        return $subject;
    }
}
