<?php

namespace MGModule\CERTUM_Certificates\helpers\Configuration;

class Commercial
{
    protected $productId;

    public function __construct($productId)
    {
        $this->productId = $productId;
    }

    public function certificteDetailsSection()
    {
        $fields = [];

        $fields['Certificate Details']['CommonName'] = array(
            'FriendlyName' => CERTUM_Certificates_translate('CommonName').' *',
            'Type'         => 'text',
            'Size'         => '30',
            'Description'  => '',
            'Required'     => true
        );

        return $fields;
    }

    public function contactDetailsSection($field, $t)
    {
        $fields = [];
        $fields[$field . 'FirstName'] = array(
            'FriendlyName' => CERTUM_Certificates_translate('first_name'),
            'Type'         => 'text',
            'Size'         => '30',
            'Description'  => '<style type="text/css">#servertype,label[for=servertype] {display:none!important;}</style><script type="text/javascript">$(function(){
                                $("select[name=servertype]").val(1000);
                                //$("select[name=servertype]").closest(".control-group").hide();

                                    $("input[name=\'fields[AdminLastName]\']").attr("placeholder","Doe");
                                    $("input[name=\'fields[AdminFirstName]\']").attr("placeholder","John");
                                    $("input[name=\'fields[AdminLastName]\']").attr("placeholder","Doe");
                                    $("input[name=\'fields[AdminName]\']").attr("placeholder","Certum");
                                    $("input[name=\'fields[AdminTax]\']").attr("placeholder","P90525548").attr("maxlength",20);
                                    $("input[name=\'fields[AdminAddress1]\']").attr("placeholder","2800 South Alabama Ave");
                                    $("input[name=\'fields[AdminCity]\']").attr("placeholder","Monroeville");
                                    $("input[name=\'fields[AdminPostalCode]\']").attr("placeholder","36460");
                                    $("input[name=\'fields[AdminPhone]\']").attr("placeholder","+480000000000");
                                    $("input[name=\'fields[AdminVerificationPhone]\']").attr("placeholder","+480000000000");
                                    $("input[name=\'fields[AdminEmail]\']").attr("placeholder","test@example.com");
                                    
                                    $( "<p>'.CERTUM_Certificates_translate('dv_contact_desc').'</p>" ).insertBefore($("input[name=\'fields[AdminLastName]\']").parents(".form-horizontal"));
                                    
                                });
                                $("#csr").closest("div").css("margin-left","125px");
                                $("label[for=csr]").css("width","125px").css("text-align","left");
                                $("label[for=csr]").closest("div").css("margin-top","10px");
                                $("select[name=\'fields[AdminCountry]\'").css("width","220px").hide();
                                
                                $("body").on("input", "input[name=\"fields[AdminFirstName]\"]", function (){
                                    updateAlertContactDetails($(this));
                                });
                                $("body").on("input", "input[name=\"fields[AdminLastName]\"]", function (){
                                    updateAlertContactDetails($(this));
                                });
                                $("body").on("input", "input[name=\"fields[AdminPhone]\"]", function (){
                                    updateAlertContactDetails($(this));
                                });
                                $("body").on("input", "input[name=\"fields[AdminEmail]\"]", function (){
                                    updateAlertContactDetails($(this));
                                });
                                
                                function updateAlertContactDetails(me)
                                {
                                    var alert = $(me).parent("div").parent("div").parent("fieldset");
                                    var firstname = $("input[name=\"fields[AdminFirstName]\"]").val();
                                    var lastname = $("input[name=\"fields[AdminLastName]\"]").val();
                                    var phonenumber = $("input[name=\"fields[AdminPhone]\"]").val();
                                    var email = $("input[name=\"fields[AdminEmail]\"]").val();
                                    
                                    var firstnametext = $("input[name=\"fields[AdminFirstName]\"]").parent("div").prev("label").text();
                                    firstnametext = firstnametext.replace(" *","");
                                    
                                    var lastnametext = $("input[name=\"fields[AdminLastName]\"]").parent("div").prev("label").text();
                                    lastnametext = lastnametext.replace(" *","");
                                    
                                    var phonetext = $("input[name=\"fields[AdminPhone]\"]").parent("div").prev("label").text();
                                    phonetext = phonetext.replace(" *","");
                                    
                                    var emailtext = $("input[name=\"fields[AdminEmail]\"]").parent("div").prev("label").text();
                                    emailtext = emailtext.replace(" *","");
                                    
                                    if(firstname != "" || lastname != "" || phonenumber != "" || email != "")
                                    {
                                        $(".alertContactDetails").remove();
                                        $("<div class=\"alert alert-warning alertContactDetails\">'.CERTUM_Certificates_translate('contact_fields_error').'</div>" ).insertBefore(alert);
          
                                        $("input[name=\"fields[AdminFirstName]\"]").parent("div").prev("label").text(firstnametext+" *");
                                        $("input[name=\"fields[AdminLastName]\"]").parent("div").prev("label").text(lastnametext+" *");
                                        $("input[name=\"fields[AdminEmail]\"]").parent("div").prev("label").text(emailtext+" *");
                                        
                                        $("input[name=\"fields[AdminFirstName]\"]").attr("required", "required");
                                        $("input[name=\"fields[AdminLastName]\"]").attr("required", "required");
                                        $("input[name=\"fields[AdminEmail]\"]").attr("required", "required");
                                    }
                                    else
                                    {
                                        $(".alertContactDetails").remove();
                                        
                                        $("input[name=\"fields[AdminFirstName]\"]").parent("div").prev("label").text(firstnametext);
                                        $("input[name=\"fields[AdminLastName]\"]").parent("div").prev("label").text(lastnametext);
                                        $("input[name=\"fields[AdminEmail]\"]").parent("div").prev("label").text(emailtext);
                                        
                                        $("input[name=\"fields[AdminFirstName]\"]").removeAttr("required");
                                        $("input[name=\"fields[AdminLastName]\"]").removeAttr("required");
                                        $("input[name=\"fields[AdminEmail]\"]").removeAttr("required");
                                    }
                                }
                                

                                ' . (isset($_POST['csr']) && !empty($_POST['csr']) ? '$("#csr").text("' . str_replace("\r", '\n\\', $_POST['csr']) . '");' : '') . '
                                </script>',
            'Required'     => false,
        );
        $fields[$field . 'LastName'] = array(
            'FriendlyName' => CERTUM_Certificates_translate('last_name'),
            'Type'         => 'text',
            'Size'         => '30',
            'Description'  => '',
            'Required'     => false,
        );

        if($this->productId == '691' || $this->productId == '791')
        {
            $fields[$field . 'Name'] = array
            (
                'FriendlyName' => CERTUM_Certificates_translate('organization'),
                'Type'         => 'text',
                'Size'         => '30',
                'Description'  => '',
                'Required'     => false,
            );
        }

        $fields[$field . 'Phone'] = array(
            'FriendlyName' => CERTUM_Certificates_translate('phone'),
            'Type'         => 'text',
            'Size'         => '30',
            'Description'  => CERTUM_Certificates_translate('phone_description'),
            'Required'     => false,
        );
        $fields[$field . 'Email'] = array(
            'FriendlyName' => CERTUM_Certificates_translate('email'),
            'Type'         => 'text',
            'Size'         => '30',
            'Description'  => '',
            'Required'     => false,
        );

        if(
            $this->productId != '691' && $this->productId != '791' &&
            $this->productId != '731' && $this->productId != '732' && $this->productId != '733' &&
            $this->productId != '501' && $this->productId != '502'
        )
        {
            $fields[$field . 'RevocationContactEmail'] = array(
                'FriendlyName' => CERTUM_Certificates_translate('RevocationContactEmail'),
                'Type'         => 'text',
                'Size'         => '30',
                'Description'  => '',
                'Required'     => false,
            );
        }
        return $fields;
    }

}