<?php

namespace MGModule\CERTUM_Certificates\helpers\Configuration;

class DocumentSigning
{
    protected $productId;

    public function __construct($productId)
    {
        $this->productId = $productId;
    }

    public function certificteDetailsSection()
    {
        $fields = [];

        $fields['customer']['simplysign_account'] = array(
            'FriendlyName' => CERTUM_Certificates_translate('simplysign_account').' *',
            'Type'         => 'text',
            'Size'         => '30',
            'Description'  => '',
            'Required'     => true
        );
        $fields['Certificate Details']['CommonName'] = array(
            'FriendlyName' => CERTUM_Certificates_translate('CommonName').' *',
            'Type'         => 'text',
            'Size'         => '30',
            'Description'  => '',
            'Required'     => true
        );
        $fields['Certificate Details']['Organization'] = array(
            'FriendlyName' => CERTUM_Certificates_translate('organization').' *',
            'Type'         => 'text',
            'Size'         => '30',
            'Description'  => '',
            'Required'     => true
        );
        $fields['Certificate Details']['Country'] = array(
            'FriendlyName' => CERTUM_Certificates_translate('country').' *',
            'Type'         => 'country',
            'Size'         => '30',
            'Description'  => '',
            'Required'     => true
        );
        $fields['Certificate Details']['Email'] = array(
            'FriendlyName' => CERTUM_Certificates_translate('email').' *',
            'Type'         => 'text',
            'Size'         => '30',
            'Description'  => '',
            'Required'     => true
        );
        $fields['Certificate Details']['Locality'] = array(
            'FriendlyName' => CERTUM_Certificates_translate('Locality').' *',
            'Type'         => 'text',
            'Size'         => '30',
            'Description'  => '',
            'Required'     => false,
        );
        $fields['Certificate Details']['StateProvince'] = array(
            'FriendlyName' => CERTUM_Certificates_translate('State/Province').' *',
            'Type'         => 'text',
            'Size'         => '30',
            'Description'  => 'Locality or State/Province is required.',
            'Required'     => false
        );

        return $fields;
    }

    public function contactDetailsSection($field, $t)
    {
        $fields = [];
        $fields[$field . 'FirstName'] = array(
            'FriendlyName' => CERTUM_Certificates_translate('first_name').' *',
            'Type'         => 'text',
            'Size'         => '30',
            'Description'  => '<style type="text/css">#servertype,label[for=servertype] {display:none!important;}</style><script type="text/javascript">$(function(){
                                $("select[name=servertype]").val(1000);
                                //$("select[name=servertype]").closest(".control-group").hide();

                                    $("input[name=\'fields[AdminLastName]\']").attr("placeholder","Doe");
                                    $("input[name=\'fields[AdminFirstName]\']").attr("placeholder","John");
                                    $("input[name=\'fields[AdminLastName]\']").attr("placeholder","Doe");
                                    $("input[name=\'fields[AdminName]\']").attr("placeholder","Certum");
                                    $("input[name=\'fields[AdminTax]\']").attr("placeholder","P90525548").attr("maxlength",20);
                                    $("input[name=\'fields[AdminAddress1]\']").attr("placeholder","2800 South Alabama Ave");
                                    $("input[name=\'fields[AdminCity]\']").attr("placeholder","Monroeville");
                                    $("input[name=\'fields[AdminPostalCode]\']").attr("placeholder","36460");
                                    $("input[name=\'fields[AdminPhone]\']").attr("placeholder","+480000000000");
                                    $("input[name=\'fields[VerificationPhoneNumber]\']").attr("placeholder","+480000000000");
                                    $("input[name=\'fields[AdminEmail]\']").attr("placeholder","test@example.com");
                                    
                                    $( "<p>'.CERTUM_Certificates_translate('ov_ev_contact_desc').'</p>" ).insertBefore($("input[name=\'fields[AdminLastName]\']").parents(".form-horizontal"));
                                    
                                    
                                });
                                $("#csr").closest("div").css("margin-left","125px");
                                $("label[for=csr]").css("width","125px").css("text-align","left");
                                $("label[for=csr]").closest("div").css("margin-top","10px");
                                $("select[name=\'fields[AdminCountry]\'").css("width","220px").hide();


                                ' . (isset($_POST['csr']) && !empty($_POST['csr']) ? '$("#csr").text("' . str_replace("\r", '\n\\', $_POST['csr']) . '");' : '') . '
                                </script>',
            'Required'     => $t != 'organization' ? true : false,
        );
        $fields[$field . 'LastName'] = array(
            'FriendlyName' => CERTUM_Certificates_translate('last_name').' *',
            'Type'         => 'text',
            'Size'         => '30',
            'Description'  => '',
            'Required'     => $t != 'organization' ? true : false,
        );
        $fields[$field . 'Phone'] = array(
            'FriendlyName' => CERTUM_Certificates_translate('phone'),
            'Type'         => 'text',
            'Size'         => '30',
            'Description'  => CERTUM_Certificates_translate('phone_description'),
            'Required'     => false,
        );
        $fields[$field . 'Email'] = array(
            'FriendlyName' => CERTUM_Certificates_translate('email').' *',
            'Type'         => 'text',
            'Size'         => '30',
            'Description'  => '',
            'Required'     => true,
        );
        $fields[$field . 'RevocationContactEmail'] = array(
            'FriendlyName' => CERTUM_Certificates_translate('RevocationContactEmail'),
            'Type'         => 'text',
            'Size'         => '30',
            'Description'  => '',
            'Required'     => false,
        );

        return $fields;
    }

}