<?php

namespace MGModule\CERTUM_Certificates\helpers\Configuration;

class EmailIDBusiness_StandardCode
{
    protected $productId;

    public function __construct($productId)
    {
        $this->productId = $productId;
    }

    public function certificteDetailsSection()
    {
        $fields = [];

        if($this->productId == '831' || $this->productId == '832' || $this->productId == '833')
        {
            $fields['customer']['simplysign_account'] = array(
                'FriendlyName' => CERTUM_Certificates_translate('simplysign_account').' *',
                'Type'         => 'text',
                'Size'         => '30',
                'Description'  => '',
                'Required'     => true
            );
        }

        $fields['Certificate Details']['CommonName'] = array(
            'FriendlyName' => CERTUM_Certificates_translate('CommonName').' *',
            'Type'         => 'text',
            'Size'         => '30',
            'Description'  => '',
            'Required'     => true
        );
        $fields['Certificate Details']['Organization'] = array(
            'FriendlyName' => CERTUM_Certificates_translate('organization').' *',
            'Type'         => 'text',
            'Size'         => '30',
            'Description'  => '',
            'Required'     => true
        );
        $fields['Certificate Details']['Country'] = array(
            'FriendlyName' => CERTUM_Certificates_translate('country').' *',
            'Type'         => 'country',
            'Size'         => '30',
            'Description'  => '',
            'Required'     => true
        );

        if($this->productId == '721' || $this->productId == '722' || $this->productId == '723')
        {
            $fields['Certificate Details']['Email'] = array(
                'FriendlyName' => CERTUM_Certificates_translate('email').' *',
                'Type'         => 'text',
                'Size'         => '30',
                'Description'  => '',
                'Required'     => true
            );
        }
        else
        {
            $fields['Certificate Details']['Email'] = array(
                'FriendlyName' => CERTUM_Certificates_translate('email'),
                'Type'         => 'text',
                'Size'         => '30',
                'Description'  => '',
                'Required'     => false
            );
        }

        if($this->productId == '831' || $this->productId == '832' || $this->productId == '833')
        {
            unset($fields['Certificate Details']['Email']);
        }

        $fields['Certificate Details']['Locality'] = array(
            'FriendlyName' => CERTUM_Certificates_translate('Locality').' *',
            'Type'         => 'text',
            'Size'         => '30',
            'Description'  => '',
            'Required'     => false,
        );
        $fields['Certificate Details']['StateProvince'] = array(
            'FriendlyName' => CERTUM_Certificates_translate('State/Province').' *',
            'Type'         => 'text',
            'Size'         => '30',
            'Description'  => 'Locality or State/Province is required.',
            'Required'     => false
        );

        return $fields;
    }

}