<?php

namespace MGModule\CERTUM_Certificates\helpers\Configuration;

class S_Mime
{
    protected $productId;

    public function __construct($productId)
    {
        $this->productId = $productId;
    }

    public function certificteDetailsSection()
    {
        $fields = [];

        if($this->productId == '501' || $this->productId == '502')
        {
            $fields['Certificate Details']['CommonName'] = array(
                'FriendlyName' => CERTUM_Certificates_translate('CommonName').' *',
                'Type'         => 'text',
                'Size'         => '30',
                'Description'  => '',
                'Required'     => true
            );
            $fields['Certificate Details']['Email'] = array(
                'FriendlyName' => CERTUM_Certificates_translate('email').' *',
                'Type'         => 'text',
                'Size'         => '30',
                'Description'  => '',
                'Required'     => true
            );
            return $fields;
        }

        if($this->productId != '531' && $this->productId != '532') {
            $fields['Certificate Details']['GivenName'] = array(
                'FriendlyName' => CERTUM_Certificates_translate('GivenName') . ' *',
                'Type' => 'text',
                'Size' => '30',
                'Description' => '',
                'Required' => true
            );
            $fields['Certificate Details']['Surname'] = array(
                'FriendlyName' => CERTUM_Certificates_translate('Surname') . ' *',
                'Type' => 'text',
                'Size' => '30',
                'Description' => '',
                'Required' => true
            );
        }
        if($this->productId == '521' || $this->productId == '522' || $this->productId == '531' || $this->productId == '532')
        {
            $fields['Certificate Details']['Organization'] = array(
                'FriendlyName' => CERTUM_Certificates_translate('organization').' *',
                'Type'         => 'text',
                'Size'         => '30',
                'Description'  => '',
                'Required'     => true
            );
            $fields['Certificate Details']['Country'] = array(
                'FriendlyName' => CERTUM_Certificates_translate('country').' *',
                'Type'         => 'country',
                'Size'         => '30',
                'Description'  => '',
                'Required'     => true
            );
        }

        $fields['Certificate Details']['Email'] = array(
            'FriendlyName' => CERTUM_Certificates_translate('email').' *',
            'Type'         => 'text',
            'Size'         => '30',
            'Description'  => '',
            'Required'     => true
        );

        if($this->productId == '521' || $this->productId == '522' || $this->productId == '531' || $this->productId == '532')
        {
            $fields['Certificate Details']['Locality'] = array(
                'FriendlyName' => CERTUM_Certificates_translate('Locality').' *',
                'Type'         => 'text',
                'Size'         => '30',
                'Description'  => '',
                'Required'     => true,
            );
            $fields['Certificate Details']['StateProvince'] = array(
                'FriendlyName' => CERTUM_Certificates_translate('State/Province'),
                'Type'         => 'text',
                'Size'         => '30',
                'Description'  => '',
                'Required'     => false
            );
        }

        $fields['Certificate Details']['CommonName'] = array(
            'FriendlyName' => CERTUM_Certificates_translate('CommonName').' *',
            'Type'         => 'dropdown',
            'Size'         => '30',
            'Description'  => '',
            'Options'      => 'Please choose...',
            'Required'     => true
        );

        return $fields;
    }

    public function contactDetailsSection($field, $t)
    {
        $fields = [];
        $additionalJSMIME = '';
        if($this->productId == '531' || $this->productId == '532')
        {
            $additionalJSMIME = '
                let organization = $("input[name=\"fields[Organization]\"]").val();
                let email = $("input[name=\"fields[Email]\"]").val();
               
                $("body").on("input", "input[name=\"fields[Organization]\"]", function (){
                    let organization = $("input[name=\"fields[Organization]\"]").val();
                    let email = $("input[name=\"fields[Email]\"]").val();
                    if(validateEmail(email) && organization != "")
                    {
                        $("select[name=\"fields[CommonName]\"]").html("<option>"+email+"</option><option>"+organization+"</option>>");
                    }
                    else
                    {
                        $("select[name=\"fields[CommonName]\"]").html("<option>Please choose...</option>");
                    }
                });
                
                $("body").on("input", "input[name=\"fields[Email]\"]", function (){
                    let organization = $("input[name=\"fields[Organization]\"]").val();
                    let email = $("input[name=\"fields[Email]\"]").val();
                    if(validateEmail(email) && organization != "")
                    {
                        $("select[name=\"fields[CommonName]\"]").html("<option>"+email+"</option><option>"+organization+"</option>>");
                    }
                    else
                    {
                        $("select[name=\"fields[CommonName]\"]").html("<option>Please choose...</option>");
                    }
                });
                
                if(validateEmail(email) && organization != "")
                {
                    $("select[name=\"fields[CommonName]\"]").html("<option>"+email+"</option><option>"+organization+"</option>>");
                }
                else
                {
                    $("select[name=\"fields[CommonName]\"]").html("<option>Please choose...</option>");
                }
            ';
        }
        if($this->productId == '511' || $this->productId == '512' || $this->productId == '521' || $this->productId == '522')
        {
            $additionalJSMIME = '
                let givenName = $("input[name=\"fields[GivenName]\"]").val();
                let surname = $("input[name=\"fields[Surname]\"]").val();
                let email = $("input[name=\"fields[Email]\"]").val();
               
                $("body").on("input", "input[name=\"fields[GivenName]\"]", function (){
                    let givenName = $("input[name=\"fields[GivenName]\"]").val();
                    let surname = $("input[name=\"fields[Surname]\"]").val();
                    let email = $("input[name=\"fields[Email]\"]").val();
                    if(validateEmail(email) && givenName != "" && surname != "")
                    {
                        $("select[name=\"fields[CommonName]\"]").html("<option>"+email+"</option><option>"+givenName+" "+surname+"</option>>");
                    }
                    else
                    {
                        $("select[name=\"fields[CommonName]\"]").html("<option>Please choose...</option>");
                    }
                });
                
                $("body").on("input", "input[name=\"fields[Surname]\"]", function (){
                    let givenName = $("input[name=\"fields[GivenName]\"]").val();
                    let surname = $("input[name=\"fields[Surname]\"]").val();
                    let email = $("input[name=\"fields[Email]\"]").val();
                    if(validateEmail(email) && givenName != "" && surname != "")
                    {
                        $("select[name=\"fields[CommonName]\"]").html("<option>"+email+"</option><option>"+givenName+" "+surname+"</option>>");
                    }
                    else
                    {
                        $("select[name=\"fields[CommonName]\"]").html("<option>Please choose...</option>");
                    }
                });
                
                $("body").on("input", "input[name=\"fields[Email]\"]", function (){
                    let givenName = $("input[name=\"fields[GivenName]\"]").val();
                    let surname = $("input[name=\"fields[Surname]\"]").val();
                    let email = $("input[name=\"fields[Email]\"]").val();
                    if(validateEmail(email) && givenName != "" && surname != "")
                    {
                        $("select[name=\"fields[CommonName]\"]").html("<option>"+email+"</option><option>"+givenName+" "+surname+"</option>>");
                    }
                    else
                    {
                        $("select[name=\"fields[CommonName]\"]").html("<option>Please choose...</option>");
                    }
                });
                
                if(validateEmail(email) && givenName != "" && surname != "")
                {
                    $("select[name=\"fields[CommonName]\"]").html("<option>"+email+"</option><option>"+givenName+" "+surname+"</option>>");
                }
                else
                {
                    $("select[name=\"fields[CommonName]\"]").html("<option>Please choose...</option>");
                }
            ';
        }

        $desc = CERTUM_Certificates_translate('s_mime_desc');
        if($this->productId == '531' || $this->productId == '532')
        {
            $desc = CERTUM_Certificates_translate('s_mime_org_desc');
        }

        $additionajJS_Individual_Sponsor = '';
        if($this->productId == '511' || $this->productId == '512' || $this->productId == '521' || $this->productId == '522')
        {
            $additionajJS_Individual_Sponsor .= '$("input[name=\'fields[AdminFirstName]\']").prop("readonly", true);
                                                $("body").on("input", "input[name=\"fields[GivenName]\"]", function (){
                                                    $("input[name=\'fields[AdminFirstName]\']").val($(this).val()).trigger("input");
                                                });';
            $additionajJS_Individual_Sponsor .= '$("input[name=\'fields[AdminLastName]\']").prop("readonly", true);
                                                $("body").on("input", "input[name=\"fields[Surname]\"]", function (){
                                                    $("input[name=\'fields[AdminLastName]\']").val($(this).val()).trigger("input");
                                                });';
            $additionajJS_Individual_Sponsor .= '$("input[name=\'fields[AdminEmail]\']").prop("readonly", true);
                                                $("body").on("input", "input[name=\"fields[Email]\"]", function (){
                                                    $("input[name=\'fields[AdminEmail]\']").val($(this).val()).trigger("input");
                                                });';
        }

        $fields[$field . 'FirstName'] = array(
            'FriendlyName' => CERTUM_Certificates_translate('first_name').' *',
            'Type'         => 'text',
            'Size'         => '30',
            'Description'  => '<style type="text/css">.main-content .form-group select[name="fields[CommonName]"]{width: 261px;}#servertype,label[for=servertype] {display:none!important;}</style><script type="text/javascript">$(function(){
                                $("select[name=servertype]").val(1000);

                                    $("input[name=\'fields[AdminLastName]\']").attr("placeholder","Doe");
                                    $("input[name=\'fields[AdminFirstName]\']").attr("placeholder","John");
                                    $("input[name=\'fields[AdminLastName]\']").attr("placeholder","Doe");
                                    $("input[name=\'fields[AdminName]\']").attr("placeholder","Certum");
                                    $("input[name=\'fields[AdminTax]\']").attr("placeholder","P90525548").attr("maxlength",20);
                                    $("input[name=\'fields[AdminAddress1]\']").attr("placeholder","2800 South Alabama Ave");
                                    $("input[name=\'fields[AdminCity]\']").attr("placeholder","Monroeville");
                                    $("input[name=\'fields[AdminPostalCode]\']").attr("placeholder","36460");
                                    $("input[name=\'fields[AdminPhone]\']").attr("placeholder","+480000000000");
                                    $("input[name=\'fields[AdminVerificationPhone]\']").attr("placeholder","+480000000000");
                                    $("input[name=\'fields[AdminEmail]\']").attr("placeholder","test@example.com");
                                    
                                    $( "<p>'.$desc.'</p>" ).insertBefore($("input[name=\'fields[AdminLastName]\']").parents(".form-horizontal"));
                                    
                                    '.$additionalJSMIME.'
                                    '.$additionajJS_Individual_Sponsor.'
                                });
    
                                function validateEmail(sEmail) {
                                    var reEmail = /^(?:[\w\!\#\$\%\&\'\*\+\-\/\=\?\^\`\{\|\}\~]+\.)*[\w\!\#\$\%\&\'\*\+\-\/\=\?\^\`\{\|\}\~]+@(?:(?:(?:[a-zA-Z0-9](?:[a-zA-Z0-9\-](?!\.)){0,61}[a-zA-Z0-9]?\.)+[a-zA-Z0-9](?:[a-zA-Z0-9\-](?!$)){0,61}[a-zA-Z0-9]?)|(?:\[(?:(?:[01]?\d{1,2}|2[0-4]\d|25[0-5])\.){3}(?:[01]?\d{1,2}|2[0-4]\d|25[0-5])\]))$/;
                                    if(!sEmail.match(reEmail)) {
                                    return false;
                                    }
                                    return true;
                                }
                                
                                $("#csr").closest("div").css("margin-left","125px");
                                $("label[for=csr]").css("width","125px").css("text-align","left");
                                $("label[for=csr]").closest("div").css("margin-top","10px");
                                $("select[name=\'fields[AdminCountry]\'").css("width","220px").hide();
                                
                                $("body").on("input", "input[name=\"fields[AdminFirstName]\"]", function (){
                                    updateAlertContactDetails($(this));
                                });
                                $("body").on("input", "input[name=\"fields[AdminLastName]\"]", function (){
                                    updateAlertContactDetails($(this));
                                });
                                $("body").on("input", "input[name=\"fields[AdminPhone]\"]", function (){
                                    updateAlertContactDetails($(this));
                                });
                                $("body").on("input", "input[name=\"fields[AdminEmail]\"]", function (){
                                    updateAlertContactDetails($(this));
                                });
                                
                                function updateAlertContactDetails(me)
                                {
                                    var alert = $(me).parent("div").parent("div").parent("fieldset");
                                    var firstname = $("input[name=\"fields[AdminFirstName]\"]").val();
                                    var lastname = $("input[name=\"fields[AdminLastName]\"]").val();
                                    var phonenumber = $("input[name=\"fields[AdminPhone]\"]").val();
                                    var email = $("input[name=\"fields[AdminEmail]\"]").val();
                                    
                                    var firstnametext = $("input[name=\"fields[AdminFirstName]\"]").parent("div").prev("label").text();
                                    firstnametext = firstnametext.replace(" *","");
                                    
                                    var lastnametext = $("input[name=\"fields[AdminLastName]\"]").parent("div").prev("label").text();
                                    lastnametext = lastnametext.replace(" *","");
                                    
                                    var phonetext = $("input[name=\"fields[AdminPhone]\"]").parent("div").prev("label").text();
                                    phonetext = phonetext.replace(" *","");
                                    
                                    var emailtext = $("input[name=\"fields[AdminEmail]\"]").parent("div").prev("label").text();
                                    emailtext = emailtext.replace(" *","");
                                    
                                    if(firstname != "" || lastname != "" || phonenumber != "" || email != "")
                                    {
                                        $(".alertContactDetails").remove();
                                        $("<div class=\"alert alert-warning alertContactDetails\">'.CERTUM_Certificates_translate('contact_fields_error').'</div>" ).insertBefore(alert);
          
                                        $("input[name=\"fields[AdminFirstName]\"]").parent("div").prev("label").text(firstnametext+" *");
                                        $("input[name=\"fields[AdminLastName]\"]").parent("div").prev("label").text(lastnametext+" *");
                                        $("input[name=\"fields[AdminEmail]\"]").parent("div").prev("label").text(emailtext+" *");
                                        
                                        $("input[name=\"fields[AdminFirstName]\"]").attr("required", "required");
                                        $("input[name=\"fields[AdminLastName]\"]").attr("required", "required");
                                        $("input[name=\"fields[AdminEmail]\"]").attr("required", "required");
                                    }
                                    else
                                    {
                                        $(".alertContactDetails").remove();
                                        
                                        $("input[name=\"fields[AdminFirstName]\"]").parent("div").prev("label").text(firstnametext);
                                        $("input[name=\"fields[AdminLastName]\"]").parent("div").prev("label").text(lastnametext);
                                        $("input[name=\"fields[AdminEmail]\"]").parent("div").prev("label").text(emailtext);
                                        
                                        $("input[name=\"fields[AdminFirstName]\"]").removeAttr("required");
                                        $("input[name=\"fields[AdminLastName]\"]").removeAttr("required");
                                        $("input[name=\"fields[AdminEmail]\"]").removeAttr("required");
                                    }
                                }
                                

                                ' . (isset($_POST['csr']) && !empty($_POST['csr']) ? '$("#csr").text("' . str_replace("\r", '\n\\', $_POST['csr']) . '");' : '') . '
                                </script>',
            'Required'     => true,
        );
        $fields[$field . 'LastName'] = array(
            'FriendlyName' => CERTUM_Certificates_translate('last_name').' *',
            'Type'         => 'text',
            'Size'         => '30',
            'Description'  => '',
            'Required'     => true,
        );

        $fields[$field . 'Phone'] = array(
            'FriendlyName' => CERTUM_Certificates_translate('phone'),
            'Type'         => 'text',
            'Size'         => '30',
            'Description'  => CERTUM_Certificates_translate('phone_description'),
            'Required'     => false,
        );
        $fields[$field . 'Email'] = array(
            'FriendlyName' => CERTUM_Certificates_translate('email').' *',
            'Type'         => 'text',
            'Size'         => '30',
            'Description'  => '',
            'Required'     => true,
        );

        if($this->productId == '511' || $this->productId == '512') {
            $fields[$field . 'RevocationContactEmail'] = array(
                'FriendlyName' => CERTUM_Certificates_translate('RevocationContactEmail'),
                'Type' => 'text',
                'Size' => '30',
                'Description' => '',
                'Required' => false,
            );
        }

        return $fields;
    }

}