<?php

namespace MGModule\CERTUM_Certificates\helpers;

use WHMCS\Database\Capsule as DB;

class Customer
{

    public static function getCustomerHash($userID)
    {
        self::createCustomerTable();
        
        $row = DB::table('certum_customers')->where('userid', '=', $userID)->first();

        if (empty($row) || $row == null)
        {

            return self::generateNewCustomerHash($userID);
        }

        return $row->customer;
    }

    private static function generateNewCustomerHash($userID)
    {
        $client = DB::table('tblclients')->where('id', '=', $userID)->first();

        if (!empty($client) && $client != null)
        {

            $customerHash = $client->firstname . $client->lastname . md5(uniqid());

            $params = [
                'userid'   => $userID,
                'customer' => $customerHash
            ];
            self::saveCustomerHash($params);
        }

        return $customerHash;
    }

    public static function saveCustomerHash($params)
    {
        $check = DB::table('certum_customers')->where('userid', $params['userid'])->first();
        if(isset($check->userid))
        {
            DB::table('certum_customers')->where('userid', $params['userid'])->update(array('customer' => $params['customer']));
        }
        else
        {
            DB::table('certum_customers')->insert($params);
        }
    }

    private static function createCustomerTable()
    {
        if (!DB::schema()->hasTable('certum_customers'))
        {
            DB::schema()->create('certum_customers', function($table)
            {
                $table->integer('userid')->unique()->unsigned();
                $table->char('customer', 255);
            });
        }
    }
}
