<?php

namespace MGModule\CERTUM_Certificates\helpers;

use WHMCS\Database\Capsule as DB;

class Product
{
    private $id;
    
    public function __construct($id)
    {
        $this->id = $id;
    }
    
    public function getConfiguration()
    {
        $product = DB::table('tblproducts')->where('id', '=', $this->id)->first();
        return $product;
    }

    public function getCertificateType()
    {
        $configuration = $this->getConfiguration();

        $certificateName = $configuration->configoption3;
        $nameParts = explode("|", $certificateName);

        return $nameParts;
       
    }

    public function getApproverMethods()
    {
        $type = $this->getCertificateType();

        $commercial = CERTUM_Certificates_Commercial();
        $trusted = CERTUM_Certificates_Trusted();
        $ev = CERTUM_Certificates_PremiumEVSSL();

        if(array_key_exists($type[0], $commercial) || array_key_exists($type[0], $ev) || array_key_exists($type[0], $trusted))
        {
            $methods = ["ADMIN", "FILE", "DNS_TXT", "DNS_CNAME", "DNS_TXT_PREFIX", "DNS_CNAME_PREFIX"];
        }
        else
        {
            $methods = ["ADMIN"];
        }

        return $methods;
    }
}
