<?php

/* * ********************************************************************
 * Customization Services by ModulesGarden.com
 * Copyright  ModulesGarden, INBS Group Brand, All Rights Reserved 
 * (2014-05-22, 15:41:300)
 * 
 *
 *  CREATED BY MODULESGARDEN       ->        http://modulesgarden.com
 *  CONTACT                        ->       contact@modulesgarden.com
 *
 *
 *
 *
 * This software is furnished under a license and may be used and copied
 * only  in  accordance  with  the  terms  of such  license and with the
 * inclusion of the above copyright notice.  This software  or any other
 * copies thereof may not be provided or otherwise made available to any
 * other person.  No title to and  ownership of the  software is  hereby
 * transferred.
 *
 *
 * ******************************************************************** */

/**
 * @author Maciej Husak <maciej@modulesgarden.com>
 */
use WHMCS\Database\Capsule as DB;

if(
    $_REQUEST['ajax'] == '1' && $_REQUEST['action'] == 'getDetailsCSR' &&
    ((isset($_SESSION['uid']) && !empty($_SESSION['uid'])) || (isset($_SESSION['adminid']) && !empty($_SESSION['adminid'])))
)
{
    $data = openssl_csr_get_subject($_REQUEST['csrform']);
    
    if($data === false)
    {
        $results = array();
        $results['error'] = true;
        $results['msg'] = 'Incorrect CSR.';
        echo json_encode($results);
        die();
    }
    
    if(is_array($data['CN']))
    {
        $data['CN'] = reset($data['CN']);
    }
    
    echo json_encode($data);
    die();    
}

if(
    $_REQUEST['ajax'] == '1' && $_REQUEST['action'] == 'getOrderState' &&
    ((isset($_SESSION['uid']) && !empty($_SESSION['uid'])) || (isset($_SESSION['adminid']) && !empty($_SESSION['adminid'])))
)
{

    $isAdmin = false;
    if(isset($_SESSION['adminid']) && !empty($_SESSION['adminid']))
    {
        $isAdmin = true;
    }

    if($isAdmin)
    {
        $service = DB::table('tblhosting')->where('id', $_REQUEST['id'])->first();
    }
    else
    {
        $service = DB::table('tblhosting')->where('id', $_REQUEST['id'])->where('userid', $_SESSION['uid'])->first();
    }

    if(isset($service->id)) {
        $product = (array)DB::table('tblproducts')->where('id', $service->packageid)->first();
        $r = DB::table('tblsslorders')->where('serviceid', '=', $_REQUEST['id'])->first();
        $remoteid = $r->remoteid;

        require_once(dirname(__FILE__) . DIRECTORY_SEPARATOR . 'CERTUM_Certificates.php');

        $api = new PartnerAPIService($product['configoption1'], $product['configoption2'], $product['configoption10']);
        $op = $api->operationGetOrderStateByOrderID();
        $op->setOrderID($remoteid);
        $op->call();

        $orderState = $op->getData();

        if ($orderState->orderStatus != NULL) {
            $stateTableVerification = '';
            foreach ($orderState->verifications->verification as $ver) {
                $exptext = '';
                if ($ver->expireDate != NULL) {
                    $exptext = ' - Expire Date: ' . date('Y-m-d H:i:s', strtotime($ver->expireDate));
                }
                $stateTableVerification .= '<tr><td>' . $ver->type . '</td>
                                        <td>' . $ver->state . $exptext . '</td></tr>';
            }

            $statusLabel = 'default';
            if ($orderState->orderStatus == 'ENROLLED') {
                $statusLabel = 'success';
            }

            $stateTable = '<table style="margin-bottom:30px;" class="table table-bordered">
                        <tbody>
                            <tr>
                                <td>Order Status</td>
                                <td><div class="label label-' . $statusLabel . '">' . $orderState->orderStatus . '</div></td>
                            </tr>
                            <tr>
                                <td>Last Update Date</td>
                                <td>' . date('Y-m-d H:i:s', strtotime($orderState->lastUpdateDate)) . '</td>
                            </tr>
                            
                            ' . $stateTableVerification . '
                        </tbody>
                        </table>';
        }
        $orderStateHtml = '<div id="order-state">' . $stateTable . '</div>';
        echo $orderStateHtml;
        die();
    }
}

if(
    $_REQUEST['ajax'] == '1' && $_REQUEST['action'] == 'getDomainVerification' &&
    ((isset($_SESSION['uid']) && !empty($_SESSION['uid'])) || (isset($_SESSION['adminid']) && !empty($_SESSION['adminid'])))
)
{
    $isAdmin = false;
    if(isset($_SESSION['adminid']) && !empty($_SESSION['adminid']))
    {
        $isAdmin = true;
    }

    if($isAdmin)
    {
        $service = DB::table('tblhosting')->where('id', $_REQUEST['id'])->first();
    }
    else
    {
        $service = DB::table('tblhosting')->where('id', $_REQUEST['id'])->where('userid', $_SESSION['uid'])->first();
    }

    if(isset($service->id)) {
        $product = (array)DB::table('tblproducts')->where('id', $service->packageid)->first();
        $r = DB::table('tblsslorders')->where('serviceid', '=', $_REQUEST['id'])->first();
        $remoteid = $r->remoteid;

        require_once(dirname(__FILE__) . DIRECTORY_SEPARATOR . 'CERTUM_Certificates.php');

        $api = new PartnerAPIService($product['configoption1'], $product['configoption2'], $product['configoption10']);

        $op2 = $api->operationGetSanVerificationState();
        $op2->setOrderID($remoteid);
        $op2->call();

        $verificationSANs = $op2->getSanVerifications();

        $buttonverify = '<button style="margin-left:5px;" type="button" id="btnshowsanverify" class="btn btn-primary">Show domain verification</button>';
        $tableVerificationSAN = '<table class="table table-bordered"><tbody>';

        foreach ($verificationSANs as $verificationSAN) {
            $statehtml = '';

            $expirydate = (string)$verificationSAN->manualVerification->expireDate;
            if (!empty($expirydate)) {
                $expirydate = ' - Expire Date: ' . date('Y-m-d H:i:s', strtotime($expirydate));
            }

            $state = (string)$verificationSAN->manualVerification->state;
            if ($state == 'VERIFIED') {
                $statehtml = '<span style="font-size:15px;" class="label label-success">' . $state . '</span>' . $expirydate;
            } else {
                $statehtml = $state . $expirydate;
            }


            $systemVerifyError = (array)$verificationSAN->systemVerification->method;

            $systemverificationhtml = '';
            if (!empty($systemVerifyError)) {
                $systemverificationhtml = '<tr><td>System verification errors</td><td>' . implode(',', $systemVerifyError) . '</td></tr>';
            }


            $info = (string)$verificationSAN->manualVerification->info;

            $manualverificationhtml = '';
            if (!empty($info)) {
                $manualverificationhtml = '<tr><td>Manual verification errors</td><td>' . $info . '</td></tr>';
            }

            $tableVerificationSAN .= '
                                <tr>
                                    <td style="background:#ddd;font-weight:700;">Domain</td><td style="background:#ddd;font-weight:700;">' . $verificationSAN->FQDN . '</td>
                                </tr>
                                <tr>
                                    <td>Manual verification state</td><td>' . $statehtml . '</td>
                                </tr>' . $manualverificationhtml . $systemverificationhtml;
        }
        $tableVerificationSAN .= '</tbody></table>';

        $domainVerification = '<div id="domain-verification">' . $tableVerificationSAN . '</div>';
        echo $domainVerification;
        die();
    }
}

function CERTUM_Certificates_customfield($params) {
    
    if (strpos($_SERVER['SCRIPT_NAME'], 'clientsservices.php') !== false) {
        
        try {
        
        $valid = false;
        $serviceid = 0;
        if(!empty($_REQUEST['id']))
        {
            $serviceid = $_REQUEST['id'];
        }
        if(!empty($_REQUEST['productselect']))
        {
            $serviceid = $_REQUEST['productselect'];
        }

        if(!empty($serviceid))
        {
            $service = DB::table('tblhosting')->where('id', $serviceid)->where('domainstatus', 'Active')->first();
            
            if(!isset($service->id) || empty($service->id))
            {
                return;
            }
            
            $product = DB::table('tblproducts')->where('id', $service->packageid)->where('servertype', 'CERTUM_Certificates')->first();
            $sslorder = DB::table('tblsslorders')->where('serviceid', $serviceid)->first();

            if(isset($product->id) && isset($sslorder->remoteid) && !empty($sslorder->remoteid))
            {
                $api = new PartnerAPIService($product->configoption1, $product->configoption2, $product->configoption10);
                $op = $api->operationGetOrderByOrderID();
                $op->setOrderID($sslorder->remoteid)->setOrderStatus(TRUE)->setCertificateDetails(TRUE)->setOrderDetails(TRUE);

                $certs = array();
                if ($op->call()) {
                    $certs = $op->getOrders();
                }

                foreach($certs as $cert)
                {
                    if($cert->certificateDetails->certificateStatus == 'VALID')
                    {
                        $valid = true;
                    }
                }
            }

            if(isset($product->id) && !$valid)
            {
                return <<<JS
                    <script type="text/javascript">
                        jQuery(document).ready(function(){
                            jQuery('#btnRenew').hide();
                        });
                    </script>
JS;
            }
        }
        
        } catch (\Exception $exf) {
            
            return '';
            
        }
        
    }

    if (isset($_SESSION['adminid']) && isset($_REQUEST['action']) && isset($_GET['id']) && isset($_POST['servertype']) && $_POST['servertype'] == 'CERTUM_Certificates' && $_REQUEST['action'] == 'generateCustom') {
        ob_clean();

        $countTbl = DB::table('tblcustomfields')->select('id')->where([
                    ['type', '=', 'product'],
                    ['relid', '=', (int) $_GET['id']],
                    ['fieldname', 'like', 'method|%']
                ])->count();
        if ($countTbl == 0) {

            require_once(dirname(__FILE__) . DIRECTORY_SEPARATOR . 'CERTUM_Certificates.php');

            if (in_array($_POST['pid'], array_keys(CERTUM_Certificates_Commercial()))) {
                $fields = "ADMIN,FILE,DNS_TXT,DNS_CNAME,DNS_TXT_PREFIX,DNS_CNAME_PREFIX";
            }

            if (in_array($_POST['pid'], array_keys(CERTUM_Certificates_Trusted()))) {
                $fields = "FILE,DNS_TXT,DNS_CNAME,DNS_TXT_PREFIX,DNS_CNAME_PREFIX";
            }

            if (in_array($_POST['pid'], array_keys(CERTUM_Certificates_PremiumEVSSL()))) {
                $fields = "ADMIN,FILE,DNS_TXT,DNS_CNAME,DNS_TXT_PREFIX,DNS_CNAME_PREFIX";
            }

            if (in_array($_POST['pid'], array_keys(CERTUM_Certificates_IDCerts()))) {
                $fields = "ADMIN";
            }

            if (in_array($_POST['pid'], array_keys(CERTUM_Certificates_CodeSigning()))) {
                $fields = "ADMIN";
            }

            if (empty($fields)) {
                die('You should select product first');
            }

            DB::table('tblcustomfields')->insert([
                'type'         => 'product',
                'relid'        => (int) $_GET['id'],
                'fieldname'    => 'method|Approve Method',
                'fieldtype'    => 'dropdown',
                'required'     => 'on',
                'showorder'    => 'on',
                'fieldoptions' => $fields
            ]);
            echo "Custom Field has been added";
        } else
            echo "Custom Field already exists";
        die();
    }
}

function CERTUM_change_language($vars) {
   
    $check = DB::table('tblsslorders')->where(DB::raw('md5(id)'), '=', $_GET['cert'])->first();
    $isAddon = false;
    if(isset($check->addon_id) && !empty($check->addon_id))
    {
        $isAddon = true;
    }
    
    if ($vars['filename'] == 'configuressl') {
        
        if($isAddon)
        {
            $addonhosting = DB::table('tblhostingaddons')->where('id', $check->addon_id)->first();
            $configAddon = DB::table('tblmodule_configuration')->where('entity_type', 'addon')->where('entity_id', $addonhosting->addonid)->get();
            
            $r = new stdClass();
            
            foreach($configAddon as $v)
            {
                $r->id = 1;
                $r->{$v->setting_name} = $v->value;
            }       
            
            
        }
        else
        {
            $r = DB::table('tblproducts')
                    ->select('tblproducts.*')
                    ->join('tblhosting', 'tblhosting.packageid', '=', 'tblproducts.id')
                    ->where([
                        ['tblhosting.id', '=', (int) $_POST['serviceid']],
                        ['tblhosting.userid', '=', (int) $_SESSION['uid']],
                        ['tblproducts.servertype', '=', 'CERTUM_Certificates']
                    ])->orderBy('tblproducts.id')
                    ->first();
        }

        if ($r->id > 0) {
            global $smarty, $CONFIG;
            require_once(dirname(__FILE__) . DIRECTORY_SEPARATOR . 'CERTUM_Certificates.php');
            $pid = explode("|", $r->configoption3);
            #print_r($smarty->_tpl_vars['LANG']);
            #die();
            if (in_array($pid[0], array_keys(CERTUM_Certificates_CodeSigning()))) {
                $smarty->_tpl_vars['LANG']['sslcertinfo'] = CERTUM_Certificates_translate('sslcertinfo_code_signing');
                $smarty->_tpl_vars['LANG']['sslconfsslcertificate'] = CERTUM_Certificates_translate('sslconfsslcertificate_code_signing');
                $smarty->_tpl_vars['LANG']['sslconfigcompletedetails'] = CERTUM_Certificates_translate('sslconfigcompletedetails_code_signing');
                $smarty->_tpl_vars['LANG']['sslserverinfodetails'] = CERTUM_Certificates_translate('sslserverinfodetails_code_signing');
                $smarty->_tpl_vars['LANG']['ssladmininfodetails'] = CERTUM_Certificates_translate('ssladmininfodetails_code_signing');
                return '<script type="text/javascript">$("title").text("' . CERTUM_Certificates_translate('sslconfsslcertificate_code_signing') . ' - ' . $CONFIG['CompanyName'] . '");</script>';
            } elseif (in_array($pid[0], array_keys(CERTUM_Certificates_IDCerts()))) {
                $smarty->_tpl_vars['LANG']['sslcertinfo'] = CERTUM_Certificates_translate('sslcertinfo_id');
                $smarty->_tpl_vars['LANG']['sslconfsslcertificate'] = CERTUM_Certificates_translate('sslconfsslcertificate_id');
                $smarty->_tpl_vars['LANG']['sslconfigcompletedetails'] = CERTUM_Certificates_translate('sslconfigcompletedetails_id');
                $smarty->_tpl_vars['LANG']['sslserverinfodetails'] = CERTUM_Certificates_translate('sslserverinfodetails_id');
                $smarty->_tpl_vars['LANG']['ssladmininfodetails'] = CERTUM_Certificates_translate('ssladmininfodetails_id');
                return '<script type="text/javascript">$("title").text("' . CERTUM_Certificates_translate('sslconfsslcertificate_id') . ' - ' . $CONFIG['CompanyName'] . '");</script>';
            }
        }
    }
}

/*
 * Added by Vitalii Aloksa
 */

function CERTUM_AdminAreaPage($vars) {
    if ($vars['filename'] == 'clientsservices') {

        $isAddon = false;
        if(isset($_REQUEST['aid']) && !empty($_REQUEST['aid']))
        {
            $isAddon = true;
        }
        
        $toShow = false;
        if($isAddon)
        {
            $addonhosting = DB::table('tblhostingaddons')
                            ->select('tblhostingaddons.id')
                            ->join('tblservers', 'tblservers.id', '=', 'tblhostingaddons.server')
                            ->where([
                            ['tblhostingaddons.id', $_REQUEST['aid']],
                            ['tblservers.name', '=', 'CERTUM_Certificates'],
                            ])->first();
            $toShow = !empty($addonhosting->id);
            $configAddon = DB::table('tblmodule_configuration')->where('entity_type', 'addon')->where('entity_id', $addonhosting->addonid)->get();
            
            $res = new stdClass();
            
            foreach($configAddon as $v)
            {
                $res->id = 1;
                $res->{$v->setting_name} = $v->value;
            }       
        }
        else 
        {
            $res = DB::table('tblhosting')
                            ->select('tblhosting.id')
                            ->join('tblproducts', 'tblproducts.id', '=', 'tblhosting.packageid')
                            ->where([
                                ['tblproducts.servertype', '=', 'CERTUM_Certificates'],
                                ['tblhosting.id', '=', (int) $_REQUEST['id']],
                            ])->first();
            $toShow = !empty($res->id);
        
        }
        
        if(!$toShow)
        {
            return;
        }
        
        if (!empty($res) || $_SESSION['certumcert']) {
            
            // $js =  $vars['jscode'];
            // $js = str_replace('var reqstr =', 'var reqstr ='
            //         . ' "CSR=" + encodeURIComponent(CSR) +'
            //         . ' "&CSR_key=" + encodeURIComponent(CSR_key) +'
            //         . ' "&CSR_serial=" +CSR_serial +'
            //         . ' "&CSR_func=" +CSR_func +'
            //         . '"&" + ', $js);

            // $vars['jscode'] = $js;
            unset($_SESSION['certumcert']);
            return $vars;
        }
    }
}
//@author = Mateusz Pawlowski
 function CERTUM_ProductDetailsPage($params) {
     
     $additionaljs = '';
     
        $show = false;      
        if ($params['templatefile'] === 'clientareacancelrequest') {
            try {
                $service = \WHMCS\Service\Service::findOrFail($params['id']);
                if ($service->product->servertype === 'CERTUM_Certificates') {
                    $show = true;
                }
            } catch (Exception $exc) {
                
            }
        } elseif ($params['modulename'] === 'CERTUM_Certificates') {
            
            $details = DB::table('tblsslorders')->where('serviceid', '=', $params['serviceid'])->first();
            
            $product = (array)DB::table('tblproducts')->where('id', $params['pid'])->first();
            
            $api = new PartnerAPIService($product['configoption1'], $product['configoption2'], $product['configoption10']);

            $certs = array();

            try {
                $op = $api->operationGetOrderByOrderID();
                $op->setOrderID($details->remoteid)->setOrderStatus(TRUE)->setCertificateDetails(TRUE)->setOrderDetails(TRUE);

                if ($op->call()) {
                    $cert = $op->getOrders();

                } else {
                    $error = $op->getErrorTexts();
                    return $error[0]['text'];
                }
            } catch (Exception $e) {
                
            }
            
            foreach($cert as $c)
            {
                if($c->certificateDetails->certificateStatus == 'VALID')
                {
                    $dateTime = new DateTime($c->certificateDetails->startDate);
                    $startdate = $dateTime->format('Y-m-d H:i:s');
                    $certs[] = array(
                        'status' => $c->certificateDetails->certificateStatus,
                        'date' => $startdate,
                        'time' => strtotime($startdate),
                        'number' => $c->certificateDetails->serialNumber,
                        'csr' => $c->certificateDetails->X509Cert,
                        'number_order' => $c->orderStatus->serialNumber
                    );
                }
            }
            
            if(!empty($certs))
            {
                $additionaljs = '$("#Primary_Sidebar-Service_Details_Actions-Custom_Module_Button_Revoke_Certificate").show();';
            }
            
            
            $show = true;
        }
        if (!$show) {
            return '';
        }

        return <<<HTML
        <script type="text/javascript">
        $(document).ready(function () {
        
        
            $('#Primary_Sidebar-Service_Details_Actions-Custom_Module_Button_Show_order_state').attr('href','#');
            $('#Primary_Sidebar-Service_Details_Actions-Custom_Module_Button_Show_domain_verification').attr('href','#');
            $('body').on('click','#Primary_Sidebar-Service_Details_Actions-Custom_Module_Button_Show_order_state', function(e){
                e.preventDefault();
                $.ajax({
                    method      : "get", 
                    dataType    : "json",
                    data        : {
                        "ajax" : "1",
                        "action" : "getOrderState",
                        "id": "{$params['serviceid']}"
                    },
                    complete : function(data) {
                        $('#order-state').remove();
                        $('.main-content').empty();
                        $('.main-content').prepend(data.responseText);
                    },
                    beforeSend: function() {

                    },
                });
            });
        
            $('body').on('click','#Primary_Sidebar-Service_Details_Actions-Custom_Module_Button_Show_domain_verification', function(e){
                e.preventDefault();
                $.ajax({
                    method      : "get", 
                    dataType    : "json",
                    data        : {
                        "ajax" : "1",
                        "action" : "getDomainVerification",
                        "id": "{$params['serviceid']}"
                    },
                    complete : function(data) {
                        $('#domain-verification').remove();
                        $('.main-content').empty();
                        $('.main-content').prepend(data.responseText);
                    },
                    beforeSend: function() {

                    },
                });
            });
        
        
        
        
            $("#Primary_Sidebar-Service_Details_Actions-Custom_Module_Button_Revoke_Certificate").hide();
            $additionaljs
        });
    </script>
HTML;
    }

add_hook("AdminAreaPage", 1, "CERTUM_AdminAreaPage");


add_hook("ClientAreaPage", 1, "CERTUM_Get_approved_emails");
add_hook("ClientAreaPage", 1, "CERTUM_change_language");
add_hook('ClientAreaFooterOutput', 1, 'CERTUM_ProductDetailsPage');   
add_hook("AdminAreaHeaderOutput", 1, "CERTUM_Certificates_customfield");
add_hook("ProductEdit", 1, function($params) {

    if (isset($_SESSION['adminid']) && $params['name'] == 'Certum SSL' && !empty($_REQUEST['action']) && $_REQUEST['action'] == 'save') {

        if (!empty($_POST['packageconfigoption'])) {

            $postPackages = $_POST['packageconfigoption'];

            $fieldsToUpdate = array();

            if (!isset($postPackages[5])) {
                $fieldsToUpdate['configoption5'] = "";
            }

            if (!isset($postPackages[7])) {
                $fieldsToUpdate['configoption7'] = "";
            }

            if (!isset($postPackages[9])) {
                $fieldsToUpdate['configoption9'] = "";
            }

            if (!isset($postPackages[10])) {
                $fieldsToUpdate['configoption10'] = "";
            }
            if (!empty($fieldsToUpdate)) {
                $pid = $params['pid'];

                DB::table('tblproducts')->where('id', '=', $pid)->update($fieldsToUpdate);
            }
        }
    }
});

add_hook('ClientAreaHeadOutput', 1, function($params) {

    require_once(dirname(__FILE__) . DIRECTORY_SEPARATOR . 'CERTUM_Certificates.php');

    if ($params['templatefile'] === 'configuressl-stepone') {


        $service = DB::table('tblhosting')->where('id', $params['serviceid'])->first();
        $product = DB::table('tblproducts')->where('id', $service->packageid)->first();

        if (isset($product->servertype) && $product->servertype == 'CERTUM_Certificates') {

            $pid = explode('|', $product->configoption3);

            $allProducts = CERTUM_Certificates_ProductsAvailable();
            if (!isset($allProducts[$pid[0]])) {
                redir('action=productdetails&id=' . $params['serviceid'], 'clientarea.php');
            }

            $customerjs = '';
            $customerjs .= '$("select[name=\'fields[Country]\'").prepend("<option value=\'\'>Please choose...</option>");$("select[name=\'fields[Country]\'").val("");';
            if (
                $pid[0] == '731' || $pid[0] == '732' || $pid[0] == '733' ||
                $pid[0] == '501' || $pid[0] == '502' || $pid[0] == '511' || $pid[0] == '512' || $pid[0] == '521' || $pid[0] == '522' || $pid[0] == '531' || $pid[0] == '532'
            ) {
                $customerjs .= '$("input[name=\"fields[CommonName]\"]").prop("readonly", true);';
            }
            if ($pid[0] == '831' || $pid[0] == '832' || $pid[0] == '833' ||
                $pid[0] == '316' || $pid[0] == '317' || $pid[0] == '318' ||
                $pid[0] == '281' || $pid[0] == '282' || $pid[0] == '283') {
                $customerjs .= '$("input[name=\"fields[simplysign_account]\"]").attr("placeholder", "sample@email.com");$("input[name=\"fields[simplysign_account]\"]").parents("fieldset").prev("p").remove();';
            }
            if ($pid[0] == '316' || $pid[0] == '317' || $pid[0] == '318' ||
                $pid[0] == '631' || $pid[0] == '681' ||
                $pid[0] == '971' || $pid[0] == '981') {
                $customerjs .= '$("select[name=\'fields[Joisocn]\'").prepend("<option value=\'\'>Please choose...</option>");$("select[name=\'fields[Joisocn]\'").val("");$("input[name=\"fields[TaxIdentificationNumber]\"]").parents("fieldset.form-horizontal").prev("p").css({"margin-top":"30px"});$("input[name=\"fields[TaxIdentificationNumber]\"]").parents("fieldset.form-horizontal").css({"margin-bottom":"30px"});$("input[name=\"fields[TaxIdentificationNumber]\"]").parents("fieldset.form-horizontal").prev("p").append("<p>' . CERTUM_Certificates_translate('organizetion_desc') . '</p>");';
            }

            $hashalg = '';
            if ($pid[0] == '601' || $pid[0] == '631' || $pid[0] == '641' ||
                $pid[0] == '681' || $pid[0] == '721' || $pid[0] == '722' ||
                $pid[0] == '723' || $pid[0] == '731' || $pid[0] == '732' ||
                $pid[0] == '501' || $pid[0] == '502' || $pid[0] == '511' || $pid[0] == '512' || $pid[0] == '521' || $pid[0] == '522' || $pid[0] == '531' || $pid[0] == '532' ||
                $pid[0] == '733' || $pid[0] == '741' ||
                $pid[0] == '961' ||
                $pid[0] == '971' || $pid[0] == '981') {
                $hashalg = "var inputHashAlg = $('#inputServerType').parent('.form-group').clone().attr('id', 'hashalg-group');
        $(inputHashAlg).insertAfter($('#inputCsr').parent('.form-group'));
        $('#hashalg-group label').attr('for', 'inputHashAlgorithm');
        $('#hashalg-group label').text('Hash Algorithm');
        $('#hashalg-group select').attr('name', 'hashalgorithm');
        $('#hashalg-group select').attr('id', 'inputHashAlgorithm');
        $('#hashalg-group select option').remove();
        
        $('#hashalg-group select').append('<option value=\"\">Default</option>');
        $('#hashalg-group select').append('<option value=\"RSA-SHA256\">RSA-SHA256</option>');
        $('#hashalg-group select').append('<option value=\"ECC-SHA256\">ECC-SHA256</option>');";
            }

            $individual = '';
            $updatefields = '';
            if (
                $pid[0] == '731' || $pid[0] == '732' || $pid[0] == '733' ||
                $pid[0] == '501' || $pid[0] == '502' || $pid[0] == '511' || $pid[0] == '512' || $pid[0] == '521' || $pid[0] == '522' || $pid[0] == '531' || $pid[0] == '532'
            ) {
                $updatefields = "$('body').on('input', 'input[name=\"fields[Email]\"]', function(){
                var emailvalue = $(this).val();
                $('input[name=\"fields[CommonName]\"]').val(emailvalue);
            })";
                $individual = "$('input[name=\"fields[CommonName]\"]').val(data.responseJSON.emailAddress);";
            }

            return <<<HTML
        <style>
            .glyphicon-refresh-animate {
                -animation: spin .7s infinite linear;
                -webkit-animation: spin2 .7s infinite linear;
            }

            @-webkit-keyframes spin2 {
                from { -webkit-transform: rotate(0deg);}
                to { -webkit-transform: rotate(360deg);}
            }

            @keyframes spin {
                from { transform: scale(1) rotate(0deg);}
                to { transform: scale(1) rotate(360deg);}
            }
        </style>
<script type="text/javascript">
    $(document).ready(function(){
        $('label[for="inputFirstName"]').append(' *');
        $('label[for="inputLastName"]').append(' *');
        $('label[for="inputEmail"]').append(' *');
        $('label[for="inputAddress1"]').append(' *');
        $('label[for="inputCity"]').append(' *');
        $('label[for="inputState"]').append(' *');
        $('label[for="inputCountry"]').append(' *');
        $('label[for="inputPhoneNumber"]').append(' *');
        $('label[for="inputPostcode"]').append(' *');
        $('<p style="float:right">* - data required</p>').insertBefore('.main-content form .text-center');
        
        $('#inputCsr').parent('.form-group').append('<div class="alert" style="display:none;margin-top:15px;"></div><button id="getDetailsCSR" type="button" class="btn btn-default" style="margin-top:15px;"><span style="display:none;margin-right:10px;" class="glyphicon glyphicon-refresh glyphicon-refresh-animate"></span>Get details from CSR</button>');
        
        $("select[name=\'fields[BusinessCategory]\'").prepend("<option value=\'\'>Please choose...</option>");
        $("select[name=\'fields[BusinessCategory]\'").val("");

        $hashalg
        $customerjs
                
        $updatefields
                
        $('body').on('click', '#getDetailsCSR', function(){
            
            $.ajax({
                method      : "get", 
                dataType    : "json",
                contentType : "application/json",
                data        : {
                    "ajax" : "1",
                    "action" : "getDetailsCSR",
                    "csrform": $('#inputCsr').val()
                },
                complete : function(data) {
                    if(data.responseJSON.error)
                    {
                        $('#inputCsr').parent('.form-group').find('.alert').text(data.responseJSON.msg);
                        $('#inputCsr').parent('.form-group').find('.alert').removeClass('alert-danger');
                        $('#inputCsr').parent('.form-group').find('.alert').removeClass('alert-success');
                        $('#inputCsr').parent('.form-group').find('.alert').addClass('alert-danger');
                        $('#inputCsr').parent('.form-group').find('.alert').show();
                    }
                    else {
                        $('#inputCsr').parent('.form-group').find('.alert').text('Details has been provided to the form below.');
                        $('#inputCsr').parent('.form-group').find('.alert').removeClass('alert-danger');
                        $('#inputCsr').parent('.form-group').find('.alert').removeClass('alert-success');
                        $('#inputCsr').parent('.form-group').find('.alert').addClass('alert-success');
                        $('#inputCsr').parent('.form-group').find('.alert').show();
                    }
                    if(data.responseJSON.CN)
                    {
                        $('input[name="fields[CommonName]"]').val(data.responseJSON.CN).trigger("input");
                    }
                    if(data.responseJSON.O)
                    {
                        $('input[name="fields[AdminName]"]').val(data.responseJSON.O).trigger("input");
                        $('input[name="fields[Organization]"]').val(data.responseJSON.O).trigger("input");
                    }
                    if(data.responseJSON.emailAddress)
                    {
                        $('input[name="fields[Email]"]').val(data.responseJSON.emailAddress).trigger("input");
                        $individual
                    }
                    if(data.responseJSON.L)
                    {
                        $('input[name="fields[AdminLocality]"]').val(data.responseJSON.L).trigger("input");
                        $('input[name="fields[Locality]"]').val(data.responseJSON.L).trigger("input");
                    }
                    if(data.responseJSON.C)
                    {
                        $('select[name="fields[AdminCountry]"]').val(data.responseJSON.C).trigger("input");
                        $('select[name="fields[Country]"]').val(data.responseJSON.C).trigger("input");
                    }
                    if(data.responseJSON.ST)
                    {
                        $('input[name="fields[AdminStateProvince]"]').val(data.responseJSON.ST).trigger("input");
                        $('input[name="fields[StateProvince]"]').val(data.responseJSON.ST).trigger("input");
                    }
                    $('#getDetailsCSR span').hide();
                    $('#getDetailsCSR').prop('disabled', false);
                },
                beforeSend: function() {
                    $('#getDetailsCSR span').show();
                    $('#getDetailsCSR').prop('disabled', true);
                },
            });
        
        });
        
        $('body').on('input', '#inputCsr', function(){
            
            $.ajax({
                method      : "get", 
                dataType    : "json",
                contentType : "application/json",
                data        : {
                    "ajax" : "1",
                    "action" : "getDetailsCSR",
                    "csrform": $('#inputCsr').val()
                },
                complete : function(data) {
                    if(data.responseJSON.CN)
                    {
                        $('input[name="fields[CommonName]"]').val(data.responseJSON.CN).trigger("input");
                    }
                    if(data.responseJSON.O)
                    {
                        $('input[name="fields[AdminName]"]').val(data.responseJSON.O).trigger("input");
                        $('input[name="fields[Organization]"]').val(data.responseJSON.O).trigger("input");
                    }
                    if(data.responseJSON.emailAddress)
                    {
                        $('input[name="fields[Email]"]').val(data.responseJSON.emailAddress).trigger("input");
                        $individual
                    }
                    if(data.responseJSON.L)
                    {
                        $('input[name="fields[AdminLocality]"]').val(data.responseJSON.L).trigger("input");
                        $('input[name="fields[Locality]"]').val(data.responseJSON.L).trigger("input");
                    }
                    if(data.responseJSON.C)
                    {
                        $('select[name="fields[AdminCountry]"]').val(data.responseJSON.C).trigger("input");
                        $('select[name="fields[Country]"]').val(data.responseJSON.C).trigger("input");
                    }
                    if(data.responseJSON.ST)
                    {
                        $('input[name="fields[AdminStateProvince]"]').val(data.responseJSON.ST).trigger("input");
                        $('input[name="fields[StateProvince]"]').val(data.responseJSON.ST).trigger("input");
                    }
                    $('#getDetailsCSR span').hide();
                    $('#getDetailsCSR').prop('disabled', false);
                },
                beforeSend: function() {
                    $('#getDetailsCSR span').show();
                    $('#getDetailsCSR').prop('disabled', true);
                },
            });
        
        });
    });
</script>
HTML;
        }
    }

    if ($params['templatefile'] === 'clientareaproductdetails' || strpos($params['templatefile'], 'renewcsr.tpl') !== false) {

        $productDB = (array)DB::table('tblproducts')->where('id', $params['pid'])->first();
        $product = explode('|', $productDB['configoption3']);

        if (isset($product->servertype) && $product->servertype == 'CERTUM_Certificates') {


        if ($product[0] == '841' || $product[0] == '842' || $product[0] == '843') {
            return <<<JS
                <script type="text/javascript">
                    jQuery(document).ready(function(){
                        $("#Primary_Sidebar-Service_Details_Actions-Custom_Module_Button_Change_verification").remove();
                    });
                </script>
JS;
        }
        if ($product[0] == '831' || $product[0] == '832' || $product[0] == '833') {
            return <<<JS
                <script type="text/javascript">
                    jQuery(document).ready(function(){
                        $("#Primary_Sidebar-Service_Details_Actions-Custom_Module_Button_Change_verification").remove();
                        $("#Primary_Sidebar-Service_Details_Actions-Custom_Module_Button_Renew_Certificate").remove();
                        $("#Primary_Sidebar-Service_Details_Actions-Custom_Module_Button_Reissue_Certificate").remove();
                    });
                </script>
JS;
        }
        if ($product[0] == '281' || $product[0] == '282' || $product[0] == '283') {
            return <<<JS
                <script type="text/javascript">
                    jQuery(document).ready(function(){
                        $("#Primary_Sidebar-Service_Details_Actions-Custom_Module_Button_Change_verification").remove();
                        $("#Primary_Sidebar-Service_Details_Actions-Custom_Module_Button_Renew_Certificate").remove();
                        $("#Primary_Sidebar-Service_Details_Actions-Custom_Module_Button_Reissue_Certificate").remove();
                    });
                </script>
JS;
        }
        if ($product[0] == '316' || $product[0] == '317' || $product[0] == '318') {
            return <<<JS
                <script type="text/javascript">
                    jQuery(document).ready(function(){
                        $("#Primary_Sidebar-Service_Details_Actions-Custom_Module_Button_Change_verification").remove();
                        $("#Primary_Sidebar-Service_Details_Actions-Custom_Module_Button_Renew_Certificate").remove();
                        $("#Primary_Sidebar-Service_Details_Actions-Custom_Module_Button_Reissue_Certificate").remove();
                    });
                </script>
JS;
        }
        if (
            $product[0] == '721' || $product[0] == '722' || $product[0] == '723' ||
            $product[0] == '731' || $product[0] == '732' || $product[0] == '733' ||
            $product[0] == '501' || $product[0] == '502' || $product[0] == '511' || $product[0] == '512' || $product[0] == '521' || $product[0] == '522' || $product[0] == '531' || $product[0] == '532'
        ) {
            return <<<JS
                <script type="text/javascript">
                    jQuery(document).ready(function(){
                        $("#Primary_Sidebar-Service_Details_Actions-Custom_Module_Button_Change_verification").remove();
                    });
                </script>
JS;
        }

    }
}
});

add_hook('ServiceEdit', 1, function($vars) {
    if (isset($_SESSION['adminid']) && isset($_REQUEST['csr_renew'])) {

        $check = DB::table('certum_renewals')->where('serviceid', '=', $vars['serviceid'])->first();

        if(isset($check->serviceid))
        {
            DB::table('certum_renewals')->where('serviceid', '=', $vars['serviceid'])->update(array('csr' => $_REQUEST['csr_renew']));
        }
        else
        {
            DB::table('certum_renewals')->insert(array('csr' => $_REQUEST['csr_renew'], 'serviceid' => $vars['serviceid']));
        }
    }
});

add_hook('AdminAreaHeaderOutput', 1, function($vars) {

    if (strpos($_SERVER['SCRIPT_NAME'], 'clientsservices.php') !== false) {

        $serviceid = isset($_REQUEST['productselect']) && !empty($_REQUEST['productselect']) ? $_REQUEST['productselect'] : $_REQUEST['id'];
        $service = (array)DB::table('tblhosting')->where('id', $serviceid)->first();
        $product = (array)DB::table('tblproducts')->where('id', $service['packageid'])->first();
        $productDB = explode('|', $product['configoption3']);

        $additionaljs = "";
        if($productDB[0] == '841' || $productDB[0] == '842' || $productDB[0] == '843')
        {
            $additionaljs = "$('#btnChange_verification').attr('disabled','disabled');";
        }
        if($productDB[0] == '281' || $productDB[0] == '282' || $productDB[0] == '283')
        {
            $additionaljs = "$('#btnReissue').attr('disabled','disabled');$('#btnChange_verification').attr('disabled','disabled');$('#btnRenew_Certificate').attr('disabled','disabled');";
        }
        if($productDB[0] == '316' || $productDB[0] == '317' || $productDB[0] == '318')
        {
            $additionaljs = "$('#btnReissue').attr('disabled','disabled');$('#btnChange_verification').attr('disabled','disabled');$('#btnRenew_Certificate').attr('disabled','disabled');";
        }
        if($productDB[0] == '831' || $productDB[0] == '832' || $productDB[0] == '833')
        {
            $additionaljs = "$('#btnReissue').attr('disabled','disabled');$('#btnChange_verification').attr('disabled','disabled');$('#btnRenew_Certificate').attr('disabled','disabled');";
        }
        if(
            $productDB[0] == '721' || $productDB[0] == '722' || $productDB[0] == '723' ||
            $productDB[0] == '731' || $productDB[0] == '732' || $productDB[0] == '733' ||
            $productDB[0] == '501' || $productDB[0] == '502' || $productDB[0] == '511' || $productDB[0] == '512' || $productDB[0] == '521' || $productDB[0] == '522' || $productDB[0] == '531' || $productDB[0]== '532'
        )
        {
            $additionaljs = "$('#btnChange_verification').attr('disabled','disabled');";
        }

        if($product['servertype'] == 'CERTUM_Certificates')
        {

            return <<<JS
                <script type="text/javascript">
                    jQuery(document).ready(function(){
                        jQuery('#btnTerminate').text('Revoke Certificate');
                        jQuery('#modalModuleTerminateBody').text('Are you sure you want to run the revoke function?');
                        jQuery('#btnCancel_Order').removeAttr('onclick');
                        jQuery('body').on('click', '#btnCancel_Order', function(){
                            jQuery('#modalModuleCancelOrder').modal('show');
                        });
                        $additionaljs
                    });
                </script>
JS;
        }

    }

});


add_hook('AdminAreaFooterOutput', 1, function($vars) {

    if (strpos($_SERVER['SCRIPT_NAME'], 'clientsservices.php') !== false) {

        $serviceid = isset($_REQUEST['productselect']) && !empty($_REQUEST['productselect']) ? $_REQUEST['productselect'] : $_REQUEST['id'];
        $service = (array)DB::table('tblhosting')->where('id', $serviceid)->first();
        $product = (array)DB::table('tblproducts')->where('id', $service['packageid'])->first();

        if($product['servertype'] == 'CERTUM_Certificates')
        {

            return <<<JS
                <div class="modal fade" id="modalModuleCancelOrder" role="dialog" aria-labelledby="ModuleCancelOrderLabel" aria-hidden="true">
                    <div class="modal-dialog">
                        <div class="modal-content panel panel-primary">
                            <div id="modalModuleCancelOrderHeading" class="modal-header panel-heading">
                                <button type="button" class="close" data-dismiss="modal">
                                    <span aria-hidden="true">×</span>
                                    <span class="sr-only">Close</span>
                                </button>
                                <h4 class="modal-title" id="ModuleCancelOrderLabel">Confirm Module Command</h4>
                            </div>
                            <div id="modalModuleCancelOrderBody" class="modal-body panel-body">Are you sure you want to run the cancel order function?</div>
                            <div id="modalModuleCancelOrderFooter" class="modal-footer panel-footer">
                                <button type="button" id="ModuleCancelOrder-Yes" class="btn btn-primary" onclick="runModuleCommand('custom','cancelOrder')">Yes</button>
                                <button type="button" id="ModuleCancelOrder-No" class="btn btn-default" data-dismiss="modal">No</button>
                            </div>
                        </div>
                    </div>
                </div>
JS;
        }

    }

});

add_hook('ClientAreaHeadOutput', 1, function($vars) {
    if($vars['clientareaaction'] == 'productdetails' && $vars['module'] == 'CERTUM_Certificates' && $vars['billingcycle'] != 'One Time' && $vars['billingcycle'] != 'Free Account') {
        return <<<JS
<script type="text/javascript">
$(document).ready(function(){
$('#Primary_Sidebar-Service_Details_Actions-Custom_Module_Button_Renew_Certificate').remove();
});
</script>
JS;
    }
});


add_hook('ClientAreaHeadOutput', 1, function($vars) {
    if($vars['clientareaaction'] == 'productdetails' && $vars['module'] == 'CERTUM_Certificates') {
        return <<<JS
<script type="text/javascript">
$(document).ready(function(){
$('#Primary_Sidebar-Service_Details_Overview-Information').attr('href', 'clientarea.php?action=productdetails&id={$_REQUEST['id']}');
});
</script>
JS;
    }
});


add_hook('PreCronJob', 1, function($vars) {

    if(!class_exists('PartnerAPIService'))
    {
        require_once dirname(__DIR__).DIRECTORY_SEPARATOR.'CERTUM_Certificates'.DIRECTORY_SEPARATOR.'certumPartnerAPI'.DIRECTORY_SEPARATOR.'service.php';
    }

    $services = DB::table('tblhosting')
        ->select([
            'tblhosting.id',
            'tblhosting.packageid',
            'tblsslorders.remoteid',
            'tblproducts.configoption1',
            'tblproducts.configoption2',
            'tblproducts.configoption3',
            'tblproducts.configoption4',
            'tblproducts.configoption5',
            'tblproducts.configoption6',
            'tblproducts.configoption7',
            'tblproducts.configoption8',
            'tblproducts.configoption9',
            'tblproducts.configoption10',
            'tblproducts.configoption11',
            'tblproducts.configoption12',
            'tblproducts.configoption13',
        ])
        ->join('tblproducts', 'tblproducts.id', '=', 'tblhosting.packageid')
        ->join('tblsslorders', 'tblsslorders.serviceid', '=', 'tblhosting.id')
        ->where('tblproducts.servertype', 'CERTUM_Certificates')
        ->where('tblhosting.domainstatus', 'Active')
        ->where('tblhosting.billingcycle', '!=', 'One Time')
        ->where('tblhosting.billingcycle', '!=', 'Free Account')
        ->where('tblsslorders.remoteid', '!=', '')
        ->whereIn('tblsslorders.status', ['Configuration Submitted', 'Completed'])
        ->get();

    foreach($services as $service)
    {
        $api = new PartnerAPIService($service->configoption1, $service->configoption2, $service->configoption10);
        $op = $api->operationGetOrderByOrderID();
        $op->setOrderID($service->remoteid)->setOrderStatus(TRUE)->setCertificateDetails(TRUE)->setOrderDetails(TRUE);

        $certs = array();
        if ($op->call()) {
            $certs = $op->getOrders();
        }

        $endDate = '';
        foreach($certs as $cert)
        {
            $endDate = (string)$cert->certificateDetails->endDate;
        }

        if(!empty($endDate))
        {
            $date = date('Y-m-d',strtotime('-7 days',strtotime($endDate)));
            DB::table('tblhosting')->where('id', $service->id)->update([
                'nextduedate' => $date,
                'nextinvoicedate' => $date
            ]);
            logActivity('[#'.$service->id.']Certum Certificate module changed next due date to:'.$date, 0);

        }
    }

});


add_hook('ClientAreaHeadOutput', 1, function($params) {

    if(!isset($_SESSION['uid']) || empty($_SESSION['uid']))
    {
        return;
    }

    if($params['filename'] != 'configuressl')
    {
        return;
    }


    $countryPOST = isset($_POST['fields']['Country']) && !empty($_POST['fields']['Country']) ? $_POST['fields']['Country'] : "";
    $businessCategoryPOST = isset($_POST['fields']['BusinessCategory']) && !empty($_POST['fields']['BusinessCategory']) ? $_POST['fields']['BusinessCategory'] : "";
    $joisocnPOST = isset($_POST['fields']['Joisocn']) && !empty($_POST['fields']['Joisocn']) ? $_POST['fields']['Joisocn'] : "";
    $commonNamePOST = isset($_POST['fields']['CommonName']) && !empty($_POST['fields']['CommonName']) ? $_POST['fields']['CommonName'] : "";

    $additionalScript = '';
    if(!empty($countryPOST))
    {
        $additionalScript .= '$("select[name=\"fields[Country]\"]").val("'.$countryPOST.'");';
    }
    if(!empty($businessCategoryPOST))
    {
        $additionalScript .= '$("select[name=\"fields[BusinessCategory]\"]").val("'.$businessCategoryPOST.'");';
    }
    if(!empty($joisocnPOST))
    {
        $additionalScript .= '$("select[name=\"fields[Joisocn]\"]").val("'.$joisocnPOST.'");';
    }
    if(!empty($commonNamePOST))
    {
        $additionalScript .= '$("select[name=\"fields[CommonName]\"]").val("'.$commonNamePOST.'");';
    }

    return <<<JS
<style>
    .counter-char {
        font-size:11px;
        font-weight:300;
        color:#555;
    }
    .counter-char.red {
        color: red;
    }
</style>
<script type="text/javascript">
    $(document).ready(function(){
    
        let fields = [
            { name: 'simplysign_account', size: "64", additionalValidation: "email" },
            { name: 'CommonName', size: "64", additionalValidation: "none" },
            { name: 'Organization', size: "64", additionalValidation: "none" },
            { name: 'GivenName', size: "16", additionalValidation: "none" },
            { name: 'Surname', size: "40", additionalValidation: "none" },
            { name: 'Email', size: "64", additionalValidation: "email" },
            { name: 'Locality', size: "128", additionalValidation: "none" },
            { name: 'StateProvince', size: "128", additionalValidation: "none" },
            { name: 'SerialNumber', size: "40", additionalValidation: "none" },
            { name: 'Street', size: "64", additionalValidation: "none" },
            { name: 'PostalCode', size: "40", additionalValidation: "none" },
            { name: 'JoILN', size: "128", additionalValidation: "none" },
            { name: 'JoISoPN', size: "128", additionalValidation: "none" },
            { name: 'AdminFirstName', size: "16", additionalValidation: "none" },
            { name: 'AdminLastName', size: "40", additionalValidation: "none" },
            { name: 'AdminPhone', size: "32", additionalValidation: "none" },
            { name: 'AdminEmail', size: "255", additionalValidation: "email" },
            { name: 'AdminRevocationContactEmail', size: "255", additionalValidation: "email" }
        ];
        
        let i;
        for (i = 0; i < fields.length; ++i) {
            
            let size = fields[i].size;
            let name = fields[i].name;
            let additionalValidation = fields[i].additionalValidation;
            
            //$('input[name="fields['+name+']"]').attr('maxlength', size);
            $('input[name="fields['+name+']"]').parent('div').append('<span class="counter-char">0/'+size+'</span>');
            
            $('body').on('input','input[name="fields['+name+']"]', function (){
                
                let length = $(this).val().length;
                if(length > size)
                {
                    $('input[name="fields['+name+']"]').parent('div').find('span.counter-char').addClass("red");
                }
                else
                {
                    $('input[name="fields['+name+']"]').parent('div').find('span.counter-char').removeClass("red");
                }
                $('input[name="fields['+name+']"]').parent('div').find('span.counter-char').html(length+'/'+size);
               
                if(additionalValidation == 'email')
                {
                    if($(this).val() != '')
                    {
                        let reg = /^([A-Za-z0-9_\-\.])+\@([A-Za-z0-9_\-\.])+\.([A-Za-z]{2,4})$/;
                        if (reg.test($(this).val()) == false) 
                        {
                           $('input[name="fields['+name+']"]').parent('div').find('span.counter-char').addClass("red");
                           $('input[name="fields['+name+']"]').parent('div').find('span.counter-char').html('The email address is incorrect '+length+'/'+size);
                        }
                        else
                        {
                            if(length < size)
                            {
                                $('input[name="fields['+name+']"]').parent('div').find('span.counter-char').removeClass("red");
                            }
                            $('input[name="fields['+name+']"]').parent('div').find('span.counter-char').html(length+'/'+size);
                        }
                    }
                }
            });
            
            $('input[name="fields['+name+']"]').trigger('input');
            
        }
        
        $("body").on('click', '#btnOrderContinue', function (){
            
            let checkError = false;
            let elementWithError = "";
            $(".counter-char").each(function(index) {
                if($(this).hasClass("red"))
                {
                    elementWithError = $(this);
                    checkError = true;
                }
            });
            
            if(checkError === true)
            {
                $(elementWithError).prev('input').focus();
                return false;
            }
            
        });
        
    });
    
    $(window).load(function(){
        $additionalScript
    });
</script>
JS;
});

add_hook('ClientAreaHeadOutput', 1, function($params) {

    if(!isset($_SESSION['uid']) || empty($_SESSION['uid']))
    {
        return;
    }

    if($params['filename'] != 'configuressl2' && $params['filename'] != 'clientarea')
    {
        return;
    }

    if($params['filename'] == 'clientarea' && $_GET['a'] != 'changeverification')
    {
        return;
    }

    return <<<JS
<style>
    .counter-char {
        font-size:11px;
        font-weight:300;
        color:#555;
    }
    .counter-char.red {
        color: red;
    }
</style>
<script type="text/javascript">
    $(document).ready(function(){
    
        let fields = [
            { name: 'domain', size: "230", additionalValidation: "san" },
            { name: 'emailaddress', size: "255", additionalValidation: "email" }
        ];
        
        let i;
        for (i = 0; i < fields.length; ++i) {
            
            let size = fields[i].size;
            let name = fields[i].name;
            let additionalValidation = fields[i].additionalValidation;
            
            if(additionalValidation == 'san')
            {
                //$('input[name^="'+name+'"]').attr('maxlength', size);
                $('input[name^="'+name+'"]').parent('td').append('<span class="counter-char">0/'+size+'</span>');
                
                $('body').on('input','input[name^="'+name+'"]', function (){
                
                    let length = $(this).val().length;
                    if(length > size)
                    {
                        $(this).parent('td').find('span.counter-char').addClass("red");
                    }
                    else
                    {
                        $(this).parent('td').find('span.counter-char').removeClass("red");
                    }
                    $(this).parent('td').find('span.counter-char').html(length+'/'+size);
                });
                
                $('input[name^="'+name+'"]').trigger('input');
                
            }
            else
            {
                //$('input[name="'+name+'"]').attr('maxlength', size);
                $('input[name="'+name+'"]').parent('div').append('<span class="counter-char">0/'+size+'</span>');
                
                $('body').on('input','input[name="'+name+'"]', function (){
                
                    let length = $(this).val().length;
                    if(length > size)
                    {
                        $('input[name="'+name+'"]').parent('div').find('span.counter-char').addClass("red");
                    }
                    else
                    {
                        $('input[name="'+name+'"]').parent('div').find('span.counter-char').removeClass("red");
                    }
                    $('input[name="'+name+'"]').parent('div').find('span.counter-char').html(length+'/'+size);
                   
                    if($(this).val() != '')
                    {
                        let reg = /^([A-Za-z0-9_\-\.])+\@([A-Za-z0-9_\-\.])+\.([A-Za-z]{2,4})$/;
                        if (reg.test($(this).val()) == false) 
                        {
                           $('input[name="'+name+'"]').parent('div').find('span.counter-char').addClass("red");
                           $('input[name="'+name+'"]').parent('div').find('span.counter-char').html('The email address is incorrect '+length+'/'+size);
                        }
                        else
                        {
                            if(length < size)
                            {
                                $('input[name="'+name+'"]').parent('div').find('span.counter-char').removeClass("red");
                            }
                            $('input[name="'+name+'"]').parent('div').find('span.counter-char').html(length+'/'+size);
                        }
                    }
                    
                });
                
                $('input[name="'+name+'"]').trigger('input');
            }
        }
    });
</script>
JS;
});