{**********************************************************************
 * Customization Services by ModulesGarden.com
 * Copyright (coffee) ModulesGarden, INBS Group Brand, All Rights Reserved 
 * (${date}, ${time})
 *
 *  CREATED BY MODULESGARDEN       ->        http://modulesgarden.com
 *  CONTACT                        ->       contact@modulesgarden.com
 *
 *
 *
 *
 * This software is furnished under a license and may be used and copied
 * only  in  accordance  with  the  terms  of such  license and with the
 * inclusion of the above copyright notice.  This software  or any other
 * copies thereof may not be provided or otherwise made available to any
 * other person.  No title to and  ownership of the  software is  hereby
 * transferred.
 *
 *
 **********************************************************************}

{**
 * @author Maciej Husak <maciej@modulesgarden.com>
 *}
 
{if $error}
    <div class="alert alert-danger">{$error}</div>
{/if}
 <h3>{$lang.renew}</h3>
<div class="alert alert-warning">{$lang.renew_alert}</div>
 <form action="" method="post">
    <table class="table">
        <tr>
            <td>{$lang.serial_number}</td>
            <td><input type="text" name="fields[serial]" value="{$smarty.post.fields.serial}" /></td>
        </tr>
        <tr>
            <td>{$lang.pem}</td>
            <td><textarea style="width:400px;height:150px;" name="fields[pem]">{$smarty.post.fields.pem}</textarea></td>
        </tr>
        <tr>
            <td>{$lang.csr}</td>
            <td><textarea style="width:400px;height:150px;" name="fields[csr]" placeholder=""></textarea></td>
        </tr>
    </table>
    {if $approvers}
    <div class="row" style="margin-top: 30px;">
    <div class="form-group col-sm-12 col-xs-12">
        <select id="approvermethod" class="form-control method" name="method" style="width: 260px;float: left;margin-right: 15px;margin-top: -5px;">
            <option>FILE</option>
            <option>DNS_TXT</option><option>DNS_CNAME</option><option>DNS_TXT_PREFIX</option><option>DNS_CNAME_PREFIX</option>
            <option>ADMIN</option>
        </select> Approve method
    </div>
    </div>

    <div class="row" style="display: none;">
    <div class="form-group col-sm-12 col-xs-12">
        <input type="email" name="emailaddress" class="form-control" placeholder="Email address" style="width: 260px;float: left;margin-right: 15px;margin-top: -5px;" disabled> This e-mail address will receive verification message*
    </div>
    </div>

    <div class="row" style="display:none">
    <div class="form-group col-sm-12 col-xs-12">
        <select class="emailprefix form-control" name="emailprefix" style="width: 260px;float: left;margin-right: 15px;margin-top: -5px;" disabled>
           <option value="ADMIN">ADMIN</option>
            <option value="ADMINISTRATOR">ADMINISTRATOR</option>
            <option value="HOSTMASTER">HOSTMASTER</option>
            <option value="POSTMASTER">POSTMASTER</option>
            <option value="WEBMASTER">WEBMASTER</option>
        </select> Administrative email type
    </div>
    </div>

    <div class="checkbox">
        <label>
            <input type="checkbox" name="approvenotification" checked value="1"> Send verification messages
        </label>
    </div>
    {/if}

     {if $simplysign}
         <div class="row">
             <div class="form-group col-sm-12 col-xs-12">
                 <label>{$lang.simplysign_account}</label>
                 <input type="email" name="simplysign" class="form-control" placeholder="sample@email.com" style="width: 260px;">
             </div>
         </div>


     {/if}

    <input type="submit" class="btn btn-success" value="{$lang.renew}" />
    <input type="hidden" name="doAction" value="renew" /> 
 </form>
    
{literal}
    <script>
        
        $(document).ready(function(){
            
            
            var checkfileglobal = false;
            $("#approvermethod option").each(function( index ) {
                if($(this).text() == 'FILE')
                {
                    checkfileglobal = true
                }
            });
            

             $("body").on('input', 'textarea[name="fields[csr]"]', function(){

                    $.ajax({
                        method      : "get", 
                        dataType    : "json",
                        contentType : "application/json",
                        data        : {
                            "ajax" : "1",
                            "action" : "getDetailsCSR",
                            "csrform": $(this).val()
                        },
                        success : function(data) {
                            var domaincsr = '';
                            if(data.CN)
                            {
                                domaincsr = data.CN;
                            }
                            
                            var iswildcard = false;
                            if(domaincsr.indexOf('*.') !== -1 )
                            {
                                iswildcard = true;
                            }
                   
                            if(iswildcard === true)
                            {
                                $("#approvermethod option").each(function( index ) {
                                    if($(this).text() == 'FILE')
                                    {
                                        $(this).remove();
                                    }
                                });
                            }
                            else
                            {
                                var checkfile = false;

                                $("#approvermethod option").each(function( index ) {
                                    if($(this).text() == 'FILE')
                                    {
                                        checkfile = true;
                                    }
                                });

                                if(checkfile === false && checkfileglobal === true)
                                {
                                    $("#approvermethod").append('<option>FILE</option>');
                                }
                            }

                        },
                        beforeSend: function() {

                        },
                    });

             });

            $("body").on('input', 'input[name="fields[serial]"]', function(){
                checkPemAndSerial();
            });

            $("body").on('input', 'textarea[name="fields[pem]"]', function(){
                checkPemAndSerial();
            });


            function checkPemAndSerial()
            {
                var serial = $('input[name="fields[serial]"]').val();
                var pem = $('textarea[name="fields[pem]"]').val();

                if(serial != '')
                {
                    $('textarea[name="fields[pem]"]').prop("readonly", true);
                    $('textarea[name="fields[pem]"]').val("");
                }
                else
                {
                    $('textarea[name="fields[pem]"]').prop("readonly", false);
                }

                if(pem != '')
                {
                    $('input[name="fields[serial]"]').prop("readonly", true);
                    $('input[name="fields[serial]"]').val("");
                }
                else
                {
                    $('input[name="fields[serial]"]').prop("readonly", false);
                }

            }
        
        
            var approvermethod = jQuery('#approvermethod').val();

            if(approvermethod == 'ADMIN')
            {
                jQuery('select[name="emailprefix"]').parent('.form-group').parent('.row').show();
                jQuery('input[name="emailaddress"]').parent('.form-group').parent('.row').hide();
                jQuery('select[name="emailprefix"]').prop("disabled", false);
                jQuery('input[name="emailaddress"]').prop("true", false);
            }
            else
            {
                jQuery('input[name="emailaddress"]').prop("disabled", false);
                jQuery('select[name="emailprefix"]').prop("true", false);
                jQuery('select[name="emailprefix"]').parent('.form-group').parent('.row').hide();
                jQuery('input[name="emailaddress"]').parent('.form-group').parent('.row').show();
            }

            jQuery("body").on("change", "#approvermethod", function() {

                var approvermethod = jQuery(this).val();

                if(approvermethod == 'ADMIN')
                {
                    jQuery('select[name="emailprefix"]').parent('.form-group').parent('.row').show();
                    jQuery('input[name="emailaddress"]').parent('.form-group').parent('.row').hide();
                    jQuery('select[name="emailprefix"]').prop("disabled", false);
                    jQuery('input[name="emailaddress"]').prop("true", false);
                }
                else
                {
                    jQuery('input[name="emailaddress"]').prop("disabled", false);
                    jQuery('select[name="emailprefix"]').prop("true", false);
                    jQuery('select[name="emailprefix"]').parent('.form-group').parent('.row').hide();
                    jQuery('input[name="emailaddress"]').parent('.form-group').parent('.row').show();
                }

            });
        
        });
        
    </script>
{/literal}